# A [Julia](http://julialang.org) Linear Operator Package

| **Documentation** | **Linux/macOS/Windows** | **Coverage** | **DOI** |
|:-----------------:|:-------------------------------:|:------------:|:-------:|
| [![docs-stable][docs-stable-img]][docs-stable-url] [![docs-dev][docs-dev-img]][docs-dev-url] | [![build-gh][build-gh-img]][build-gh-url] | [![codecov][codecov-img]][codecov-url] | [![doi][doi-img]][doi-url] |

[docs-stable-img]: https://img.shields.io/badge/docs-stable-blue.svg
[docs-stable-url]: https://JuliaSmoothOptimizers.github.io/LinearOperators.jl/stable
[docs-dev-img]: https://img.shields.io/badge/docs-dev-purple.svg
[docs-dev-url]: https://JuliaSmoothOptimizers.github.io/LinearOperators.jl/dev
[build-gh-img]: https://github.com/JuliaSmoothOptimizers/LinearOperators.jl/actions/workflows/CI.yml/badge.svg
[build-gh-url]: https://github.com/JuliaSmoothOptimizers/LinearOperators.jl/actions/workflows/CI.yml
[codecov-img]: https://codecov.io/gh/JuliaSmoothOptimizers/LinearOperators.jl/branch/main/graph/badge.svg
[codecov-url]: https://app.codecov.io/gh/JuliaSmoothOptimizers/LinearOperators.jl
[doi-img]: https://zenodo.org/badge/20136006.svg
[doi-url]: https://zenodo.org/badge/latestdoi/20136006

## How to Cite

If you use LinearOperators.jl in your work, please cite using the format given in [`CITATION.cff`](https://github.com/JuliaSmoothOptimizers/LinearOperators.jl/blob/main/CITATION.cff).

## Philosophy

Operators behave like matrices (with some exceptions - see below) but are defined by their effect when applied to a vector. They can be transposed, conjugated, or combined with other operators cheaply. The costly operation is deferred until multiplied with a vector.

## Compatibility

[Julia 1.6](https://julialang.org/downloads/#long_term_support_release) and up.

## How to Install

````JULIA
pkg> add LinearOperators
pkg> test LinearOperators
````

## How to use

Check the
[tutorial](https://JuliaSmoothOptimizers.github.io/LinearOperators.jl/latest/tutorial).

## Operators Available

Operator               | Description
-----------------------|------------
`LinearOperator`       | Base class. Useful to define operators from functions
`TimedLinearOperator`  | Linear operator instrumented with timers from [`TimerOutputs`](https://github.com/KristofferC/TimerOutputs.jl)
`BlockDiagonalOperator`| Block-diagonal linear operator
`opEye`                | Identity operator
`opOnes`               | All ones operator
`opZeros`              | All zeros operator
`opDiagonal`           | Square (equivalent to `diagm()`) or rectangular diagonal operator
`opInverse`            | Equivalent to `\`
`opCholesky`           | More efficient than `opInverse` for symmetric positive definite matrices
`opHouseholder`        | Apply a Householder transformation `I-2hh'`
`opHermitian`          | Represent a symmetric/hermitian operator based on the diagonal and strict lower triangle
`opRestriction`        | Represent a selection of "rows" when composed on the left with an existing operator
`opExtension`          | Represent a selection of "columns" when composed on the right with an existing operator
`LBFGSOperator`        | Limited-memory BFGS approximation in operator form (damped or not)
`InverseLBFGSOperator` | Inverse of a limited-memory BFGS approximation in operator form (damped or not)
`LSR1Operator`         | Limited-memory SR1 approximation in operator form

## Utility Functions

Function           | Description
-------------------|------------
`check_ctranspose` | Cheap check that `A'` is correctly implemented
`check_hermitian`  | Cheap check that `A = A'`
`check_positive_definite` | Cheap check that an operator is positive (semi-)definite
`diag`             | Extract the diagonal of an operator
`Matrix`           | Convert an abstract operator to a dense array
`hermitian`        | Determine whether the operator is Hermitian
`push!`            | For L-BFGS or L-SR1 operators, push a new pair {s,y}
`reset!`           | For L-BFGS or L-SR1 operators, reset the data
`show`             | Display basic information about an operator
`size`             | Return the size of a linear operator
`symmetric`        | Determine whether the operator is symmetric
`normest`          | Estimate the 2-norm
`solve_shifted_system!`          | Solves linear system $(B + \sigma I) x = b$, where $B$ is a forward L-BFGS operator and $\sigma \geq 0$.


## Other Operations on Operators

Operators can be transposed (`transpose(A)`), conjugated (`conj(A)`) and conjugate-transposed (`A'`).
Operators can be sliced (`A[:,3]`, `A[2:4,1:5]`, `A[1,1]`), but unlike matrices, slices always return
operators (see differences below).

## Differences

Unlike matrices, an operator never reduces to a vector or a number.

````JULIA
A = rand(5,5)
opA = LinearOperator(A)
A[:,1] * 3 # Vector
opA[:,1] * 3 # LinearOperator
A[:,1] * [3] # ERROR
opA[:,1] * [3] # Vector
````

This is also true for `A[i,J]`, which returns vectors on 0.5, and for the scalar
`A[i,j]`.
Similarly, `opA[1,1]` is an operator of size (1,1):"
````JULIA
opA[1,1] # LinearOperator
A[1,1] # Number
````

In the same spirit, the operator `full` always returns a matrix.
````JULIA
full(opA[:,1]) # nx1 matrix
````


## Other Operators

* [LimitedLDLFactorizations](https://github.com/JuliaSmoothOptimizers/LimitedLDLFactorizations.jl) features a limited-memory
  LDL<sup>T</sup> factorization operator that may be used as preconditioner
  in iterative methods
* [MUMPS.jl](https://github.com/JuliaSmoothOptimizers/MUMPS.jl) features a full
  distributed-memory factorization operator that may be used to represent the
  preconditioner in, e.g., constraint-preconditioned Krylov methods.

## Bug reports and discussions

If you think you found a bug, feel free to open an [issue](https://github.com/JuliaSmoothOptimizers/LinearOperators.jl/issues).
Focused suggestions and requests can also be opened as issues. Before opening a pull request, start an issue or a discussion on the topic, please.

If you want to ask a question not suited for a bug report, feel free to start a discussion [here](https://github.com/JuliaSmoothOptimizers/Organization/discussions). This forum is for general discussion about this repository and the [JuliaSmoothOptimizers](https://github.com/JuliaSmoothOptimizers) organization, so questions about any of our packages are welcome.

struct Flip end

function (::Flip)(res, x, α, β::T) where {T}
  if β == zero(T)
    res .= (-α) .* x
  else
    res .= (-α) .* x .+ β .* res
  end
end

function test_callable()
  @testset ExtendedTestSet "Test callable" begin
    Mv = ones(2)
    op = LinearOperator(Float64, 2, 2, true, true, Flip())
    @test op * ones(2) == -ones(2)
    @test op' * ones(2) == -ones(2)
    @test transpose(op) * ones(2) == -ones(2)
    v = ones(2)
    allocs = @allocated mul!(Mv, op, v)
    @test allocs == 0
    @test Mv == -ones(2)
  end
end

test_callable()

module LinearOperatorsLDLFactorizationsExt

using FastClosures, LDLFactorizations, LinearAlgebra, LinearOperators, SparseArrays

function LinearOperators.opLDL(M::AbstractMatrix; check::Bool = false)
  (m, n) = size(M)
  m == n || throw(LinearOperatorException("shape mismatch"))
  if check
    check_hermitian(M) || throw(LinearOperatorException("matrix is not Hermitian"))
  end
  LDL = ldlt(M)
  prod! = @closure (res, v, α, β) -> LinearOperators.mulFact!(res, LDL, v, α, β)
  tprod! = @closure (res, u, α, β) -> LinearOperators.tmulFact!(res, LDL, u, α, β)  # M.' = conj(M)
  ctprod! = @closure (res, w, α, β) -> LinearOperators.mulFact!(res, LDL, w, α, β)
  S = eltype(LDL)
  return LinearOperator{S, Vector{S}}(m, m, isreal(M), true, prod!, tprod!, ctprod!)
  #TODO: use iterative refinement.
end

function LinearOperators.opLDL(
  M::Symmetric{T, SparseMatrixCSC{T, Int}};
  check::Bool = false,
) where {T <: Real}
  (m, n) = size(M)
  m == n || throw(LinearOperatorException("shape mismatch"))
  if check
    check_hermitian(M) || throw(LinearOperatorException("matrix is not Hermitian"))
  end
  LDL = ldl(M)
  prod! = @closure (res, v) -> ldiv!(res, LDL, v)
  tprod! = @closure (res, u) -> ldiv!(res, LDL, u)  # M.' = conj(M)
  ctprod! = @closure (res, w) -> ldiv!(res, LDL, w)
  S = eltype(LDL)
  return LinearOperator{S, Vector{S}}(m, m, isreal(M), true, prod!, tprod!, ctprod!)
end

end # module

function test_linop()
  @testset "linop" begin
    (nrow, ncol) = (10, 6)
    ϵ = eps(Float64)
    rtol = sqrt(ϵ)
    A1 = rand(nrow, ncol)
    opA1 = LinearOperator(A1)
    v = rand(ncol)
    res = zeros(nrow)

    # test mul3
    mul!(res, opA1, v) # build 
    opA1 = LinearOperator(A1)
    allocs = @allocated mul!(res, opA1, v)
    @test allocs == 0
    res_true = zeros(nrow)
    mul!(res_true, A1, v)
    @test norm(res - res_true) ≤ sqrt(ϵ)

    # test mul5 
    α, β = 2.0, -3.0
    res = rand(nrow)
    res_true .= res
    opA1 = LinearOperator(A1)
    mul!(res, opA1, v, α, β)
    mul!(res, A1, v, α, β)
    res .= res_true
    allocs2 = @allocated mul!(res, opA1, v, α, β)
    allocs = @allocated mul!(res_true, A1, v, α, β)
    @test allocs2 == 0
    @test allocs == 0
    @test norm(res - res_true) ≤ sqrt(ϵ)

    # test prod 
    opA1 = LinearOperator(A1)
    res = opA1 * v
    res_true = A1 * v
    @test norm(res - res_true) ≤ sqrt(ϵ)

    # test +op 
    opA2 = +opA1
    α, β = 2.0, -3.0
    res = rand(nrow)
    res_true .= res
    mul!(res, opA2, v, α, β)
    mul!(res_true, A1, v, α, β)
    @test norm(res - res_true) ≤ sqrt(ϵ)

    # test -op
    opA2 = -opA1
    α, β = 2.0, -3.0
    res = rand(nrow)
    res_true .= res
    opA1 = LinearOperator(A1)
    mul!(res, opA2, v, α, β)
    mul!(res_true, -A1, v, α, β)
    @test norm(res - res_true) ≤ sqrt(ϵ)
    mul!(res, opA2, v, α, β)

    # Matrix * LinearOperator
    (nrow2, ncol2) = (ncol, 7)
    v2 = rand(ncol2)
    A2 = rand(nrow2, ncol2)
    opA3 = opA1 * A2
    Mv = rand(nrow)
    res_true = copy(Mv)
    mul!(Mv, opA3, v2, α, β)
    mul!(res_true, A1 * A2, v2, α, β)
    @test norm(Mv - res_true) ≤ sqrt(ϵ)
  end
end

test_linop()

export LBFGSOperator, InverseLBFGSOperator, diag, diag!

"A data type to hold information relative to LBFGS operators."
mutable struct LBFGSData{T, I <: Integer}
  const mem::I
  const scaling::Bool
  scaling_factor::T
  const damped::Bool
  σ₂::T
  σ₃::T
  opnorm_upper_bound::T # Upper bound for the operator norm ‖Bₖ‖₂ ≤ ‖B₀‖₂ + ∑ᵢ ‖bᵢ‖₂²
  const s::Vector{Vector{T}}
  const y::Vector{Vector{T}}
  const ys::Vector{T}
  const α::Vector{T}
  const a::Vector{Vector{T}}
  const b::Vector{Vector{T}}
  const norm_b::Vector{T}
  insert::I
  const Ax::Vector{T}
  const shifted_p::Matrix{T} # Temporary matrix used in the computation solve_shifted_system!
  const shifted_v::Vector{T}
  const shifted_u::Vector{T}
end

function LBFGSData(
  T::Type,
  n::I;
  mem::I = 5,
  scaling::Bool = true,
  damped::Bool = false,
  inverse::Bool = true,
  σ₂::Float64 = 0.99,
  σ₃::Float64 = 10.0,
) where {I <: Integer}
  LBFGSData{T, I}(
    max(mem, 1),
    scaling,
    convert(T, 1),
    damped,
    convert(T, σ₂),
    convert(T, σ₃),
    convert(T, 1),
    [zeros(T, n) for _ = 1:mem],
    [zeros(T, n) for _ = 1:mem],
    zeros(T, mem),
    inverse ? zeros(T, mem) : zeros(T, 0),
    inverse ? Vector{T}(undef, 0) : [zeros(T, n) for _ = 1:mem],
    inverse ? Vector{T}(undef, 0) : [zeros(T, n) for _ = 1:mem],
    inverse ? Vector{T}(undef, 0) : zeros(T, mem),
    1,
    Vector{T}(undef, n),
    Array{T}(undef, (n, 2 * mem)),
    Vector{T}(undef, 2 * mem),
    Vector{T}(undef, n),
  )
end

LBFGSData(n::I; kwargs...) where {I <: Integer} = LBFGSData(Float64, n; kwargs...)

"A type for limited-memory BFGS approximations."
mutable struct LBFGSOperator{T, I <: Integer, F, Ft, Fct} <: AbstractQuasiNewtonOperator{T}
  const nrow::I
  const ncol::I
  const symmetric::Bool
  const hermitian::Bool
  const prod!::F    # apply the operator to a vector
  const tprod!::Ft    # apply the transpose operator to a vector
  const ctprod!::Fct   # apply the transpose conjugate operator to a vector
  const inverse::Bool
  const data::LBFGSData{T, I}
  nprod::I
  ntprod::I
  nctprod::I
end

LBFGSOperator{T}(
  nrow::I,
  ncol::I,
  symmetric::Bool,
  hermitian::Bool,
  prod!::F,
  tprod!::Ft,
  ctprod!::Fct,
  inverse::Bool,
  data::LBFGSData{T, I},
) where {T, I <: Integer, F, Ft, Fct} = LBFGSOperator{T, I, F, Ft, Fct}(
  nrow,
  ncol,
  symmetric,
  hermitian,
  prod!,
  tprod!,
  ctprod!,
  inverse,
  data,
  0,
  0,
  0,
)

has_args5(op::LBFGSOperator) = true
isallocated5(op::LBFGSOperator) = true
storage_type(op::LBFGSOperator{T}) where {T} = Vector{T}

"""
    InverseLBFGSOperator(T, n, [mem=5; scaling=true])
    InverseLBFGSOperator(n, [mem=5; scaling=true])
Construct a limited-memory BFGS approximation in inverse form. If the type `T`
is omitted, then `Float64` is used.
"""
function InverseLBFGSOperator(T::Type, n::I; kwargs...) where {I <: Integer}
  kwargs = Dict(kwargs)
  delete!(kwargs, :inverse)
  lbfgs_data = LBFGSData(T, n; inverse = true, kwargs...)

  function lbfgs_multiply(
    res::AbstractVector,
    data::LBFGSData,
    x::AbstractArray,
    αm,
    βm::T2,
  ) where {T2}
    # Multiply operator with a vector.
    # See, e.g., Nocedal & Wright, 2nd ed., Procedure 7.4, p. 178.

    q = data.Ax # tmp vector
    q .= x

    @inbounds for i = 1:(data.mem)
      k = mod(data.insert - i - 1, data.mem) + 1
      if data.ys[k] != 0
        αk = dot(data.s[k], q) / data.ys[k]
        data.α[k] = αk
        q .-= αk .* data.y[k]
      end
    end

    data.scaling && (q .*= data.scaling_factor)

    @inbounds for i = 1:(data.mem)
      k = mod(data.insert + i - 2, data.mem) + 1
      if data.ys[k] != 0
        αk = data.α[k]
        β = αk - dot(data.y[k], q) / data.ys[k]
        q .+= β .* data.s[k]
      end
    end
    if βm == zero(T2)
      res .= αm .* q
    else
      res .= αm .* q .+ βm .* res
    end
  end

  prod! = @closure (res, x, α, β) -> lbfgs_multiply(res, lbfgs_data, x, α, β)
  return LBFGSOperator{T}(n, n, true, true, prod!, prod!, prod!, true, lbfgs_data)
end

InverseLBFGSOperator(n::Integer; kwargs...) = InverseLBFGSOperator(Float64, n; kwargs...)

"""
    LBFGSOperator(T, n; [mem=5, scaling=true])
    LBFGSOperator(n; [mem=5, scaling=true])
Construct a limited-memory BFGS approximation in forward form. If the type `T`
is omitted, then `Float64` is used.
"""
function LBFGSOperator(T::Type, n::I; kwargs...) where {I <: Integer}
  kwargs = Dict(kwargs)
  delete!(kwargs, :inverse)
  lbfgs_data = LBFGSData(T, n; inverse = false, kwargs...)

  function lbfgs_multiply(
    res::AbstractVector,
    data::LBFGSData,
    x::AbstractArray,
    α,
    β::T2,
  ) where {T2}
    # Multiply operator with a vector.
    # See, e.g., Nocedal & Wright, 2nd ed., Procedure 7.6, p. 184.

    q = data.Ax
    q .= x

    data.scaling && (q ./= data.scaling_factor)

    # B = B₀ + Σᵢ (bᵢbᵢ' - aᵢaᵢ').
    @inbounds for i = 1:(data.mem)
      k = mod(data.insert + i - 2, data.mem) + 1
      if data.ys[k] != 0
        ax = dot(data.a[k], x)
        bx = dot(data.b[k], x)
        q .+= bx .* data.b[k] .- ax .* data.a[k]
      end
    end
    if β == zero(T2)
      res .= α .* q
    else
      res .= α .* q .+ β .* res
    end
  end

  prod! = @closure (res, x, α, β) -> lbfgs_multiply(res, lbfgs_data, x, α, β)
  return LBFGSOperator{T}(n, n, true, true, prod!, prod!, prod!, false, lbfgs_data)
end

LBFGSOperator(n::I; kwargs...) where {I <: Integer} = LBFGSOperator(Float64, n; kwargs...)

function push_common!(
  op::LBFGSOperator{T, I, F1, F2, F3},
  s::Vector{T},
  y::Vector{T},
  ys::T,
) where {T, I, F1, F2, F3}
  # op.counters.updates += 1
  data = op.data
  insert = data.insert

  data.s[insert] .= s
  data.y[insert] .= y
  data.ys[insert] = ys
  if op.data.scaling
    !iszero(data.scaling_factor) && (data.opnorm_upper_bound -= 1 / op.data.scaling_factor)
    op.data.scaling_factor = ys / dot(y, y)
    !iszero(data.scaling_factor) && (data.opnorm_upper_bound += 1 / op.data.scaling_factor)
  end

  # Update arrays a and b used in forward products.
  if !op.inverse
    data.opnorm_upper_bound -= data.norm_b[insert]^2
    data.b[insert] .= y ./ sqrt(ys)
    data.norm_b[insert] = norm(data.b[insert])
    data.opnorm_upper_bound += data.norm_b[insert]^2

    @inbounds for i = 1:(data.mem)
      k = mod(insert + i - 1, data.mem) + 1
      if data.ys[k] != 0
        data.a[k] .= data.s[k] ./ data.scaling_factor  # B₀ = I / γ.

        @inbounds for j = 1:(i - 1)
          l = mod(insert + j - 1, data.mem) + 1
          if data.ys[l] != 0
            data.a[k] .+= dot(data.b[l], data.s[k]) .* data.b[l]
            data.a[k] .-= dot(data.a[l], data.s[k]) .* data.a[l]
          end
        end
        data.a[k] ./= sqrt(dot(data.s[k], data.a[k]))
      end
    end
  end

  op.data.insert = mod(insert, data.mem) + 1
  return op
end

"""
    push!(op, s, y)
    push!(op, s, y, Bs)
    push!(op, s, y, α, g)
    push!(op, s, y, α, g, Bs)

Push a new {s,y} pair into a L-BFGS operator.
The second calling sequence is used for forward updating damping, using the preallocated vector `Bs`.
If the operator is damped, the first call will create `Bs` and call the second call.
The third and fourth calling sequences are used in inverse LBFGS updating in conjunction with damping,
where α is the most recent steplength and g the gradient used when solving `d=-Hg`.
"""
function push!(
  op::LBFGSOperator{T, I, F1, F2, F3},
  s::Vector{T},
  y::Vector{T},
) where {T, I, F1, F2, F3}
  if op.data.damped
    return push!(op, s, y, similar(s))
  end
  ys = dot(y, s)
  σ₂ = op.data.σ₂
  σ₃ = op.data.σ₃

  if ys <= eps(eltype(op))
    # op.counters.rejects +=1
    return op
  end

  push_common!(op, s, y, ys)
end

function push!(
  op::LBFGSOperator{T, I, F1, F2, F3},
  s::Vector{T},
  y::Vector{T},
  Bs::Vector{T},
) where {T, I, F1, F2, F3}
  if !op.data.damped
    error("This push! should be used for damped operators")
  elseif op.inverse
    error("This function be used for forward operators. Use push!(op, s, y, α, g, Bs) instead.")
  end
  ys = dot(y, s)
  σ₂ = op.data.σ₂
  σ₃ = op.data.σ₃

  # Powell's damped update strategy
  mul!(Bs, op, s, one(T), zero(T))
  sBs = dot(s, Bs)
  damp = false
  if ys < (1 - σ₂) * sBs
    θ = σ₂ * sBs / (sBs - ys)
    damp = true
  elseif ys > (1 + σ₃) * sBs
    θ = σ₃ * sBs / (ys - sBs)
    damp = true
  end
  if damp
    y = θ .* y .+ (1 - θ) .* Bs  # damped y
    ys = θ * ys + (1 - θ) * sBs
  end

  push_common!(op, s, y, ys)
end

function push!(
  op::LBFGSOperator{T, I, F1, F2, F3},
  s::Vector{T},
  y::Vector{T},
  α::T,
  g::Vector{T},
  Bs::Vector{T},
) where {T, I, F1, F2, F3}
  if !op.data.damped
    error("This push! should be used for damped operators")
  elseif !op.inverse
    error("This function be used for inverse operators. Use push!(op, s, y, Bs) instead.")
  end
  ys = dot(y, s)
  σ₂ = op.data.σ₂
  σ₃ = op.data.σ₃

  # Powell's damped update strategy
  Bs .= -α .* g
  sBs = dot(s, Bs)
  damp = false
  if ys < (1 - σ₂) * sBs
    θ = σ₂ * sBs / (sBs - ys)
    damp = true
  elseif ys > (1 + σ₃) * sBs
    θ = σ₃ * sBs / (ys - sBs)
    damp = true
  end
  if damp
    y .= θ .* y .+ (1 - θ) .* Bs  # damped y
    ys = θ * ys + (1 - θ) * sBs
  end

  push_common!(op, s, y, ys)
end

function push!(
  op::LBFGSOperator{T, I, F1, F2, F3},
  s::Vector{T},
  y::Vector{T},
  α::T,
  g::Vector{T},
) where {T, I, F1, F2, F3}
  push!(op, s, y, α, g, similar(g))
end

"""
    diag(op)
    diag!(op, d)
Extract the diagonal of a L-BFGS operator in forward mode.
"""
function diag(op::LBFGSOperator{T}) where {T}
  d = Vector{T}(undef, op.nrow)
  diag!(op, d)
end

function diag!(op::LBFGSOperator{T}, d) where {T}
  op.inverse && throw(
    LinearOperatorException("only the diagonal of a forward L-BFGS approximation is available"),
  )
  data = op.data

  fill!(d, 1)
  data.scaling && (d ./= data.scaling_factor)

  @inbounds for i = 1:(data.mem)
    k = mod(data.insert + i - 2, data.mem) + 1
    if data.ys[k] != 0
      d .+= data.b[k] .^ 2 .- data.a[k] .^ 2
    end
  end
  return d
end

"""
    reset!(data)
Resets the given LBFGS data.
"""
function reset!(data::LBFGSData{T, I}, inverse::Bool) where {T, I <: Integer}
  for i = 1:(data.mem)
    fill!(data.s[i], 0)
    fill!(data.y[i], 0)
    if !inverse
      fill!(data.a[i], 0)
      fill!(data.b[i], 0)
    end
  end
  fill!(data.ys, 0)
  fill!(data.α, 0)
  data.scaling_factor = T(1)
  data.insert = 1
  return data
end

"""
    reset!(op)
Resets the LBFGS data of the given operator.
"""
function reset!(op::LBFGSOperator)
  reset!(op.data, op.inverse)
  op.nprod = 0
  op.ntprod = 0
  op.nctprod = 0
  return op
end

"""
    @wrappedallocs(expr)

Given an expression, this macro wraps that expression inside a new function
which will evaluate that expression and measure the amount of memory allocated
by the expression. Wrapping the expression in a new function allows for more
accurate memory allocation detection when using global variables (e.g. when
at the REPL).

This code is based on that of https://github.com/JuliaAlgebra/TypedPolynomials.jl/blob/master/test/runtests.jl

For example, `@wrappedallocs(x + y)` produces:

```julia
function g(x1, x2)
    @allocated x1 + x2
end
g(x, y)
```

You can use this macro in a unit test to verify that a function does not
allocate:

```
@test @wrappedallocs(x + y) == 0
```
"""
macro wrappedallocs(expr)
  argnames = [gensym() for a in expr.args]
  quote
    function g($(argnames...))
      $(Expr(expr.head, argnames...))
      @allocated $(Expr(expr.head, argnames...))
    end
    $(Expr(:call, :g, [esc(a) for a in expr.args]...))
  end
end

# Points
x0 = [-1.0, 1.0, -1.0]
x1 = x0 + [1.0, 0.0, 1.0]

# Test functions
# f(x) = x[1]^2 + x[2]^2 + x[3]^2
∇f(x) = 2 * [x[1], x[2], x[3]]

# g(x) = exp(x[1]) + x[2] + cos(x[3])
∇g(x) = [exp(x[1]), 1, -sin(x[3])]

# h(x) = x[1]^2 * x[2] * x[3]^3
∇h(x) = [2 * x[1] * x[2] * x[3]^3, x[1]^2 * x[3]^3, 3 * x[1]^2 * x[2] * x[3]^2]

@testset "Weak secant equation for Andrei update" begin
  for grad_fun in (:∇f, :∇g, ∇h)
    grad = eval(grad_fun)
    s = x1 - x0
    y = grad(x1) - grad(x0)
    B = DiagonalAndrei([1.0, -1.0, 1.0])
    push!(B, s, y)
    @test abs(dot(s, B * s) - dot(s, y)) <= 1e-10
  end
end

@testset "Weak secant equation for PSB update" begin
  for grad_fun in (:∇f, :∇g, ∇h)
    grad = eval(grad_fun)
    s = x1 - x0
    y = grad(x1) - grad(x0)
    B = DiagonalPSB([1.0, -1.0, 1.0])
    push!(B, s, y)
    @test abs(dot(s, B * s) - dot(s, y)) <= 1e-10
  end
end

@testset "Hard coded test" begin
  Bref = Dict{Symbol, Dict{Any, Any}}()
  Bref[:∇f] = Dict{Any, Any}()
  Bref[:∇g] = Dict{Any, Any}()
  Bref[:∇h] = Dict{Any, Any}()
  Bref[:∇f][DiagonalPSB] = [2, -1, 2]
  Bref[:∇f][DiagonalAndrei] = [2, -2, 2]
  Bref[:∇g][DiagonalPSB] = [1 + (sin(-1) - exp(-1) - 1) / 2, -1, 1 + (sin(-1) - exp(-1) - 1) / 2]
  Bref[:∇g][DiagonalAndrei] = [(1 + sin(-1) - exp(-1)) / 2, -2, (1 + sin(-1) - exp(-1)) / 2]
  Bref[:∇h][DiagonalPSB] = [-5 / 2, -1, -5 / 2]
  Bref[:∇h][DiagonalAndrei] = [-5 / 2, -2, -5 / 2]

  Bref_spg = Dict{Any, Any}()
  Bref_spg[:∇f] = 2
  Bref_spg[:∇g] = (1 - exp(-1) + sin(-1)) / 2
  Bref_spg[:∇h] = -5 / 2

  for grad_fun in (:∇f, :∇g, :∇h)
    grad = eval(grad_fun)
    s = x1 - x0
    y = grad(x1) - grad(x0)
    for DQN ∈ (DiagonalPSB, DiagonalAndrei)
      B = DQN([1.0, -1.0, 1.0])
      push!(B, s, y)
      @test norm(B.d - Bref[grad_fun][DQN]) <= 1e-10
    end

    B = SpectralGradient(1.0, 3)
    push!(B, s, y)
    @test abs(B.d[1] - Bref_spg[grad_fun]) <= 1e-10
  end
end

@testset "Allocations test" begin
  d = rand(5)
  A = DiagonalAndrei(d)
  v = rand(5)
  u = similar(v)
  mul!(u, A, v)
  @test (@allocated mul!(u, A, v)) == 0
  @test (@wrappedallocs push!(A, u, v)) == 0
  B = DiagonalPSB(d)
  mul!(u, B, v)
  @test (@allocated mul!(u, B, v)) == 0
  @test (@wrappedallocs push!(B, u, v)) == 0
  C = SpectralGradient(rand(), 5)
  mul!(u, C, v)
  @test (@allocated mul!(u, C, v)) == 0
  @test (@wrappedallocs push!(C, u, v)) == 0
  D = DiagonalBFGS(d)
  mul!(u, D, v)
  @test (@allocated mul!(u, D, v)) == 0
  @test (@wrappedallocs push!(D, u, v)) == 0
end

@testset "reset" begin
  B = DiagonalAndrei([1.0, -1.0, 1.0])
  s = x1 - x0
  y = ∇f(x1) - ∇f(x0)
  push!(B, s, y)
  reset!(B)
  @test B * x0 == x0

  B = SpectralGradient(2.5, 3)
  s = x1 - x0
  y = ∇f(x1) - ∇f(x0)
  push!(B, s, y)
  reset!(B)
  @test B * x0 == x0
end

module LinearOperatorsAMDGPUExt

using LinearOperators
isdefined(Base, :get_extension) ? (using AMDGPU) : (using ..AMDGPU)

LinearOperators.storage_type(::ROCArray{T, 2, B}) where {T, B} = ROCArray{T, 1, B}

end # module

export check_ctranspose,
  check_hermitian, check_positive_definite, normest, solve_shifted_system!, ldiv!, estimate_opnorm
import LinearAlgebra.ldiv!

"""
  normest(S) estimates the matrix 2-norm of S.
  This function is an adaptation of Matlab's built-in NORMEST.
  This method allocates.

  -----------------------------------------
  Inputs:
    S --- Matrix or LinearOperator type, 
    tol ---  relative error tol, default(or -1) Machine eps
    maxiter --- maximum iteration, default 100
    
  Returns:
    e --- the estimated norm
    cnt --- the number of iterations used
  """
function normest(S, tol = -1, maxiter = 100)
  (m, n) = size(S)
  cnt = 0
  if tol == -1
    tol = Float64(eps(eltype(S)))
  end
  # Compute an "estimate" of the ab-val column sums.
  v = ones(eltype(S), m)
  v[randn(m) .< 0] .= -1
  x = zeros(eltype(S), n)
  mul!(x, S', v)
  e = norm(x)

  if e == 0
    return e, cnt
  end

  x ./= e
  e_0 = zero(e)
  Sx = zeros(eltype(S), m)

  while abs(e - e_0) > tol * e
    e_0 = e
    mul!(Sx, S, x)
    if count(x -> x != 0, Sx) == 0
      Sx .= randn(eltype(Sx), size(Sx))
    end
    mul!(x, S', Sx)
    normx = norm(x)
    e = normx / norm(Sx)
    x ./= normx
    cnt = cnt + 1
    if cnt > maxiter
      @warn("normest did not converge ", maxiter, tol,)
      break
    end
  end

  return e, cnt
end

"""
    check_ctranspose(op)

Cheap check that the operator and its conjugate transposed are related.
"""
function check_ctranspose(op::AbstractLinearOperator{T}) where {T <: Union{AbstractFloat, Complex}}
  (m, n) = size(op)
  x = rand(n)
  y = rand(m)
  yAx = dot(y, op * x)
  xAty = dot(x, op' * y)
  ε = eps(real(eltype(op)))
  return abs(yAx - conj(xAty)) < (abs(yAx) + ε) * ε^(1 / 3)
end

function check_ctranspose(op::AbstractLinearOperator{T}) where {T <: Integer}
  (m, n) = size(op)
  x = convert(Vector{T}, (floor.(10 * rand(n)))) .- 5
  y = convert(Vector{T}, (floor.(10 * rand(m)))) .- 5
  yAx = dot(y, op * x)
  xAty = dot(x, op' * y)
  return yAx == xAty
end

check_ctranspose(M::AbstractMatrix) = check_ctranspose(LinearOperator(M))

"""
    check_hermitian(op)

Cheap check that the operator is Hermitian.
"""
function check_hermitian(op::AbstractLinearOperator{T}) where {T <: Union{AbstractFloat, Complex}}
  m, n = size(op)
  m == n || throw(LinearOperatorException("shape mismatch"))
  v = rand(n)
  w = copy(op * v)  # copy necessary to guard against in-place operators
  s = dot(w, w)  # = (Av)'(Av) = v' A' A v.
  y = op * w
  t = dot(v, y)  # = v' A A v.
  ε = eps(real(eltype(op)))
  return abs(s - t) < (abs(s) + ε) * ε^(1 / 3)
end

function check_hermitian(op::AbstractLinearOperator{T}) where {T <: Integer}
  m, n = size(op)
  m == n || throw(LinearOperatorException("shape mismatch"))
  v = convert(Vector{T}, (floor.(10 * rand(n)))) .- 5
  w = copy(op * v)
  s = dot(w, w)  # = (Av)'(Av) = v' A' A v.
  y = op * w
  t = dot(v, y)  # = v' A A v.
  return s == t
end

check_hermitian(M::AbstractMatrix) = check_hermitian(LinearOperator(M))

"""
    check_positive_definite(op; semi=false)

Cheap check that the operator is positive (semi-)definite.
"""
function check_positive_definite(
  op::AbstractLinearOperator{T};
  semi = false,
) where {T <: Union{AbstractFloat, Complex}}
  m, n = size(op)
  m == n || throw(LinearOperatorException("shape mismatch"))
  v = rand(n)
  w = op * v
  vw = dot(v, w)
  ε = eps(real(eltype(op)))
  if imag(vw) > sqrt(ε) * abs(vw)
    return false
  end
  vw = real(vw)
  return semi ? (vw ≥ 0) : (vw > 0)
end

function check_positive_definite(op::AbstractLinearOperator{T}; semi = false) where {T <: Integer}
  m, n = size(op)
  m == n || throw(LinearOperatorException("shape mismatch"))
  v = convert(Vector{T}, (floor.(10 * rand(n)))) .- 5
  w = op * v
  vw = dot(v, w)
  return semi ? (vw ≥ 0) : (vw > 0)
end

check_positive_definite(M::AbstractMatrix; kwargs...) =
  check_positive_definite(LinearOperator(M); kwargs...)

"""
  solve_shifted_system!(x, B,  b, σ)

Solve linear system (B + σI) x = b, where B is a forward L-BFGS operator and σ ≥ 0.

### Parameters

- `x::AbstractVector{T}`: preallocated vector of length n that is used to store the solution x.
- `B::LBFGSOperator`: forward L-BFGS operator that models a matrix of size n x n.
- `b::AbstractVector{T}`: right-hand side vector of length n.
- `σ::T`: nonnegative shift.

### Returns

- `x::AbstractVector{T}`: solution vector `x` of length n.

### Method

The method uses a two-loop recursion-like approach with modifications to handle the shift `σ`.

### Example

```julia
using Random

# Problem setup
n = 100  # size of the problem
mem = 10   # L-BFGS memory size
scaling = true  # enable scaling

# Create an L-BFGS operator
B = LBFGSOperator(n, mem = mem, scaling = scaling)

# Add random {s, y} pairs to the L-BFGS operator
for _ = 1:10
    s = rand(n)   
    y = rand(n)   
    push!(B, s, y)  # Add the {s, y} pair to B
end

# Prepare vectors for the system
x = zeros(n)   # Preallocated solution vector
b = rand(n)        # Right-hand side vector
σ = 0.1            # Small shift value

# Solve the shifted system
result = solve_shifted_system!(x, B, b, σ)

# Check that the solution is close enough (residual test)
@assert norm(B * x + σ * x - b) / norm(b) < 1e-8
```

### References

Erway, J. B., Jain, V., & Marcia, R. F. Shifted L-BFGS Systems. Optimization Methods and Software, 29(5), pp. 992-1004, 2014.
"""
function solve_shifted_system!(
  x::AbstractVector{T},
  B::LBFGSOperator{T, I, F1, F2, F3},
  b::AbstractVector{T},
  σ::T,
) where {T, I, F1, F2, F3}
  if σ < 0
    throw(ArgumentError("σ must be nonnegative"))
  end
  data = B.data
  insert = data.insert

  γ_inv = 1 / data.scaling_factor
  x_0 = 1 / (γ_inv + σ)
  @. x = x_0 * b

  max_i = 2 * data.mem
  sign_i = 1

  for i = 1:max_i
    j = (i + 1) ÷ 2
    k = mod(insert + j - 1, data.mem) + 1
    data.shifted_u .= ((sign_i == -1) ? data.b[k] : data.a[k])

    @. data.shifted_p[:, i] = x_0 * data.shifted_u

    sign_t = 1
    for t = 1:(i - 1)
      c0 = dot(view(data.shifted_p, :, t), data.shifted_u)
      c1 = sign_t .* data.shifted_v[t]
      c2 = c1 * c0
      view(data.shifted_p, :, i) .+= c2 .* view(data.shifted_p, :, t)
      sign_t = -sign_t
    end

    data.shifted_v[i] = 1 / (1 - sign_i * dot(data.shifted_u, view(data.shifted_p, :, i)))
    x .+=
      sign_i * data.shifted_v[i] * (view(data.shifted_p, :, i)' * b) .* view(data.shifted_p, :, i)
    sign_i = -sign_i
  end
  return x
end

"""
    ldiv!(x, B, b)

Solves the linear system Bx = b.

### Arguments:

- `x::AbstractVector{T}`: preallocated vector of length n that is used to store the solution x.
- `B::LBFGSOperator`: forward L-BFGS operator that models a matrix of size n x n.
- `b::AbstractVector{T}`: right-hand side vector of length n.
### Returns:

- `x::AbstractVector{T}`: The modified solution vector containing the solution to the linear system.

### Example:
```julia

# Create an L-BFGS operator
B = LBFGSOperator(10)

# Generate random vectors
x = rand(10)
b = rand(10)

# Solve the linear system
ldiv!(x, B, b)

# The vector `x` now contains the solution
```
"""

function ldiv!(
  x::AbstractVector{T},
  B::LBFGSOperator{T, I, F1, F2, F3},
  b::AbstractVector{T},
) where {T, I, F1, F2, F3}
  # Call solve_shifted_system! with σ = 0
  solve_shifted_system!(x, B, b, T(0.0))
  return x
end

"""
    estimate_opnorm(B::AbstractLinearOperator; kwargs...)

Compute an estimate of the operator 2-norm (largest singular value) of a linear operator `B`.

This method dispatches to efficient algorithms depending on the properties and size of `B`:
- **Non-standard element types** (e.g., `BigFloat`, `Float16`): Always uses `TSVD.tsvd` as the fallback, since ARPACK only supports standard 32-bit and 64-bit floating-point types.
- **Small operators** (dimension ≤ `tiny_dense_threshold`): Attempts to convert `B` to a dense `Matrix` and uses direct LAPACK routines (`LinearAlgebra.eigen` if Hermitian, `LinearAlgebra.svd` otherwise).
- **Large, standard-type operators**:
    - If `ishermitian(B)`: Uses `Arpack.eigs` to find the eigenvalue with the largest magnitude.
    - Otherwise: Uses `Arpack.svds` to find the largest singular value.

**Note:** This function allocates memory. It requires `Arpack.jl` and `TSVD.jl` 
(and `GenericLinearAlgebra.jl` for generic types) to be loaded.

# Arguments
- `B::AbstractLinearOperator`: The linear operator to analyze.

# Keyword Arguments
- `max_attempts::Int=3`: Maximum number of retries for iterative solvers if convergence fails, doubling the Krylov subspace dimension (`ncv`) each time.
- `tiny_dense_threshold::Int=5`: If the minimum dimension of `B` is less than or equal to this threshold, it attempts to use direct dense LAPACK routines.
- `kwargs...`: Additional optional keyword arguments passed to the underlying iterative routines (`Arpack.eigs`, `Arpack.svds`, or `TSVD.tsvd`).

# Returns
- A tuple `(norm, success)` where:
    - `norm` is the estimated operator 2-norm of `B` (largest singular value or eigenvalue in absolute value).
    - `success` is a boolean indicating whether the estimate was computed successfully.
"""
function estimate_opnorm end

function test_lsr1()
  ϵ = eps(Float64)
  rtol = sqrt(ϵ)

  @testset ExtendedTestSet "LSR1" begin
    n = 10
    mem = 5
    B = LSR1Operator(n, mem = mem, scaling = false)
    @test isallocated5(B) == true

    for t = 1:2
      @test norm(diag(B) - diag(Matrix(B))) <= rtol

      @test B.data.insert == 1
      @test norm(Matrix(B) - Matrix(1.0I, n, n)) <= ϵ

      # Test that only valid updates are accepted.
      s = simple_vector(Float64, n)
      y = B * s
      push!(B, s, y)
      @test B.data.insert == 1

      # Insert a few {s,y} pairs.
      for i = 1:(mem + 2)
        s = ones(n) * i
        y = [i; ones(n - 1)]
        push!(B, s, y)
      end

      @test check_hermitian(B)
      @test norm(diag(B) - diag(Matrix(B))) <= rtol

      v = simple_vector(Float64, n)
      @test norm(B * v - v) > rtol
      reset!(B)
      @test B.data.scaling_factor == 1.0
      @test norm(B * v - v) < rtol

      # Test upper bound
      @test opnorm(Matrix(B)) ≤ B.data.opnorm_upper_bound
    end

    # test against full SR1 without scaling
    mem = n
    LB = LSR1Operator(n, mem = mem, scaling = false)
    B = Matrix(1.0I, n, n)

    function sr1!(B, s, y)
      # dense SR1 update
      ymBs = y - B * s
      denom = dot(ymBs, s)
      if abs(denom) >= 1.0e-8 + 1.0e-8 * norm(s) * norm(ymBs)
        B = B + ymBs * ymBs' / denom
      end
      return B
    end

    @test norm(Matrix(LB) - B) < rtol * norm(B)
    @test norm(diag(LB) - diag(B)) < rtol * norm(diag(B))

    for k = 1:mem
      s = simple_vector(Float64, n)
      y = simple_vector(Float64, n)
      B = sr1!(B, s, y)
      LB = push!(LB, s, y)
      @test norm(Matrix(LB) - B) < rtol * norm(B)
      @test norm(diag(LB) - diag(B)) < rtol * norm(diag(B))
    end

    # Test upper bound
    @test opnorm(B) ≤ LB.data.opnorm_upper_bound
  end

  @testset ExtendedTestSet "Different precision" begin
    n = 10
    mem = 5
    for T in (Float16, Float32, Float64, BigFloat)
      B = LSR1Operator(T, n, mem = mem)
      s = ones(T, n)
      y = ones(T, n)
      push!(B, s, y)
      @test eltype(B) == T
      v = [-(-one(T))^i for i = 1:n]
      @test eltype(B * v) == T
    end
  end

  @testset "LSR1 allocations" begin
    n = 100
    mem = 20
    B = LSR1Operator(n, mem = mem)
    nallocs = 0
    for _ = 1:2:n
      s = rand(n)
      y = rand(n)
      nallocs += @allocated push!(B, s, y)
    end
    @test nallocs == 0
    x = rand(n)
    res = similar(x)
    mul!(res, B, x)  # warmup
    nallocs = @allocated mul!(res, B, x)
    @test nallocs == 0
    nallocs = @allocated diag!(B, x)
    @test nallocs == 0
  end

  @testset "LSR1 eigenvalues" begin
    n = 100
    mem = 20
    B = LSR1Operator(n, mem = mem)
    for _ = 1:2:n
      s = rand(n)
      y = rand(n)
      push!(B, s, y)
    end
    vals = eigs(B, nev = n)
    resid = vals[end]
    @test norm(resid) ≤ sqrt(eps(eltype(B)))
  end
end

test_lsr1()

export DiagonalPSB, DiagonalAndrei, SpectralGradient, DiagonalBFGS

"""
    DiagonalPSB(d)

Construct a linear operator that represents a diagonal PSB quasi-Newton approximation
as described in

M. Zhu, J. L. Nazareth and H. Wolkowicz
The Quasi-Cauchy Relation and Diagonal Updating.
SIAM Journal on Optimization, vol. 9, number 4, pp. 1192-1204, 1999.
https://doi.org/10.1137/S1052623498331793.

The approximation satisfies the weak secant equation and is not guaranteed to be
positive definite.

# Arguments

- `d::AbstractVector`: initial diagonal approximation.
"""
mutable struct DiagonalPSB{T <: Real, I <: Integer, V <: AbstractVector{T}, F} <:
               AbstractDiagonalQuasiNewtonOperator{T}
  const d::V # Diagonal of the operator
  const nrow::I
  const ncol::I
  const symmetric::Bool
  const hermitian::Bool
  const prod!::F
  const tprod!::F
  const ctprod!::F
  nprod::I
  ntprod::I
  nctprod::I
end

@doc (@doc DiagonalPSB) function DiagonalPSB(d::AbstractVector{T}) where {T <: Real}
  prod = (res, v, α, β) -> mulSquareOpDiagonal!(res, d, v, α, β)
  n = length(d)
  DiagonalPSB(d, n, n, true, true, prod, prod, prod, 0, 0, 0)
end

# update function
# s = x_{k+1} - x_k
# y = ∇f(x_{k+1}) - ∇f(x_k)
function push!(
  B::DiagonalPSB{T, I, V, F},
  s::V,
  y::V,
) where {T <: Real, I <: Integer, V <: AbstractVector{T}, F}
  sNorm = norm(s, 2)
  if sNorm == 0
    error("Cannot update DiagonalQN operator with s=0")
  end
  # sᵀBs = sᵀy can be scaled by ||s||² without changing the update
  s2 = (si^2 for si ∈ s)
  sNorm2 = sNorm^2
  trA2 = dot(s2, s2) / sNorm2^2
  sT_y = dot(s, y) / sNorm2
  sT_B_s = dot(s2, B.d) / sNorm2
  q = sT_y - sT_B_s
  q /= trA2
  B.d .+= q / sNorm2 .* s .^ 2
  return B
end

"""
    reset!(op::AbstractDiagonalQuasiNewtonOperator)

Reset the diagonal data of the given operator.
"""
function reset!(op::AbstractDiagonalQuasiNewtonOperator{T}) where {T <: Real}
  op.d .= one(T)
  op.nprod = 0
  op.ntprod = 0
  op.nctprod = 0
  return op
end

"""
    DiagonalAndrei(d)

Construct a linear operator that represents a diagonal quasi-Newton approximation
as described in

Andrei, N.
A diagonal quasi-Newton updating method for unconstrained optimization.
https://doi.org/10.1007/s11075-018-0562-7

The approximation satisfies the weak secant equation and is not guaranteed to be
positive definite.

# Arguments

- `d::AbstractVector`: initial diagonal approximation.
"""
mutable struct DiagonalAndrei{T <: Real, I <: Integer, V <: AbstractVector{T}, F} <:
               AbstractDiagonalQuasiNewtonOperator{T}
  const d::V # Diagonal of the operator
  const nrow::I
  const ncol::I
  const symmetric::Bool
  const hermitian::Bool
  const prod!::F
  const tprod!::F
  const ctprod!::F
  nprod::I
  ntprod::I
  nctprod::I
end

@doc (@doc DiagonalAndrei) function DiagonalAndrei(d::AbstractVector{T}) where {T <: Real}
  prod = (res, v, α, β) -> mulSquareOpDiagonal!(res, d, v, α, β)
  n = length(d)
  DiagonalAndrei(d, n, n, true, true, prod, prod, prod, 0, 0, 0)
end

# update function
# s = x_{k+1} - x_k
# y = ∇f(x_{k+1}) - ∇f(x_k)
function push!(
  B::DiagonalAndrei{T, I, V, F},
  s::V,
  y::V,
) where {T <: Real, I <: Integer, V <: AbstractVector{T}, F}
  sNorm = norm(s, 2)
  if sNorm == 0
    error("Cannot update DiagonalQN operator with s=0")
  end
  # sᵀBs = sᵀy can be scaled by ||s||² without changing the update
  s2 = (si^2 for si ∈ s)
  sNorm2 = sNorm^2
  trA2 = dot(s2, s2) / sNorm2^2
  sT_y = dot(s, y) / sNorm2
  sT_B_s = dot(s2, B.d) / sNorm2
  q = sT_y - sT_B_s
  sT_s = dot(s, s) / sNorm2
  q += sT_s
  q /= trA2
  B.d .+= q / sNorm2 .* s .^ 2 .- 1
  return B
end

"""
Implementation of a spectral gradient quasi-Newton approximation described in

Birgin, E. G., Martínez, J. M., & Raydan, M.
Spectral Projected Gradient Methods: Review and Perspectives.
https://doi.org/10.18637/jss.v060.i03
"""
mutable struct SpectralGradient{T <: Real, I <: Integer, F} <:
               AbstractDiagonalQuasiNewtonOperator{T}
  const d::Vector{T} # Diagonal coefficient of the operator (multiple of the identity)
  const nrow::I
  const ncol::I
  const symmetric::Bool
  const hermitian::Bool
  const prod!::F
  const tprod!::F
  const ctprod!::F
  nprod::I
  ntprod::I
  nctprod::I
end

"""
        SpectralGradient(σ, n)

Construct a spectral gradient Hessian approximation.
The approximation is defined as σI.

# Arguments

- `σ::Real`: initial positive multiple of the identity;
- `n::Int`: operator size.
"""
function SpectralGradient(σ::T, n::I) where {T <: Real, I <: Integer}
  @assert σ > 0
  d = [σ]
  prod = (res, v, α, β) -> mulSquareOpDiagonal!(res, d, v, α, β)
  SpectralGradient(d, n, n, true, true, prod, prod, prod, 0, 0, 0)
end

# update function
# s = x_{k+1} - x_k
# y = ∇f(x_{k+1}) - ∇f(x_k)
function push!(
  B::SpectralGradient{T, I, F},
  s::V,
  y::V,
) where {T <: Real, I <: Integer, F, V <: AbstractVector{T}}
  if all(x -> x == 0, s)
    error("Cannot divide by zero and s .= 0")
  end
  B.d[1] = dot(s, y) / dot(s, s)
  return B
end

"""
    DiagonalBFGS(d)

A diagonal approximation of the BFGS update inspired by
Marnissi, Y., Chouzenoux, E., Benazza-Benyahia, A., & Pesquet, J. C. (2020).
Majorize–minimize adapted Metropolis–Hastings algorithm.
https://ieeexplore.ieee.org/abstract/document/9050537.

# Arguments

- `d::AbstractVector`: initial diagonal approximation.
"""
mutable struct DiagonalBFGS{T <: Real, I <: Integer, V <: AbstractVector{T}, F} <:
               AbstractDiagonalQuasiNewtonOperator{T}
  const d::V # Diagonal of the operator
  const nrow::I
  const ncol::I
  const symmetric::Bool
  const hermitian::Bool
  const prod!::F
  const tprod!::F
  const ctprod!::F
  nprod::I
  ntprod::I
  nctprod::I
end

@doc (@doc DiagonalBFGS) function DiagonalBFGS(d::AbstractVector{T}) where {T <: Real}
  prod = (res, v, α, β) -> mulSquareOpDiagonal!(res, d, v, α, β)
  n = length(d)
  DiagonalBFGS(d, n, n, true, true, prod, prod, prod, 0, 0, 0)
end

# update function
# s = x_{k+1} - x_k
# y = ∇f(x_{k+1}) - ∇f(x_k)
function push!(
  B::DiagonalBFGS{T, I, V, F},
  s::V,
  y::V,
) where {T <: Real, I <: Integer, V <: AbstractVector{T}, F}
  sNorm = norm(s, 2)
  if sNorm == 0
    error("Cannot update DiagonalQN operator with s=0")
  end
  sNorm2 = sNorm^2
  sT_y = dot(s, y) / sNorm2
  B.d .= abs.(y)
  B.d .*= sum(B.d) / sT_y
  return B
end

for op in (DiagonalPSB, DiagonalAndrei, SpectralGradient, DiagonalBFGS)
  @eval begin
    isallocated5(::$op) = true
    has_args5(::$op) = true
  end
end

module LinearOperatorsCUDAExt

using LinearOperators
isdefined(Base, :get_extension) ? (using CUDA; using CUDA.cuSPARSE) :
(using ..CUDA; using ..CUDA.cuSPARSE)

LinearOperators.storage_type(::CuArray{T, 2, D}) where {T, D} = CuArray{T, 1, D}
LinearOperators.storage_type(::AbstractCuSparseMatrix{T}) where {T} =
  CuArray{T, 1, CUDA.DeviceMemory}

end # module

function test_linop()
  (nrow, ncol) = (10, 6)
  ϵ = eps(Float64)
  rtol = sqrt(ϵ)
  A1 = simple_matrix(ComplexF64, nrow, ncol)

  @testset ExtendedTestSet "Basic operations" begin
    for op in (
      LinearOperator(A1),
      LinearOperator(A1')',
      transpose(LinearOperator(transpose(A1))),
      conj(LinearOperator(conj(A1))),
    )
      show(op)

      @testset "Data type" begin
        @test eltype(op) == eltype(A1)
        @test !isreal(op)
      end

      @testset "Size" begin
        @test(size(op) == (nrow, ncol))
        @test(size(op, 1) == nrow)
        @test(size(op, 2) == ncol)
        @test_throws LinearOperatorException size(op, 3)
        @test_throws LinearOperatorException op * ones(ncol + 1)
      end

      @testset "Boolean operators" begin
        @test(issymmetric(op) == false)
        @test(ishermitian(op) == false)
      end

      @testset "Full" begin
        @test(norm(A1 - Matrix(op)) <= ϵ * norm(A1))
      end

      @testset "Unary +." begin
        @test(norm(A1 - Matrix(+op)) <= ϵ * norm(A1))
      end
    end

    @testset "LinearOperator(Matrix)" begin
      A2 = simple_sparse_matrix(ComplexF64, nrow, ncol)
      for A in (A1, A2)
        op = LinearOperator(A)
        @test(op.nrow == nrow)
        @test(op.ncol == ncol)

        @test(norm(A - Matrix(op)) <= rtol * norm(A))
        @test(norm(transpose(A) - Matrix(transpose(op))) <= rtol * norm(A))
        @test(norm(A' - Matrix(op')) <= rtol * norm(A))

        v = simple_vector(ComplexF64, ncol)
        @test(norm(A * v - op * v) <= rtol * norm(v))

        u = simple_vector(ComplexF64, nrow)
        @test(norm(transpose(A) * u - transpose(op) * u) <= rtol * norm(u))
        @test(norm(A' * u - op' * u) <= rtol * norm(u))
        @test(norm(u' * A - u' * op) <= rtol * norm(u))
        @test(norm(transpose(u) * A - transpose(u) * op) <= rtol * norm(u))
        @test(typeof(u' * op * v) <: Number)
        @test(norm(u' * A * v - u' * op * v) <= rtol * norm(u))

        mv = hcat(v, -2v)
        mu = hcat(u, -2u)
        res_mat = similar(mu)
        res_trans = similar(mv)
        res_adj = similar(mv)
        mul!(res_mat, op, mv)
        mul!(res_trans, transpose(op), mu)
        mul!(res_adj, op', mu)
        @test(norm(A * mv - res_mat) <= rtol * norm(mv))
        @test(norm(transpose(A) * mu - res_trans) <= rtol * norm(mu))
        @test(norm(A' * mu - res_adj) <= rtol * norm(mu))
      end

      A3 = Hermitian(A2' * A2)
      op3 = LinearOperator(A3)
      @test Hermitian(op3) == op3
      @test hermitian(op3, :L) == op3
      nrow3, ncol3 = size(A3)
      @test(op3.nrow == op3.ncol == nrow3)
      v3 = simple_vector(ComplexF64, ncol3)
      @test(norm(A3 * v3 - op3 * v3) <= rtol * norm(v3))

      A3 = Symmetric(real.(A2' * A2))
      op3 = LinearOperator(A3)
      @test Symmetric(op3) == op3
      @test symmetric(op3, :L) == op3
      nrow3, ncol3 = size(A3)
      @test(op3.nrow == op3.ncol == nrow3)
      v3 = simple_vector(ComplexF64, ncol3)
      @test(norm(A3 * v3 - op3 * v3) <= rtol * norm(v3))

      A4 = SymTridiagonal(A3)
      op4 = LinearOperator(A4)
      nrow4, ncol4 = size(A4)
      @test(op4.nrow == op4.ncol == nrow4)
      v4 = simple_vector(ComplexF64, ncol4)
      @test(norm(A4 * v4 - op4 * v4) <= rtol * norm(v4))

      A5 = rand(Complex{Float64}, 10, 20)
      op5 = LinearOperator(A5)
      @test_throws LinearOperatorException Symmetric(op5)
      @test_throws LinearOperatorException Hermitian(op5)

      A6 = rand(Complex{Float64}, 10, 10)
      op6 = LinearOperator(A6)
      @test Matrix(Symmetric(op6)) == (A6 + transpose(A6)) / 2
      @test Matrix(Hermitian(op6)) == (A6 + adjoint(A6)) / 2
    end

    @testset "Constructor with specified structure" begin
      v = simple_vector(Float64, nrow)
      A = simple_matrix(ComplexF64, nrow, nrow)
      A = A + A'
      A = A + transpose(A)
      op = LinearOperator(A, symmetric = true, hermitian = true)
      @test norm(op * v - A * v) <= rtol * norm(A)
      @test norm(transpose(op) * v - transpose(A) * v) <= rtol * norm(A)
      @test norm(op' * v - A' * v) <= rtol * norm(A)

      A = simple_matrix(ComplexF64, nrow, nrow)
      A = A + A' # Hermitian
      op = LinearOperator(A, symmetric = false, hermitian = true)
      @test norm(op * v - A * v) <= rtol * norm(A)
      @test norm(transpose(op) * v - transpose(A) * v) <= rtol * norm(A)
      @test norm(op' * v - A' * v) <= rtol * norm(A)

      A = simple_matrix(ComplexF64, nrow, nrow)
      A = A + transpose(A) # Symmetric
      op = LinearOperator(A, symmetric = true, hermitian = false)
      @test norm(op * v - A * v) <= rtol * norm(A)
      @test norm(transpose(op) * v - transpose(A) * v) <= rtol * norm(A)
      @test norm(op' * v - A' * v) <= rtol * norm(A)
    end

    @testset "Basic arithmetic operations" begin
      B1 = simple_matrix(ComplexF64, nrow, ncol)

      for q in (+, -)
        C = q(A1, B1)
        opC = q(LinearOperator(A1), LinearOperator(B1))
        v = simple_vector(ComplexF64, ncol)
        @test(norm(opC * v - C * v) <= rtol * norm(v))
        u = simple_vector(ComplexF64, nrow)
        @test(norm(transpose(opC) * u - transpose(C) * u) <= rtol * norm(u))
        @test(norm(opC' * u - C' * u) <= rtol * norm(u))

        opC = q(A1, LinearOperator(B1))
        @test(norm(opC * v - C * v) <= rtol * norm(v))
        @test(norm(transpose(opC) * u - transpose(C) * u) <= rtol * norm(u))
        @test(norm(opC' * u - C' * u) <= rtol * norm(u))

        opC = q(LinearOperator(A1), B1)
        @test(norm(opC * v - C * v) <= rtol * norm(v))
        @test(norm(transpose(opC) * u - transpose(C) * u) <= rtol * norm(u))
        @test(norm(opC' * u - C' * u) <= rtol * norm(u))
      end
    end

    B2 = simple_matrix(ComplexF64, ncol, ncol + 1)
    @testset "Operator ± scalar" begin
      opC = LinearOperator(A1) + 2.12345
      @test(norm(A1 .+ 2.12345 - Matrix(opC)) <= rtol * norm(A1 .+ 2.12345))

      opC = 2.12345 + LinearOperator(A1)
      @test(norm(A1 .+ 2.12345 - Matrix(opC)) <= rtol * norm(A1 .+ 2.12345))

      opC = LinearOperator(A1) - 2.12345
      @test(norm((A1 .- 2.12345) - Matrix(opC)) <= rtol * norm(A1 .- 2.12345))

      opC = 2.12345 - LinearOperator(A1)
      @test(norm((2.12345 .- A1) - Matrix(opC)) <= rtol * norm(2.12345 .- A1))
    end

    @testset "Operator × Operator" begin
      A4 = simple_matrix(ComplexF64, ncol, ncol)
      B4 = simple_matrix(ComplexF64, ncol, ncol)
      for Ai in (A4, transpose(A4), adjoint(A4), conj(A4))
        for Bi in (B4, transpose(B4), adjoint(B4), conj(B4))
          C = Ai * Bi
          opC = LinearOperator(Ai) * LinearOperator(Bi)
          v = simple_vector(ComplexF64, ncol)
          @test(norm(opC * v - C * v) <= rtol * norm(v))
          u = simple_vector(ComplexF64, ncol)
          @test(norm(transpose(opC) * u - transpose(C) * u) <= rtol * norm(u))
          @test(norm(opC' * u - C' * u) <= rtol * norm(u))
        end
      end

      C = A1 * B2
      opC = LinearOperator(A1) * LinearOperator(B2)
      v = simple_vector(ComplexF64, ncol + 1)
      @test(norm(opC * v - C * v) <= rtol * norm(v))
      u = simple_vector(ComplexF64, nrow)
      @test(norm(transpose(opC) * u - transpose(C) * u) <= rtol * norm(u))
      @test(norm(opC' * u - C' * u) <= rtol * norm(u))

      @test_throws LinearOperatorException LinearOperator(A1) + LinearOperator(B2)
      @test_throws LinearOperatorException LinearOperator(B2) * LinearOperator(A1)
    end

    A1B2 = A1 * B2
    @testset "Matrix × operator" begin
      opC = A1 * LinearOperator(B2)
      @test(norm(A1B2 - Matrix(opC)) <= rtol * norm(A1B2))
    end

    @testset "Operator × matrix" begin
      opC = LinearOperator(A1) * B2
      @test(norm(A1B2 - Matrix(opC)) <= rtol * norm(A1B2))
    end

    AA1 = 2.12345 * A1
    @testset "Scalar × operator" begin
      opC = 2.12345 * LinearOperator(A1)
      @test(norm(AA1 - Matrix(opC)) <= rtol * norm(AA1))
    end

    @testset "Operator × scalar" begin
      opC = LinearOperator(A1) * 2.12345
      @test(norm(AA1 - Matrix(opC)) <= rtol * norm(AA1))
    end
  end

  @testset ExtendedTestSet "Basic operators" begin
    @testset "Identity" begin
      opI = opEye(nrow)
      opI2 = opEye(nrow, nrow)
      v = simple_vector(ComplexF64, nrow)
      @test(abs(norm(opI * v - v)) <= ϵ * norm(v))
      @test(abs(norm(opI2 * v - v)) <= ϵ * norm(v))
      @test(abs(norm(transpose(opI) * v - v)) <= ϵ * norm(v))
      @test(abs(norm(opI' * v - v)) <= ϵ * norm(v))
      @test(abs(norm(v' * opI - v')) <= ϵ * norm(v))
      @test(norm(Matrix(opI) - Matrix(1.0I, nrow, nrow)) <= ϵ * norm(Matrix(1.0I, nrow, nrow)))

      w = opI * v
      w[1] = -1.0
      @test v[1] != w[1]

      opI = opEye(nrow, ncol)
      v = simple_vector(ComplexF64, ncol)
      v0 = [v; zeros(nrow - ncol)]
      vu = [v; ones(nrow - ncol)]
      @test(abs(norm(opI * v - v0)) <= ϵ * norm(v))
      @test(abs(norm(transpose(opI) * vu - v)) <= ϵ * norm(v))
      @test(abs(norm(opI' * vu - v)) <= ϵ * norm(v))
      @test(norm(Matrix(opI) - Matrix(1.0I, nrow, ncol)) <= ϵ * norm(Matrix(1.0I, nrow, ncol)))

      opI = opEye(ncol, nrow)
      @test(abs(norm(opI * vu - v)) <= ϵ * norm(v))
      @test(abs(norm(transpose(opI) * v - v0)) <= ϵ * norm(v))
      @test(abs(norm(opI' * v - v0)) <= ϵ * norm(v))
      @test(norm(Matrix(opI) - Matrix(1.0I, ncol, nrow)) <= ϵ * norm(Matrix(1.0I, ncol, nrow)))
    end

    @testset "Identity (non-convertible to matrix)" begin
      op = opEye()
      show(op)

      v = simple_vector(Float64, 5)
      w = op * v
      @test w === v
      w = v * op

      @test w === v
      A2 = op * A1
      @test A2 === A1
      A2 = A1 * op
      @test A2 === A1

      T1 = LinearOperator(A1)
      T2 = op * T1
      @test T2 === T1
      T2 = T1 * op
      @test T2 === T1

      op2 = opEye()
      @test op === op2
      @test op === op * op2 === op2 * op

      @test norm(transpose(op) * v - v) <= ϵ * norm(v)
      @test norm(adjoint(op) * v - v) <= ϵ * norm(v)
      @test norm(conj(op) * v - v) <= ϵ * norm(v)
    end

    @testset "Ones" begin
      E = opOnes(nrow, ncol)
      v = simple_vector(ComplexF64, nrow)
      u = simple_vector(ComplexF64, ncol)
      @test(norm(E * u - sum(u) * ones(nrow)) <= rtol * norm(u))
      @test(norm(transpose(E) * v - sum(v) * ones(ncol)) <= rtol * norm(v))
      @test(norm(E' * v - sum(v) * ones(ncol)) <= rtol * norm(v))
    end

    @testset "Zeros" begin
      O = opZeros(nrow, ncol)
      v = simple_vector(ComplexF64, nrow)
      u = simple_vector(ComplexF64, ncol)
      @test(norm(O * u) <= ϵ)
      @test(norm(transpose(O) * v) <= ϵ)
      @test(norm(O' * v) <= ϵ)
    end

    @testset "Diagonal" begin
      v = simple_vector(ComplexF64, nrow)
      D = opDiagonal(v)
      u = simple_vector(ComplexF64, nrow)
      @test(norm(D * u - v .* u) <= ϵ * norm(u))
      @test(norm(transpose(D) * u - v .* u) <= ϵ * norm(u))
      @test(norm(D' * u - conj(v) .* u) <= ϵ * norm(u))
      res = simple_vector(ComplexF64, nrow)
      res2 = v .* u .* 2.0 + 2.0 .* res
      mul!(res, D, u, 2.0, 2.0)
      @test(norm(res - res2) <= ϵ * norm(u))
    end

    @testset "Rectangular diagonal" begin
      nmin = min(nrow, ncol)
      nmax = max(nrow, ncol)
      A = zeros(ComplexF64, nmax, nmin)
      v = simple_vector(ComplexF64, nmin)
      for i = 1:nmin
        A[i, i] = v[i]
      end
      D = opDiagonal(nmax, nmin, v)
      u = simple_vector(ComplexF64, nmin)
      @test(norm(A * u - D * u) <= ϵ * norm(u))
      w = simple_vector(ComplexF64, nmax)
      @test(norm(transpose(A) * w - transpose(D) * w) <= ϵ * norm(w))
      @test(norm(A' * w - D' * w) <= ϵ * norm(w))

      A = zeros(ComplexF64, nmin, nmax)
      for i = 1:nmin
        A[i, i] = v[i]
      end
      D = opDiagonal(nmin, nmax, v)
      @test(norm(A * w - D * w) <= ϵ * norm(w))
      @test(norm(transpose(A) * u - transpose(D) * u) <= ϵ * norm(u))
      @test(norm(A' * u - D' * u) <= ϵ * norm(u))
    end

    @testset "posdef" begin
      v = simple_vector(ComplexF64, nrow)
      H = opHouseholder(v)
      Λ = collect(eltype(v), 1:nrow)
      op = H * opDiagonal(Λ) * H'
      @test check_positive_definite(op)
      @test check_positive_definite(op, semi = true)
      Λ = collect(eltype(v), 0:(nrow - 1))
      op = H * opDiagonal(Λ) * H'
      @test check_positive_definite(op, semi = true)
      A = Matrix(op)
      @test check_positive_definite(A, semi = true)
    end

    @testset "Hermitian" begin
      A = simple_matrix(ComplexF64, nrow, nrow)
      d = real.(diag(A))
      A = tril(A, -1)
      C = A + A' + diagm(0 => d)
      H = opHermitian(d, A)
      v = simple_vector(ComplexF64, nrow)
      @test(norm(H * v - C * v) <= rtol * norm(v))
      @test(norm(transpose(H) * v - transpose(C) * v) <= rtol * norm(v))
      @test(norm(H' * v - C * v) <= rtol * norm(v))

      @test(!check_hermitian(LinearOperator(A - A')))
      @test(!check_positive_definite(LinearOperator(-A' * A)))

      C = simple_matrix(ComplexF64, nrow, nrow, symmetric = true)
      H = opHermitian(C)
      v = simple_vector(ComplexF64, nrow)
      @test(norm(H * v - C * v) <= rtol * norm(v))
      @test(norm(transpose(H) * v - transpose(C) * v) <= rtol * norm(v))
      @test(norm(H' * v - C * v) <= rtol * norm(v))
    end

    @testset "Transpose and adjoint" begin
      A = simple_matrix(ComplexF64, nrow, nrow)
      v = simple_vector(ComplexF64, nrow)
      res_init = simple_vector(ComplexF64, nrow)
      res = copy(res_init)
      α, β = 2.0, -3.0

      op = LinearOperator(
        ComplexF64,
        nrow,
        nrow,
        false,
        false,
        (res, v, α, β) -> mul!(res, A, v, α, β),
        (res, v, α, β) -> mul!(res, transpose(A), v, α, β),
        nothing,
      )
      @test(norm(transpose(A) * v - transpose(op) * v) <= rtol * norm(v))
      @test(norm(adjoint(A) * v - adjoint(op) * v) <= rtol * norm(v))
      @test(norm(A * v - transpose(transpose(op)) * v) <= rtol * norm(v))
      @test(norm(A * v - adjoint(adjoint(op)) * v) <= rtol * norm(v))
      @test(norm(conj.(A) * v - transpose(adjoint(op)) * v) <= rtol * norm(v))
      @test(norm(conj.(A) * v - adjoint(transpose(op)) * v) <= rtol * norm(v))
      mul!(res, adjoint(op), v, α, β)
      @test(norm(α * A' * v + β * res_init - res) <= rtol * norm(v))

      op = LinearOperator(
        ComplexF64,
        nrow,
        nrow,
        false,
        false,
        (res, v, α, β) -> mul!(res, A, v, α, β),
        nothing,
        (res, v, α, β) -> mul!(res, adjoint(A), v, α, β),
      )
      @test(norm(transpose(A) * v - transpose(op) * v) <= rtol * norm(v))
      @test(norm(adjoint(A) * v - adjoint(op) * v) <= rtol * norm(v))
      @test(norm(A * v - transpose(transpose(op)) * v) <= rtol * norm(v))
      @test(norm(A * v - adjoint(adjoint(op)) * v) <= rtol * norm(v))
      @test(norm(conj.(A) * v - transpose(adjoint(op)) * v) <= rtol * norm(v))
      @test(norm(conj.(A) * v - adjoint(transpose(op)) * v) <= rtol * norm(v))
      res .= res_init
      mul!(res, transpose(op), v, α, β)
      @test(norm(α * transpose(A) * v + β * res_init - res) <= rtol * norm(v))
    end

    @testset "Integer" begin
      A = round.(Int, simple_matrix(Float64, nrow, nrow))
      op = LinearOperator(A)
      @test check_ctranspose(op)
      @test check_hermitian(op + op')
      @test check_positive_definite(op * op')
    end

    @testset "Restriction and Extension" begin
      n = 10
      J = [1; 2; 4; 7]
      r = 3:6
      s = 1:2:7
      k = 4
      v = simple_vector(Float64, nrow)

      for idx in (J, r, s, Colon(), k)
        P = opRestriction(idx, n)
        Z = opExtension(idx, n)

        # 1d slices are different; in Julia, v[idx] is a scalar
        w = v[idx]
        typeof(idx) <: Number && (w = [w])
        vz = zeros(n)
        vz[idx] = v[idx]

        @test P * v == w
        @test P' * w == vz
        @test Z * w == vz
        @test Z' * v == w
        @test (P * Z) * w == w
        @test (Z * P) * v == vz
      end

      A = rand(n, n)
      opA = LinearOperator(A)
      v = simple_vector(Float64, 2)
      @test norm(A[[3, 4], [5, 6]] * v - opA[[3, 4], [5, 6]] * v) ≤ rtol * norm(v)
    end
  end

  @testset ExtendedTestSet "Linear system operators" begin
    A = simple_matrix(ComplexF64, nrow, nrow)
    v = simple_vector(Float64, nrow)

    @testset "Inverse" begin
      Ainv = opInverse(A)
      @test(norm(A \ v - Ainv * v) <= rtol * norm(v))
      @test(norm(transpose(A) \ v - transpose(Ainv) * v) <= rtol * norm(v))
      @test(norm(A' \ v - Ainv' * v) <= rtol * norm(v))
    end

    @testset "Cholesky and LDL" begin
      B = A' * A
      Binv = opCholesky(B)  #, check=true);
      @test(norm(B \ v - Binv * v) <= rtol * norm(v))
      @test(norm(transpose(B) \ v - transpose(Binv) * v) <= rtol * norm(v))
      @test(norm(B' \ v - Binv' * v) <= rtol * norm(v))

      @test_throws LinearOperatorException opCholesky(simple_matrix(Float64, 3, 5))
      @test_throws LinearOperatorException opCholesky(simple_matrix(Float64, 5, 5), check = true)

      # Test Cholesky operator on SQD matrix.
      A = simple_matrix(Float64, 3, 3, symmetric = true)
      B = simple_matrix(Float64, 2, 3)
      C = simple_matrix(Float64, 2, 2, symmetric = true)
      K = Symmetric([A B'; B -C])

      # Dense Cholesky should throw an exception.
      @test_throws LinearAlgebra.PosDefException opCholesky(K)

      # Compute the LDL' factorization.
      LDL = opLDL(sparse(K))
      e = ones(size(K, 1))
      @test(norm(LDL * (K * e) - e) < rtol * norm(e))

      # tests LDLFactorizations
      LDL = opLDL(Symmetric(triu!(sparse(K)), :U), check = true)
      e = ones(size(K, 1))
      @test(norm(LDL * (K * e) - e) < rtol * norm(e))
    end

    @testset "Householder" begin
      v = simple_vector(ComplexF64, nrow)
      H = opHouseholder(v)
      u = simple_vector(ComplexF64, nrow)
      @test(norm(H * u - (u - 2 * dot(v, u) * v)) <= rtol * norm(u))
      @test(norm(transpose(H) * u - (u - 2 * dot(conj(v), u) * conj(v))) <= rtol * norm(u))
      @test(norm(H' * u - (u - 2 * dot(v, u) * v)) <= rtol * norm(u))
    end
  end

  @testset ExtendedTestSet "Inference" begin
    function test_func(res)
      res .= 1.0 .+ im * 1.0
    end
    op = LinearOperator(ComplexF64, 5, 3, false, false, (res, p, α, β) -> test_func(res))
    @test eltype(op) == ComplexF64
    v = rand(5)
    @test_throws LinearOperatorException transpose(op) * v  # cannot be inferred
    @test_throws LinearOperatorException op' * v            # cannot be inferred

    op2 = conj(op)
    @test(norm(Matrix(op2) - conj(Matrix(op))) <= ϵ * norm(Matrix(op)))

    A = simple_matrix(ComplexF64, 5, 3)
    op = LinearOperator(A)
    @test(check_ctranspose(A))
    @test(check_ctranspose(op))
    @test_throws LinearOperatorException opCholesky(A)  # Shape mismatch

    A = simple_matrix(ComplexF64, 5, 5)
    @test_throws LinearOperatorException opCholesky(A, check = true)  # Not Hermitian / positive definite
    @test_throws LinearOperatorException opCholesky(-A' * A, check = true)  # Not positive definite

    # Adjoint of a symmetric non-hermitian
    A = simple_matrix(ComplexF64, 3, 3)
    A = A + transpose(A)
    op = LinearOperator(ComplexF64, 3, 3, true, false, (res, v, α, β) -> mul!(res, A, v))
    v = rand(3)
    @test op' * v ≈ A' * v
  end

  @testset ExtendedTestSet "Type specific operator" begin
    function prod!(res, v, α, β)
      res[1] = v[1] + v[2]
      res[2] = v[2]
    end
    function ctprod!(res, v, α, β)
      res[1] = v[1]
      res[2] = v[1] + v[2]
    end
    for T in (Complex{Float64}, Complex{Float32}, BigFloat, Float64, Float32, Float16, Int32)
      op = LinearOperator(T, 2, 2, false, false, prod!, nothing, ctprod!)
      w = ones(T, 2)
      @test eltype(op) == T
      @test op * w == T[2; 1]
      @test eltype(op * w) == T
    end

    A = [im 1.0; 0.0 1.0]
    function prod2!(res, v, α, β)
      mul!(res, A, v)
    end
    function tprod2!(res, u, α, β)
      mul!(res, transpose(A), u)
    end
    function ctprod2!(res, w, α, β)
      mul!(res, A', w)
    end
    opC = LinearOperator(ComplexF64, 2, 2, false, false, prod2!, tprod2!, ctprod2!)
    v = simple_vector(ComplexF64, 2)
    @test A == Matrix(opC)
    opF = LinearOperator(Float64, 2, 2, false, false, prod2!, tprod2!, ctprod2!) # The type is a lie
    @test eltype(opF) == Float64
    @test_throws InexactError Matrix(opF) # changed here TypeError to InexactError
  end

  # Issue #80
  @testset ExtendedTestSet "Test mul!" begin
    A = [1.0 1.0; 1.0 0.0]
    op = LinearOperator(A)
    y = zeros(2)
    x = ones(2)
    mul!(y, op, x)
    @test y == [2.0; 1.0]
  end

  # Issue #107
  @testset ExtendedTestSet "Unary and scalar operations on Adjoint and Transpose operators" begin
    op = LinearOperator(rand(5, 3))
    for adjtrans in [adjoint, transpose]
      @test Matrix(adjtrans(-op)) == Matrix(-adjtrans(op))
      @test Matrix(adjtrans(2 * op)) == Matrix(2 * adjtrans(op))
    end
  end

  # Issue #109
  @testset ExtendedTestSet "Sum with Adjoint and Transpose" begin
    A = rand(3, 3) + im * rand(3, 3)
    opA = LinearOperator(A)
    for adjtrans in [adjoint, transpose]
      @test Matrix(adjtrans(opA) + opA) == Matrix(opA + adjtrans(opA)) == A + adjtrans(A)
      @test Matrix(adjtrans(opA) + A) == Matrix(A + adjtrans(opA)) == A + adjtrans(A)
    end
  end

  # Issue #109
  @testset ExtendedTestSet "Cat with Adjoint and Transpose" begin
    A = rand(3, 3) + im * rand(3, 3)
    opA = LinearOperator(A)
    for adjtrans in [adjoint, transpose]
      @test Matrix([adjtrans(opA) opA]) == Matrix([adjtrans(A) A])
      @test Matrix([adjtrans(opA); opA]) == Matrix([adjtrans(A); A])
      @test Matrix([adjtrans(opA); adjtrans(opA)]) == Matrix([adjtrans(A); adjtrans(A)])
      @test Matrix([opA adjtrans(opA)]) == Matrix([A adjtrans(A)])
      @test Matrix([opA; adjtrans(opA)]) == Matrix([A; adjtrans(A)])
      @test Matrix([adjtrans(opA) A]) == Matrix([adjtrans(A) A])
      @test Matrix([adjtrans(opA); A]) == Matrix([adjtrans(A); A])
      @test Matrix([A adjtrans(opA)]) == Matrix([A adjtrans(A)])
      @test Matrix([A; adjtrans(opA)]) == Matrix([A; adjtrans(A)])
      @test Matrix([adjtrans(opA) opA; opA adjtrans(opA)]) == Matrix([adjtrans(A) A; A adjtrans(A)])
    end
  end

  @testset ExtendedTestSet "Counters" begin
    op = LinearOperator(rand(3, 4) + im * rand(3, 4))
    @test nprod(op) == 0
    @test ntprod(op) == 0
    @test nctprod(op) == 0
    nprods = 5
    ntprods = 4
    nctprods = 7
    for _ = 1:nprods
      op * rand(4)
    end
    for _ = 1:ntprods
      transpose(op) * rand(3)
    end
    for _ = 1:nctprods
      op' * rand(3)
    end
    @test nprod(op) == nprods
    @test ntprod(op) == ntprods
    @test nctprod(op) == nctprods
    for _ = 1:nprods
      conj(op) * rand(4)
    end
    @test nprod(op) == 2 * nprods

    opᵀ = transpose(op)
    @test nprod(opᵀ) == ntprod(op)
    @test ntprod(opᵀ) == nprod(op)
    @test nctprod(opᵀ) == nprod(op)

    opᴴ = op'
    @test nprod(opᴴ) == nctprod(op)
    @test ntprod(opᴴ) == nprod(op)
    @test nctprod(opᴴ) == nprod(op)

    reset!(op)
    @test nprod(op) == 0
    @test ntprod(op) == 0
    @test nctprod(op) == 0
  end

  @testset ExtendedTestSet "Timers" begin
    op = LinearOperator(rand(3, 4) + im * rand(3, 4))
    top = TimedLinearOperator(op)
    show(top)
    nprods = 5
    ntprods = 4
    nctprods = 7
    for _ = 1:nprods
      op * rand(4)
    end
    for _ = 1:nprods
      conj(op) * rand(4)
    end
    for _ = 1:ntprods
      transpose(op) * rand(3)
    end
    for _ = 1:nctprods
      op' * rand(3)
    end
    for fn ∈ (:size, :issymmetric, :ishermitian, :nprod, :ntprod, :nctprod)
      @eval begin
        @test $fn($top) == $fn($top.op)
      end
    end

    reset!(op)
    reset!(top)

    top2 = TimedLinearOperator(op')  # the same as top'
    nrow, ncol = size(op)
    u = rand(nrow) + im * rand(nrow)
    @test all(top' * u .== top2 * u)
    v = rand(ncol) + im * rand(ncol)
    @test all(top * v .== top2' * v)

    top3 = TimedLinearOperator(transpose(op))  # the same as transpose(top)
    nrow, ncol = size(op)
    u = rand(nrow) + im * rand(nrow)
    @test all(transpose(top) * u .== top3 * u)
    v = rand(ncol) + im * rand(ncol)
    @test all(top * v .== transpose(top3) * v)
  end

  @testset ExtendedTestSet "BlockDiagonal" begin
    A = rand(3, 4) + im * rand(3, 4)
    B = rand(3, 3) + im * rand(3, 3)
    C = rand(4, 2) + im * rand(4, 2)
    D = [
      A zeros(3, 3) zeros(3, 2)
      zeros(3, 4) B zeros(3, 2)
      zeros(4, 4) zeros(4, 3) C
    ]
    M = BlockDiagonalOperator(LinearOperator.((A, B, C))...)
    @test size(M, 1) == size(A, 1) + size(B, 1) + size(C, 1)
    @test size(M, 2) == size(A, 2) + size(B, 2) + size(C, 2)
    @test norm(Matrix(M) - D) ≤ sqrt(eps()) * norm(D)
    @test norm(Matrix(transpose(M)) - transpose(D)) ≤ sqrt(eps()) * norm(D)
    @test norm(Matrix(M') - D') ≤ sqrt(eps()) * norm(D)

    M = BlockDiagonalOperator(A, B, C)
    @test size(M, 1) == size(A, 1) + size(B, 1) + size(C, 1)
    @test size(M, 2) == size(A, 2) + size(B, 2) + size(C, 2)
    @test norm(Matrix(M) - D) ≤ sqrt(eps()) * norm(D)
    @test norm(Matrix(transpose(M)) - transpose(D)) ≤ sqrt(eps()) * norm(D)
    @test norm(Matrix(M') - D') ≤ sqrt(eps()) * norm(D)

    F = cholesky([2.0 0.0 0.0; 0.0 4.0 0.0; 0.0 0.0 8.0])
    A = LinearOperator(Float64, 3, 3, true, true, (y, v) -> ldiv!(y, F, v))
    B = rand(4, 2)
    C = sprand(2, 4, 0.5)
    D = [
      Diagonal([0.5; 0.25; 0.125]) zeros(3, 2) zeros(3, 4)
      zeros(4, 3) B zeros(4, 4)
      zeros(2, 3) zeros(2, 2) C
    ]
    M = BlockDiagonalOperator(A, B, C)
    @test size(M, 1) == size(A, 1) + size(B, 1) + size(C, 1)
    @test size(M, 2) == size(A, 2) + size(B, 2) + size(C, 2)
    @test norm(Matrix(M) - D) ≤ sqrt(eps()) * norm(D)
    @test norm(Matrix(transpose(M)) - transpose(D)) ≤ sqrt(eps()) * norm(D)
    @test norm(Matrix(M') - D') ≤ sqrt(eps()) * norm(D)
  end

  # Issue #139
  @testset ExtendedTestSet "Matrix-vector products with SparseMatrix and SparseVector" begin
    A = sprand(10, 10, 0.2)
    b = sprand(10, 0.2)
    opA = LinearOperator(A)
    @test opA * b == A * b
    @test transpose(opA) * b == transpose(A) * b
    @test adjoint(opA) * b == adjoint(A) * b
  end

  @testset ExtendedTestSet "3-args" begin
    for T in [Float64, Complex{Float64}]
      A = rand(T, 12, 10)
      b = rand(T, 10)
      prod! = (res, v) -> mul!(res, A, v)
      tprod! = (T == Float64) ? (res, v) -> mul!(res, transpose(A), v) : nothing
      ctprod! = (T == Float64) ? nothing : (res, v) -> mul!(res, adjoint(A), v)
      opA = LinearOperator(T, 12, 10, false, false, prod!, tprod!, ctprod!)
      @test has_args5(opA) == false
      @test opA * b == A * b
      res = rand(T, 12)
      mul!(res, opA, b)
      @test res == A * b
      for (α, β) in [(2.0, 3.0), (1.0, 3.0), (2.0, 0.0)]
        res2 = copy(res)
        mul!(res, opA, b, α, β)
        @test res == α * A * b + β * res2
        c, res3 = rand(T, 12), rand(T, 10)
        res4 = copy(res3)
        mul!(res3, transpose(opA), c, α, β)
        @test norm(α * transpose(A) * c + β * res4 - res3) ≤ sqrt(eps())
        @test transpose(A) * c == transpose(opA) * c
        res4 = copy(res3)
        mul!(res3, opA', c, α, β)
        @test norm(α * A' * c + β * res4 - res3) ≤ sqrt(eps())
        @test A' * c == opA' * c
      end
    end

    # test with operators created from other operators
    T = Float64
    for operation in [:+, :-, :vcat, :hcat]
      A1 = rand(T, 12, 10)
      A2 = rand(T, 12, 10)
      prod1! = (res, v) -> mul!(res, A1, v)
      tprod1! = (res, v) -> mul!(res, transpose(A1), v)
      prod2! = (res, v) -> mul!(res, A2, v)
      tprod2! = (res, v) -> mul!(res, transpose(A2), v)
      opA1 = LinearOperator(T, 12, 10, false, false, prod1!, tprod1!)
      opA2 = LinearOperator(T, 12, 10, false, false, prod2!, tprod2!)
      opA = eval(operation)(opA1, opA2)
      b = rand(T, opA.ncol)
      @test isallocated5(opA1) == isallocated5(opA2) == false
      @test norm(opA * b - eval(operation)(A1, A2) * b) ≤ sqrt(eps())
      α, β = 2.0, 3.0
      res = rand(T, opA.nrow)
      res2 = copy(res)
      mul!(res, opA, b, α, β)
      @test norm(res - (α * eval(operation)(A1, A2) * b + β * res2)) ≤ sqrt(eps())
      @test isallocated5(opA1) == isallocated5(opA2) == true
    end
    # blockdiag
    A1 = rand(T, 10, 10)
    A2 = rand(T, 10, 10)
    A = [
      A1 zeros(T, 10, 10)
      zeros(T, 10, 10) A2
    ]
    b = rand(T, 20)
    prod1! = (res, v) -> mul!(res, A1, v)
    tprod1! = (res, v) -> mul!(res, transpose(A1), v)
    prod2! = (res, v) -> mul!(res, A2, v)
    tprod2! = (res, v) -> mul!(res, transpose(A2), v)
    opA1 = LinearOperator(T, 10, 10, false, false, prod1!, tprod1!)
    opA2 = LinearOperator(T, 10, 10, false, false, prod2!, tprod2!)
    opA = BlockDiagonalOperator(opA1, opA2)
    @test isallocated5(opA1) == isallocated5(opA2) == false
    @test norm(opA * b - A * b) ≤ sqrt(eps())
    α, β = 2.0, 3.0
    res = rand(T, 20)
    res2 = copy(res)
    mul!(res, opA, b, α, β)
    @test norm(res - (α * A * b + β * res2)) ≤ sqrt(eps())
    @test isallocated5(opA1) == isallocated5(opA2) == true
    # -op
    A1 = rand(T, 12, 10)
    b = rand(T, 10)
    prod1! = (res, v) -> mul!(res, A1, v)
    tprod1! = (res, v) -> mul!(res, transpose(A1), v)
    opA1 = LinearOperator(T, 12, 10, false, false, prod1!, tprod1!)
    opA = -opA1
    @test isallocated5(opA1) == false
    @test norm(opA * b + A1 * b) ≤ sqrt(eps())
    α, β = 2.0, 3.0
    res = rand(T, 12)
    res2 = copy(res)
    mul!(res, opA, b, α, β)
    @test norm(res - (-α * A1 * b + β * res2)) ≤ sqrt(eps())
    @test isallocated5(opA1) == true
    # x * op
    A1 = rand(T, 12, 10)
    b = rand(T, 10)
    prod1! = (res, v) -> mul!(res, A1, v)
    tprod1! = (res, v) -> mul!(res, transpose(A1), v)
    opA1 = LinearOperator(T, 12, 10, false, false, prod1!, tprod1!)
    x = 4.0
    opA = x * opA1
    @test isallocated5(opA1) == false
    @test norm(opA * b - x * A1 * b) ≤ sqrt(eps())
    α, β = 2.0, 3.0
    res = rand(T, 12)
    res2 = copy(res)
    mul!(res, opA, b, α, β)
    @test norm(res - (α * x * A1 * b + β * res2)) ≤ sqrt(eps())
    @test isallocated5(opA1) == true

    # test symmetric
    A0 = rand(T, 10, 10)
    A = A0 + A0'
    b = rand(T, 10)
    prod! = (res, v) -> mul!(res, A, v)
    tprod! = (res, v) -> mul!(res, transpose(A), v)
    opA = LinearOperator(T, 10, 10, true, true, prod!, tprod!)
    res = rand(T, 10)
    mul!(res, opA, b)
    @test res == A * b
    α, β = 2.0, 3.0
    res2 = copy(res)
    mul!(res, opA, b, α, β)
    @test res == α * A * b + β * res2
    c, res3 = rand(T, 10), rand(T, 10)
    mul!(res3, opA', c)
    @test norm(res3 - A' * c) ≤ sqrt(eps())
  end
end

test_linop()

function test_cat()
  ϵ = eps(Float64)
  rtol = sqrt(ϵ)
  @testset ExtendedTestSet "Concatenation" begin
    A = simple_sparse_matrix(ComplexF64, 100, 100)
    B = simple_matrix(ComplexF64, 100, 10)
    C = simple_matrix(ComplexF64, 100, 90)
    D = [A B C]
    Ao = LinearOperator(A)
    Bo = LinearOperator(B)
    Co = LinearOperator(C)
    Do = [Ao Bo Co]
    Do2 = LinearOperator(D)
    rhs = simple_vector(ComplexF64, 200)
    rhs2 = simple_vector(ComplexF64, 100)

    @test(norm(Do * rhs - D * rhs) <= rtol * norm(D * rhs))  # throws InexactError()
    @test(norm(Do2 * rhs - D * rhs) <= rtol * norm(D * rhs))
    @test(norm(transpose(Do) * rhs2 - transpose(D) * rhs2) <= rtol * norm(transpose(D) * rhs2))
    @test(norm(adjoint(Do) * rhs2 - adjoint(D) * rhs2) <= rtol * norm(adjoint(D) * rhs2))

    @test_throws LinearOperatorException [LinearOperator(ones(5, 5)) opEye(3)]

    # test vcat
    A = simple_sparse_matrix(ComplexF64, 100, 100)
    B = simple_matrix(ComplexF64, 10, 100)
    C = simple_matrix(ComplexF64, 90, 100)
    D = [A; B; C]
    Ao = LinearOperator(A)
    Bo = LinearOperator(B)
    Co = LinearOperator(C)
    Do = [Ao; Bo; Co]
    Do2 = LinearOperator(D)
    rhs = simple_vector(ComplexF64, 100)
    rhs2 = simple_vector(ComplexF64, 200)

    @test(norm(Do * rhs - D * rhs) <= rtol * norm(D * rhs))
    @test(norm(Do2 * rhs - D * rhs) <= rtol * norm(D * rhs))
    @test(norm(transpose(Do) * rhs2 - transpose(D) * rhs2) <= rtol * norm(transpose(D) * rhs2))
    @test(norm(adjoint(Do) * rhs2 - adjoint(D) * rhs2) <= rtol * norm(adjoint(D) * rhs2))

    @test_throws LinearOperatorException [LinearOperator(ones(5, 5)); opEye(3)]
    K = [opEye(2) opZeros(2, 3); opZeros(3, 2) opEye(3)]
    v = simple_vector(Float64, 5)
    @test all(v .== K * v)

    K = [opEye(2); sparse(1.0I, 2, 2)]
    v = simple_vector(Float64, 2)
    @test all(K * v .== [v; v])
  end
  @testset ExtendedTestSet "Concatenation 3-args" begin
    T = Complex{Float64}
    A = simple_sparse_matrix(T, 100, 100)
    B = simple_matrix(T, 100, 10)
    C = simple_matrix(T, 100, 90)
    D = [A B C]
    Ao = LinearOperator(
      T,
      100,
      100,
      false,
      false,
      (res, v) -> mul!(res, A, v),
      (res, u) -> mul!(res, transpose(A), u),
      (res, w) -> mul!(res, adjoint(A), w),
    )
    Bo = LinearOperator(
      T,
      size(B)...,
      false,
      false,
      (res, v) -> mul!(res, B, v),
      (res, u) -> mul!(res, transpose(B), u),
      (res, w) -> mul!(res, adjoint(B), w),
    )
    Co = LinearOperator(
      T,
      size(C)...,
      false,
      false,
      (res, v) -> mul!(res, C, v),
      (res, u) -> mul!(res, transpose(C), u),
      (res, w) -> mul!(res, adjoint(C), w),
    )
    Do = [Ao Bo Co]
    Do2 = LinearOperator(D)
    rhs = simple_vector(T, 200)
    rhs2 = simple_vector(T, 100)
    @test(norm(Do * rhs - D * rhs) <= rtol * norm(D * rhs))  # throws InexactError()
    @test(norm(Do2 * rhs - D * rhs) <= rtol * norm(D * rhs))
    @test(norm(transpose(Do) * rhs2 - transpose(D) * rhs2) <= rtol * norm(transpose(D) * rhs2))
    @test(norm(adjoint(Do) * rhs2 - adjoint(D) * rhs2) <= rtol * norm(adjoint(D) * rhs2))

    @test_throws LinearOperatorException [LinearOperator(ones(5, 5)) opEye(3)]

    # 5-args mul! hcat
    α, β = 3.0, -4.0
    resD = rand(T, 100)
    resDo, resDo2 = copy(resD), copy(resD)
    mul!(resD, D, rhs, α, β)
    mul!(resDo, Do, rhs, α, β)
    mul!(resDo2, Do2, rhs, α, β)
    @test(norm(resD - resDo) <= rtol * norm(resD))
    @test(norm(resD - resDo2) <= rtol * norm(resD))
    resD = rand(T, 200)
    resDo, resDo2 = copy(resD), copy(resD)
    mul!(resD, transpose(D), rhs2, α, β)
    mul!(resDo, transpose(Do), rhs2, α, β)
    mul!(resDo2, transpose(Do2), rhs2, α, β)
    @test(norm(resD - resDo) <= rtol * norm(resD))
    @test(norm(resD - resDo2) <= rtol * norm(resD))
    resD = rand(T, 200)
    resDo, resDo2 = copy(resD), copy(resD)
    mul!(resD, adjoint(D), rhs2, α, β)
    mul!(resDo, adjoint(Do), rhs2, α, β)
    mul!(resDo2, adjoint(Do2), rhs2, α, β)
    @test(norm(resD - resDo) <= rtol * norm(resD))
    @test(norm(resD - resDo2) <= rtol * norm(resD))

    # test vcat
    A = simple_sparse_matrix(T, 100, 100)
    B = simple_matrix(T, 10, 100)
    C = simple_matrix(T, 90, 100)
    D = [A; B; C]
    Ao = LinearOperator(
      T,
      100,
      100,
      false,
      false,
      (res, v) -> mul!(res, A, v),
      (res, u) -> mul!(res, transpose(A), u),
      (res, w) -> mul!(res, adjoint(A), w),
    )
    Bo = LinearOperator(
      T,
      size(B)...,
      false,
      false,
      (res, v) -> mul!(res, B, v),
      (res, u) -> mul!(res, transpose(B), u),
      (res, w) -> mul!(res, adjoint(B), w),
    )
    Co = LinearOperator(
      T,
      size(C)...,
      false,
      false,
      (res, v) -> mul!(res, C, v),
      (res, u) -> mul!(res, transpose(C), u),
      (res, w) -> mul!(res, adjoint(C), w),
    )
    Do = [Ao; Bo; Co]
    Do2 = LinearOperator(D)
    rhs = simple_vector(T, 100)
    rhs2 = simple_vector(T, 200)

    @test(norm(Do * rhs - D * rhs) <= rtol * norm(D * rhs))
    @test(norm(Do2 * rhs - D * rhs) <= rtol * norm(D * rhs))
    @test(norm(transpose(Do) * rhs2 - transpose(D) * rhs2) <= rtol * norm(transpose(D) * rhs2))
    @test(norm(adjoint(Do) * rhs2 - adjoint(D) * rhs2) <= rtol * norm(adjoint(D) * rhs2))

    @test_throws LinearOperatorException [LinearOperator(ones(5, 5)); opEye(3)]

    # 5-args mul! hcat
    α, β = 3.0, -4.0
    resD = rand(T, 200)
    resDo, resDo2 = copy(resD), copy(resD)
    mul!(resD, D, rhs, α, β)
    mul!(resDo, Do, rhs, α, β)
    mul!(resDo2, Do2, rhs, α, β)
    @test(norm(resD - resDo) <= rtol * norm(resD))
    @test(norm(resD - resDo2) <= rtol * norm(resD))
    resD = rand(T, 100)
    resDo, resDo2 = copy(resD), copy(resD)
    mul!(resD, transpose(D), rhs2, α, β)
    mul!(resDo, transpose(Do), rhs2, α, β)
    mul!(resDo2, transpose(Do2), rhs2, α, β)
    @test(norm(resD - resDo) <= rtol * norm(resD))
    @test(norm(resD - resDo2) <= rtol * norm(resD))
    resD = rand(T, 100)
    resDo, resDo2 = copy(resD), copy(resD)
    mul!(resD, adjoint(D), rhs2, α, β)
    mul!(resDo, adjoint(Do), rhs2, α, β)
    mul!(resDo2, adjoint(Do2), rhs2, α, β)
    @test(norm(resD - resDo) <= rtol * norm(resD))
    @test(norm(resD - resDo2) <= rtol * norm(resD))

    K = [opEye(2) opZeros(2, 3); opZeros(3, 2) opEye(3)]
    v = simple_vector(Float64, 5)
    @test all(v .== K * v)

    K = [opEye(2); sparse(1.0I, 2, 2)]
    v = simple_vector(Float64, 2)
    @test all(K * v .== [v; v])
  end
end

test_cat()

import Base.transpose, Base.adjoint, Base.conj

export AdjointLinearOperator,
  TransposeLinearOperator, ConjugateLinearOperator, adjoint, transpose, conj

# From julialang:stdlib/LinearAlgebra/src/adjtrans.jl
struct AdjointLinearOperator{T, S} <: AbstractLinearOperator{T}
  parent::S
  function AdjointLinearOperator{T, S}(A::S) where {T, S}
    new(A)
  end
end

struct TransposeLinearOperator{T, S} <: AbstractLinearOperator{T}
  parent::S
  function TransposeLinearOperator{T, S}(A::S) where {T, S}
    new(A)
  end
end

struct ConjugateLinearOperator{T, S} <: AbstractLinearOperator{T}
  parent::S
  function ConjugateLinearOperator{T, S}(A::S) where {T, S}
    new(A)
  end
end

AdjointLinearOperator(A) = AdjointLinearOperator{eltype(A), typeof(A)}(A)
TransposeLinearOperator(A) = TransposeLinearOperator{eltype(A), typeof(A)}(A)
ConjugateLinearOperator(A) = ConjugateLinearOperator{eltype(A), typeof(A)}(A)

adjoint(A::AbstractLinearOperator) = AdjointLinearOperator(A)
adjoint(A::AdjointLinearOperator) = A.parent
transpose(A::AbstractLinearOperator) = TransposeLinearOperator(A)
transpose(A::TransposeLinearOperator) = A.parent
conj(A::AbstractLinearOperator) = ConjugateLinearOperator(A)
conj(A::ConjugateLinearOperator) = A.parent

adjoint(A::ConjugateLinearOperator) = transpose(A.parent)
adjoint(A::TransposeLinearOperator) = conj(A.parent)
conj(A::AdjointLinearOperator) = transpose(A.parent)
conj(A::TransposeLinearOperator) = adjoint(A.parent)
transpose(A::AdjointLinearOperator) = conj(A.parent)
transpose(A::ConjugateLinearOperator) = adjoint(A.parent)

nprod(A::AdjointLinearOperator) = nctprod(A.parent)
ntprod(A::AdjointLinearOperator) = nprod(A.parent)   # transpose(A') = conj(A)
nctprod(A::AdjointLinearOperator) = nprod(A.parent)  # (A')' == A

nprod(A::TransposeLinearOperator) = ntprod(A.parent)
ntprod(A::TransposeLinearOperator) = nprod(A.parent)
nctprod(A::TransposeLinearOperator) = nprod(A.parent)  # (transpose(A))' = conj(A)

for f in [:nprod, :ntprod, :nctprod, :increase_nprod!, :increase_ntprod!, :increase_nctprod!]
  @eval begin
    $f(A::ConjugateLinearOperator) = $f(A.parent)
  end
end

const AdjTrans = Union{AdjointLinearOperator, TransposeLinearOperator}

size(A::AdjTrans) = reverse(size(A.parent))
size(A::AdjTrans, d::Int) = size(A.parent, 3 - d)
size(A::ConjugateLinearOperator) = size(A.parent)
size(A::ConjugateLinearOperator, d::Int) = size(A.parent, d)

for f in
    [:ishermitian, :issymmetric, :has_args5, :isallocated5, :allocate_vectors_args3!, :storage_type]
  @eval begin
    $f(A::AdjTrans) = $f(A.parent)
    $f(A::ConjugateLinearOperator) = $f(A.parent)
  end
end

function show(io::IO, op::AdjointLinearOperator)
  println(io, "Adjoint of the following LinearOperator:")
  show(io, op.parent)
end

function show(io::IO, op::TransposeLinearOperator)
  println(io, "Transpose of the following LinearOperator:")
  show(io, op.parent)
end

function show(io::IO, op::ConjugateLinearOperator)
  println(io, "Conjugate of the following LinearOperator:")
  show(io, op.parent)
end

function mul!(
  res::AbstractVector,
  op::AdjointLinearOperator{T, S},
  v::AbstractVector,
  α,
  β,
) where {T, S}
  p = op.parent
  (length(v) == size(p, 1) && length(res) == size(p, 2)) ||
    throw(LinearOperatorException("shape mismatch"))
  if ishermitian(p)
    return mul!(res, p, v, α, β)
  end
  ctprod! = p.ctprod!
  if ctprod! !== nothing
    increase_nctprod!(p)
    if hasmethod(ctprod!, Tuple{typeof(res), typeof(v), typeof(α), typeof(β)})
      return ctprod!(res, v, α, β)
    else
      iszero(β) || !isempty(p.Mtu) || allocate_vectors_args3!(p)
      return prod3!(res, ctprod!, v, α, β, p.Mtu)
    end
  end
  tprod! = p.tprod!
  increment_tprod = true
  if p.tprod! === nothing
    if issymmetric(p)
      increment_tprod = false
      tprod! = p.prod!
    else
      throw(LinearOperatorException("unable to infer conjugate transpose operator"))
    end
  end
  if increment_tprod
    increase_ntprod!(p)
  else
    increase_nprod!(p)
  end
  conj!(res)
  vc = eltype(v) <: Real ? v : conj.(v)  # avoid unnecessary allocations if v has real elements
  if hasmethod(tprod!, Tuple{typeof(res), typeof(v), typeof(α), typeof(β)})
    tprod!(res, vc, conj(α), conj(β))
  else
    iszero(β) || !isempty(p.Mtu) || allocate_vectors_args3!(p)
    prod3!(res, tprod!, vc, conj(α), conj(β), p.Mtu)
  end
  conj!(res)
end

function mul!(
  res::AbstractMatrix,
  op::AdjointLinearOperator{T, S},
  m::AbstractMatrix,
  α,
  β,
) where {T, S}
  p = op.parent
  (size(m, 1) == size(p, 1) && size(res, 1) == size(p, 2) && size(m, 2) == size(res, 2)) ||
    throw(LinearOperatorException("shape mismatch"))
  if ishermitian(p)
    return mul!(res, p, m, α, β)
  elseif p.ctprod! !== nothing
    return p.ctprod!(res, m, α, β)
  else
    error("Not implemented")
  end
end

function mul!(
  res::AbstractVector,
  op::TransposeLinearOperator{T, S},
  v::AbstractVector,
  α,
  β,
) where {T, S}
  p = op.parent
  (length(v) == size(p, 1) && length(res) == size(p, 2)) ||
    throw(LinearOperatorException("shape mismatch"))
  if issymmetric(p)
    return mul!(res, p, v, α, β)
  end
  tprod! = p.tprod!
  if tprod! !== nothing
    increase_ntprod!(p)
    if hasmethod(tprod!, Tuple{typeof(res), typeof(v), typeof(α), typeof(β)})
      return tprod!(res, v, α, β)
    else
      iszero(β) || !isempty(p.Mtu) || allocate_vectors_args3!(p)
      return prod3!(res, tprod!, v, α, β, p.Mtu)
    end
  end
  increment_ctprod = true
  ctprod! = p.ctprod!
  if ctprod! === nothing
    if ishermitian(p)
      increment_ctprod = false
      ctprod! = p.prod!
    else
      throw(LinearOperatorException("unable to infer transpose operator"))
    end
  end
  if increment_ctprod
    increase_nctprod!(p)
  else
    increase_nprod!(p)
  end
  conj!(res)
  vc = eltype(v) <: Real ? v : conj.(v)  # avoid unnecessary allocations when v has real elements
  if hasmethod(ctprod!, Tuple{typeof(res), typeof(v), typeof(α), typeof(β)})
    ctprod!(res, vc, conj(α), conj(β))
  else
    iszero(β) || !isempty(p.Mtu) || allocate_vectors_args3!(p)
    prod3!(res, ctprod!, vc, conj(α), conj(β), p.Mtu)
  end
  conj!(res)
end

function mul!(
  res::AbstractMatrix,
  op::TransposeLinearOperator{T, S},
  m::AbstractMatrix,
  α,
  β,
) where {T, S}
  p = op.parent
  (size(m, 1) == size(p, 1) && size(res, 1) == size(p, 2) && size(m, 2) == size(res, 2)) ||
    throw(LinearOperatorException("shape mismatch"))
  if issymmetric(p)
    return mul!(res, p, m, α, β)
  elseif p.tprod! !== nothing
    return p.tprod!(res, m, α, β)
  else
    error("Not implemented")
  end
end

function mul!(
  res::AbstractVector,
  op::ConjugateLinearOperator{T, S},
  v::AbstractVector,
  α,
  β,
) where {T, S}
  p = op.parent
  vc = eltype(v) <: Real ? v : conj.(v)  # avoid unnecessary allocations if v has real elements
  mul!(res, p, vc, α, β)
  conj!(res)
end

function mul!(
  res::AbstractVector,
  op::ConjugateLinearOperator{T, S},
  v::AbstractVector{<:Real},
  α,
  β,
) where {T, S}
  p = op.parent
  mul!(res, p, v, α, β)   # we can skip `conj.(v)` since it has real elements (this avoids unnecessary allocations)
  conj!(res)
end

function mul!(
  res::AbstractMatrix,
  op::ConjugateLinearOperator{T, S},
  v::AbstractMatrix,
  α,
  β,
) where {T, S}
  p = op.parent
  mul!(res, p, conj.(v), α, β)
  conj!(res)
end

-(op::AdjointLinearOperator) = adjoint(-op.parent)
-(op::TransposeLinearOperator) = transpose(-op.parent)
-(op::ConjugateLinearOperator) = conj(-op.parent)

*(op::AdjointLinearOperator, x::Number) = adjoint(op.parent * conj(x))
*(op::TransposeLinearOperator, x::Number) = transpose(op.parent * x)
*(op::ConjugateLinearOperator, x::Number) = conj(op.parent * conj(x))

*(x::Number, op::AdjointLinearOperator) = adjoint(conj(x) * op.parent)
*(x::Number, op::TransposeLinearOperator) = transpose(x * op.parent)
*(x::Number, op::ConjugateLinearOperator) = conj(conj(x) * op.parent)

using Test, LinearAlgebra, SparseArrays
using LinearOperators, AMDGPU

@testset "AMDGPU -- AMDGPU.jl" begin
  A = ROCArray(rand(Float32, 5, 5))
  B = ROCArray(rand(Float32, 10, 10))
  C = ROCArray(rand(Float32, 20, 20))
  M = BlockDiagonalOperator(A, B, C)

  v = ROCArray(rand(Float32, 35))
  y = M * v
  @test y isa ROCArray{Float32}

  @test LinearOperators.storage_type(A) == LinearOperators.storage_type(adjoint(A))
  @test LinearOperators.storage_type(A) == LinearOperators.storage_type(transpose(A))
  @test LinearOperators.storage_type(A) == LinearOperators.storage_type(adjoint(A))
  @test LinearOperators.storage_type(Diagonal(v)) == typeof(v)

  @testset "AMDGPU S kwarg" test_S_kwarg(arrayType = ROCArray)
end

using LinearAlgebra, SparseArrays

function simple_matrix(T::Type, nrow::Int, ncol::Int; symmetric::Bool = false)
  symmetric && @assert nrow == ncol
  if nrow == ncol == 1
    return ones(T, nrow, ncol)
  end
  U, _ = qr(rand(T, nrow, nrow))
  local V
  if symmetric
    V = U
  else
    V, _ = qr(rand(T, ncol, ncol))
  end
  S = T[(1 + (i - 1) / (nrow - 1)) * (i == j) for i = 1:nrow, j = 1:ncol]
  return U * S * V'
end

function simple_sparse_matrix(T::Type, nrow::Int, ncol::Int; symmetric::Bool = false)
  m = min(nrow, ncol)
  p = floor(Int, sqrt(m))
  q = div(m, p)
  M = kron(Matrix(I, q, q), simple_matrix(T, p, p, symmetric = symmetric))
  pq = p * q
  R = if m > pq
    simple_matrix(T, nrow - pq, ncol - pq, symmetric = symmetric)
  else
    spzeros(nrow - pq, ncol - pq)
  end
  A = [sparse(M) spzeros(pq, ncol - pq); spzeros(nrow - pq, pq) R]
end

simple_vector(T::Type, n::Int) = T[-(-one(T))^i for i = 1:n]

import Base.+, Base.-, Base.*, Base./, LinearAlgebra.mul!

function allocate_vectors_args3!(op::AbstractLinearOperator)
  S = storage_type(op)
  op.Mv = S(undef, op.nrow)
  op.Mtu = (op.nrow == op.ncol) ? op.Mv : S(undef, op.ncol)
  return op
end

function prod3!(res, prod!, v, α, β, Mv)
  if iszero(β)
    prod!(res, v)
    if α != 1
      res .*= α
    end
  else
    prod!(Mv, v)
    res .= α .* Mv .+ β .* res
  end
end

function mul!(res::AbstractVector, op::AbstractLinearOperator{T}, v::AbstractVector, α, β) where {T}
  (size(v, 1) == size(op, 2) && size(res, 1) == size(op, 1)) ||
    throw(LinearOperatorException("shape mismatch"))
  increase_nprod!(op)
  if hasmethod(op.prod!, Tuple{typeof(res), typeof(v), typeof(α), typeof(β)})
    op.prod!(res, v, α, β)
  else
    iszero(β) || !isempty(op.Mv) || allocate_vectors_args3!(op)
    prod3!(res, op.prod!, v, α, β, op.Mv)
  end
end

function mul!(res::AbstractMatrix, op::AbstractLinearOperator, m::AbstractMatrix{T}, α, β) where {T}
  op.prod!(res, m, α, β)
end

function mul!(res::AbstractVecOrMat, op::AbstractLinearOperator, v::AbstractVecOrMat{T}) where {T}
  mul!(res, op, v, one(T), zero(T))
end

# Apply an operator to a vector.
function *(op::AbstractLinearOperator{T}, v::AbstractVector{S}) where {T, S}
  nrow, ncol = size(op)
  res = similar(v, promote_type(T, S), nrow)
  mul!(res, op, v)
  return res
end

function mul!(
  res::Adjoint{S1, V1},
  v::Adjoint{S2, V2},
  op::AbstractLinearOperator{T},
) where {T, S1, S2, V1 <: AbstractVector{S1}, V2 <: AbstractVector{S2}}
  mul!(adjoint(res), adjoint(op), adjoint(v))
  return res
end

function mul!(
  res::Transpose{S1, V1},
  v::Transpose{S2, V2},
  op::AbstractLinearOperator{T},
) where {T, S1, S2, V1 <: AbstractVector{S1}, V2 <: AbstractVector{S2}}
  mul!(transpose(res), transpose(op), transpose(v))
  return res
end

function *(
  v::Union{Transpose{S, V}, Adjoint{S, V}},
  op::AbstractLinearOperator{T},
) where {T, S, V <: AbstractVector{S}}
  nrow, ncol = size(op)
  res = similar(v.parent, promote_type(T, S), ncol)
  v_wrapper = typeof(v).name.wrapper
  mul!(v_wrapper(res), v, op)
  return v_wrapper(res)
end

# Apply an operator to a matrix (only in-place, since operator * matrix is a matrix).

function mul!(
  res::Adjoint{S1, M1},
  m::Adjoint{S2, M2},
  op::AbstractLinearOperator{T},
) where {T, S1, S2, M1 <: AbstractMatrix{S1}, M2 <: AbstractMatrix{S2}}
  mul!(adjoint(res), adjoint(op), adjoint(m))
  return res
end

function mul!(
  res::Transpose{S1, M1},
  m::Transpose{S2, M2},
  op::AbstractLinearOperator{T},
) where {T, S1, S2, M1 <: AbstractMatrix{S1}, M2 <: AbstractMatrix{S2}}
  mul!(transpose(res), transpose(op), transpose(m))
  return res
end

# Unary operations.
+(op::AbstractLinearOperator) = op

function -(op::AbstractLinearOperator{T}) where {T}
  prod! = @closure (res, v, α, β) -> mul!(res, op, v, -α, β)
  tprod! = @closure (res, u, α, β) -> mul!(res, transpose(op), u, -α, β)
  ctprod! = @closure (res, w, α, β) -> mul!(res, adjoint(op), w, -α, β)
  LinearOperator{T, storage_type(op)}(
    op.nrow,
    op.ncol,
    op.symmetric,
    op.hermitian,
    prod!,
    tprod!,
    ctprod!,
  )
end

function prod_op!(
  res::AbstractVecOrMat,
  op1::AbstractLinearOperator,
  op2::AbstractLinearOperator,
  vtmp::AbstractVecOrMat,
  v::AbstractVecOrMat,
  α,
  β,
)
  mul!(vtmp, op2, v)
  mul!(res, op1, vtmp, α, β)
end

## Operator times operator.
function *(op1::AbstractLinearOperator, op2::AbstractLinearOperator)
  T = promote_type(eltype(op1), eltype(op2))
  (m1, n1) = size(op1)
  (m2, n2) = size(op2)
  if m2 != n1
    throw(LinearOperatorException("shape mismatch"))
  end
  S = promote_type(storage_type(op1), storage_type(op2))
  if !isconcretetype(S)
    throw(
      LinearOperatorException(
        "storage types $(storage_type(op1)) and $(storage_type(op2)) " *
        "cannot be promoted to a concrete type. " *
        "Ensure both operators use compatible storage types (e.g., both GPU or both CPU).",
      ),
    )
  end
  #tmp vector for products
  vtmp = fill!(S(undef, m2), zero(T))
  utmp = fill!(S(undef, n1), zero(T))
  wtmp = fill!(S(undef, n1), zero(T))
  prod! = @closure (res, v, α, β) -> prod_op!(res, op1, op2, vtmp, v, α, β)
  tprod! = @closure (res, u, α, β) -> prod_op!(res, transpose(op2), transpose(op1), utmp, u, α, β)
  ctprod! = @closure (res, w, α, β) -> prod_op!(res, adjoint(op2), adjoint(op1), wtmp, w, α, β)
  LinearOperator{T, S}(m1, n2, false, false, prod!, tprod!, ctprod!)
end

## Matrix times operator.
*(M::AbstractMatrix, op::AbstractLinearOperator) = LinearOperator(M) * op
*(op::AbstractLinearOperator, M::AbstractMatrix) = op * LinearOperator(M)

## Scalar times operator. (# commutation α*v ???)
function *(op::AbstractLinearOperator, x::Number)
  T = promote_type(eltype(op), typeof(x))
  prod! = @closure (res, v, α, β) -> mul!(res, op, v, x * α, β)
  tprod! = @closure (res, u, α, β) -> mul!(res, transpose(op), u, x * α, β)
  ctprod! = @closure (res, w, α, β) -> mul!(res, adjoint(op), w, x' * α, β)
  LinearOperator{T, storage_type(op)}(
    op.nrow,
    op.ncol,
    op.symmetric,
    op.hermitian && isreal(x),
    prod!,
    tprod!,
    ctprod!,
  )
end

function *(x::Number, op::AbstractLinearOperator)
  return op * x
end

/(op::AbstractLinearOperator{T}, x::Number) where {T} = op * (one(T) / x)

# Operator + operator.

function sum_prod!(
  res::AbstractVecOrMat,
  op1::AbstractLinearOperator,
  op2::AbstractLinearOperator{T},
  v::AbstractVecOrMat,
  α,
  β,
) where {T}
  mul!(res, op1, v, α, β)
  mul!(res, op2, v, α, one(T))
end

function +(op1::AbstractLinearOperator, op2::AbstractLinearOperator)
  (m1, n1) = size(op1)
  (m2, n2) = size(op2)
  if (m1 != m2) || (n1 != n2)
    throw(LinearOperatorException("shape mismatch"))
  end
  T = promote_type(eltype(op1), eltype(op2))
  prod! = @closure (res, v, α, β) -> sum_prod!(res, op1, op2, v, α, β)
  tprod! = @closure (res, u, α, β) -> sum_prod!(res, transpose(op1), transpose(op2), u, α, β)
  ctprod! = @closure (res, w, α, β) -> sum_prod!(res, adjoint(op1), adjoint(op2), w, α, β)
  symm = (issymmetric(op1) && issymmetric(op2))
  herm = (ishermitian(op1) && ishermitian(op2))
  S = promote_type(storage_type(op1), storage_type(op2))
  isconcretetype(S) ||
    throw(LinearOperatorException("storage types cannot be promoted to a concrete type"))
  return LinearOperator{T, S}(m1, n1, symm, herm, prod!, tprod!, ctprod!)
end

# Operator + matrix.
+(M::AbstractMatrix, op::AbstractLinearOperator) = LinearOperator(M) + op
+(op::AbstractLinearOperator, M::AbstractMatrix) = op + LinearOperator(M)

# Operator .+ scalar.
+(op::AbstractLinearOperator, x::Number) = op + x * opOnes(op.nrow, op.ncol)
+(x::Number, op::AbstractLinearOperator) = x * opOnes(op.nrow, op.ncol) + op

# Operator - operator
-(op1::AbstractLinearOperator, op2::AbstractLinearOperator) = op1 + (-op2)

# Operator - matrix.
-(M::AbstractMatrix, op::AbstractLinearOperator) = LinearOperator(M) - op
-(op::AbstractLinearOperator, M::AbstractMatrix) = op - LinearOperator(M)

# Operator - scalar.
-(op::AbstractLinearOperator, x::Number) = op + (-x)
-(x::Number, op::AbstractLinearOperator) = x + (-op)

using Test
using LinearOperators
using LinearAlgebra

function setup_test_val(; M = 5, n = 100, scaling = false, σ = 0.1)
  B = LBFGSOperator(n, mem = M, scaling = scaling)
  H = InverseLBFGSOperator(n, mem = M, scaling = false)

  for _ = 1:10
    s = rand(n)
    y = rand(n)
    push!(B, s, y)
    push!(H, s, y)
  end

  x = randn(n)
  b = B * x + σ .* x # so we know the true answer is x

  return B, H, b, σ, zeros(n), x
end

function test_solve_shifted_system()
  @testset "solve_shifted_system! Default setup test" begin
    # Setup Test Case 1: Default setup from setup_test_val
    B, _, b, σ, x_sol, x_true = setup_test_val(n = 100, M = 5)

    result = solve_shifted_system!(x_sol, B, b, σ)

    # Test 1: Check if result is a vector of the same size as z
    @test length(result) == length(b)

    # Test 2: Verify that x_sol (result) is modified in place
    @test result === x_sol

    # Test 3: Check if the function produces finite values
    @test all(isfinite, result)

    # Test 4: Check if x_sol is close to the known solution x
    @test isapprox(x_sol, x_true, atol = 1e-6, rtol = 1e-6)
  end
  @testset "solve_shifted_system! Negative σ test" begin
    # Setup Test Case 2: Negative σ
    B, _, b, _, x_sol, _ = setup_test_val(n = 100, M = 5)
    σ = -0.1

    # Expect an ArgumentError to be thrown
    @test_throws ArgumentError solve_shifted_system!(x_sol, B, b, σ)
  end

  @testset "ldiv! test" begin
    # Setup Test Case 1: Default setup from setup_test_val
    B, H, b, _, x_sol, x_true = setup_test_val(n = 100, M = 5, σ = 0.0)

    # Solve the system using solve_shifted_system!
    result = ldiv!(x_sol, B, b)

    # Check consistency with operator-vector product using H
    x_H = H * b
    @test isapprox(x_sol, x_H, atol = 1e-6, rtol = 1e-6)
    @test isapprox(x_sol, x_true, atol = 1e-6, rtol = 1e-6)
  end
end

test_solve_shifted_system()

using Zygote

function matmulOp(mat::AbstractArray{T}) where {T}
  function prod!(res, x)
    for i in axes(mat, 1)
      res[i] = transpose(mat[i, :]) * x
    end
  end

  function ctprod!(res, x)
    for i in axes(mat, 2)
      res[i] = dot(mat[:, i], x)
    end
  end

  return LinearOperator{T}(size(mat, 1), size(mat, 2), false, false, prod!, nothing, ctprod!)
end

function test_chainrules()
  @testset ExtendedTestSet "Chainrules" begin
    for (M, N) in zip([2, 3, 8, 7], [2, 4, 8, 16])
      for T in [Float64, ComplexF64]
        mat = simple_matrix(T, M, N)
        op = matmulOp(mat)
        x = rand(T, N)
        xᵀ = transpose(x[1:M])
        xᴴ = adjoint(x[1:M])

        # test op*x
        y, g = Zygote.withgradient(v -> sum(abs.(op * v)), x)
        y2, g2 = Zygote.withgradient(v -> sum(abs.(mat * v)), x)
        @test isapprox(y, y2)
        @test isapprox(g[1], g2[1])

        # test xᵀ*op
        yt, gt = Zygote.withgradient(v -> sum(abs.(v * op)), xᵀ)
        yt2, gt2 = Zygote.withgradient(v -> sum(abs.(v * mat)), xᵀ)
        @test isapprox(yt, yt2)
        @test isapprox(gt[1], gt2[1])

        # test xᴴ*op
        yh, gh = Zygote.withgradient(v -> sum(abs.(v * op)), xᴴ)
        yh2, gh2 = Zygote.withgradient(v -> sum(abs.(v * mat)), xᴴ)
        @test isapprox(yh, yh2)
        @test isapprox(gh[1], gh2[1])
      end
    end
  end
end

test_chainrules()

using TimerOutputs

export TimedLinearOperator

mutable struct TimedLinearOperator{T, OP <: AbstractLinearOperator{T}, F, Ft, Fct} <:
               AbstractLinearOperator{T}
  timer::TimerOutput
  const op::OP
  const prod!::F
  const tprod!::Ft
  const ctprod!::Fct
end

TimedLinearOperator{T}(
  timer::TimerOutput,
  op::AbstractLinearOperator{T},
  prod!::F,
  tprod!::Ft,
  ctprod!::Fct,
) where {T, F, Ft, Fct} =
  TimedLinearOperator{T, typeof(op), F, Ft, Fct}(timer, op, prod!, tprod!, ctprod!)

"""
    TimedLinearOperator(op)
Creates a linear operator instrumented with timers from TimerOutputs.
"""
function TimedLinearOperator(op::AbstractLinearOperator{T}) where {T}
  timer = TimerOutput()
  prod!(res, x, α, β) = @timeit timer "prod" mul!(res, op, x, α, β)
  tprod!(res, x, α, β) = @timeit timer "tprod" mul!(res, transpose(op), x, α, β)
  ctprod!(res, x, α, β) = @timeit timer "ctprod" mul!(res, op', x, α, β)
  TimedLinearOperator{T}(timer, op, prod!, tprod!, ctprod!)
end

TimedLinearOperator(op::AdjointLinearOperator) = adjoint(TimedLinearOperator(op.parent))
TimedLinearOperator(op::TransposeLinearOperator) = transpose(TimedLinearOperator(op.parent))
TimedLinearOperator(op::ConjugateLinearOperator) = conj(TimedLinearOperator(op.parent))

for fn ∈ (
  :size,
  :shape,
  :issymmetric,
  :ishermitian,
  :has_args5,
  :isallocated5,
  :allocate_vectors_args3!,
  :nprod,
  :ntprod,
  :nctprod,
  :storage_type,
  :increase_nprod!,
  :increase_ntprod!,
  :increase_nctprod!,
  :reset!,
)
  @eval begin
    $fn(A::TimedLinearOperator) = $fn(A.op)
  end
end

function show(io::IO, op::TimedLinearOperator)
  show(io, op.op)
  show(io, op.timer)
end

# Deprecated use of positional argument mem
@deprecate LBFGSOperator(T::Type, n::Int, mem::Int; kwargs...) LBFGSOperator(
  T,
  n;
  mem = mem,
  kwargs...,
) false
@deprecate LBFGSOperator(n::Int, mem::Int; kwargs...) LBFGSOperator(n; mem = mem, kwargs...) false
@deprecate InverseLBFGSOperator(T::Type, n::Int, mem::Int; kwargs...) InverseLBFGSOperator(
  T,
  n;
  mem = mem,
  kwargs...,
) false
@deprecate InverseLBFGSOperator(n::Int, mem::Int; kwargs...) InverseLBFGSOperator(
  n;
  mem = mem,
  kwargs...,
) false
@deprecate LSR1Operator(T::Type, n::Int, mem::Int; kwargs...) LSR1Operator(
  T,
  n;
  mem = mem,
  kwargs...,
) false
@deprecate LSR1Operator(n::Int, mem::Int; kwargs...) LSR1Operator(n; mem = mem, kwargs...) false
@deprecate hermitian(op::AbstractLinearOperator) ishermitian(op::AbstractLinearOperator)
@deprecate symmetric(op::AbstractLinearOperator) issymmetric(op::AbstractLinearOperator)

module LinearOperatorsOpNormExt

using LinearOperators
using Arpack
using TSVD
using LinearAlgebra
using GenericLinearAlgebra
import Arpack: eigs, svds

import LinearOperators: estimate_opnorm

function estimate_opnorm(B::AbstractLinearOperator; kwargs...)
  _estimate_opnorm(B, eltype(B); kwargs...)
end

function _estimate_opnorm(
  B,
  ::Type{T};
  max_attempts::Int = 3,
  tiny_dense_threshold = 5,
  kwargs...,
) where {T}
  _, s, _ = tsvd(B, 1; kwargs...)
  return s[1], true
end

function _estimate_opnorm(
  B,
  ::Type{T};
  kwargs...,
) where {T <: Union{Float32, Float64, ComplexF32, ComplexF64}}
  if ishermitian(B)
    return opnorm_eig(B; kwargs...)
  else
    return opnorm_svd(B; kwargs...)
  end
end

function opnorm_eig(B; max_attempts::Int = 3, tiny_dense_threshold = 5, kwargs...)
  n = size(B, 1)

  if n ≤ tiny_dense_threshold
    try
      return maximum(abs, eigen(Matrix(B)).values), true
    catch
      # If Matrix(B) fails or isn't efficient, fall through to iterative
    end
  end

  nev = 1
  ncv = max(20, 2*nev + 1)

  for attempt = 1:max_attempts
    try
      d, nconv, _, _, _ =
        eigs(B; nev = nev, ncv = ncv, which = :LM, ritzvec = false, check = 1, kwargs...)

      if nconv == 1
        return abs(d[1]), true
      end

    catch e
      if occursin("ARPACK", string(e)) || occursin("AUPD", string(e))
        if ncv >= n
          @warn "ARPACK failed and NCV cannot be increased further." exception=e
          rethrow(e)
        end
      else
        rethrow(e)
      end
    end

    if attempt < max_attempts
      old_ncv = ncv
      ncv = min(2 * ncv, n)
      if ncv > old_ncv
        @warn "opnorm_eig: increasing NCV from $old_ncv to $ncv and retrying."
      else
        break
      end
    end
  end

  T = real(eltype(B))
  return T(NaN), false
end

function opnorm_svd(B; max_attempts::Int = 3, tiny_dense_threshold = 5, kwargs...)
  m, n = size(B)

  if min(m, n) ≤ tiny_dense_threshold
    try
      return maximum(svd(Matrix(B)).S), true
    catch
      # Fallback
    end
  end

  min_dim = min(m, n)

  nsv = 1
  ncv = 10

  for attempt = 1:max_attempts
    try
      s, nconv, _, _, _ = svds(B; nsv = nsv, ncv = ncv, ritzvec = false, check = 1, kwargs...)

      if nconv >= 1
        return maximum(s.S), true
      end

    catch e
      if occursin("ARPACK", string(e)) || occursin("AUPD", string(e))
        if ncv >= min_dim
          @warn "ARPACK failed and NCV cannot be increased further." exception=e
          rethrow(e)
        end
      else
        rethrow(e)
      end
    end

    if attempt < max_attempts
      old_ncv = ncv
      ncv = min(2 * ncv, min_dim)
      if ncv > old_ncv
        @warn "opnorm_svd: increasing NCV from $old_ncv to $ncv and retrying."
      else
        break
      end
    end
  end

  T = real(eltype(B))
  return T(NaN), false
end

end

module LinearOperatorsChainRulesCoreExt

using LinearOperators
isdefined(Base, :get_extension) ? (import ChainRulesCore) : (import ..ChainRulesCore)

function ChainRulesCore.frule(
  (_, Δx, _),
  ::typeof(*),
  op::AbstractLinearOperator{T},
  x::AbstractVector{S},
) where {T, S}
  y = op * x
  Δy = op * Δx
  return y, Δy
end
function ChainRulesCore.rrule(
  ::typeof(*),
  op::AbstractLinearOperator{T},
  x::AbstractVector{S},
) where {T, S}
  y = op * x
  project_x = ChainRulesCore.ProjectTo(x)
  function mul_pullback(ȳ)
    x̄ = project_x(adjoint(op) * ChainRulesCore.unthunk(ȳ))
    return ChainRulesCore.NoTangent(), ChainRulesCore.NoTangent(), x̄
  end
  return y, mul_pullback
end

function ChainRulesCore.frule(
  (_, Δx, _),
  ::typeof(*),
  x::Union{LinearOperators.Adjoint{S, V}, LinearOperators.Transpose{S, V}},
  op::AbstractLinearOperator{T},
) where {T, S, V <: AbstractVector{S}}
  y = x * op
  Δy = Δx * op
  return y, Δy
end
function ChainRulesCore.rrule(
  ::typeof(*),
  x::LinearOperators.Transpose{S, V},
  op::AbstractLinearOperator{T},
) where {T, S, V <: AbstractVector{S}}
  y = x * op
  project_x = ChainRulesCore.ProjectTo(x)
  function mul_pullback(ȳ)
    # needed to make sure that ȳ is recognized as Transposed
    # ȳ_ = transpose(collect(vec(ChainRulesCore.unthunk(ȳ))))
    ȳ_ = transpose(vec(ChainRulesCore.unthunk(ȳ)))
    x̄ = project_x(ȳ_ * adjoint(op))
    return ChainRulesCore.NoTangent(), x̄, ChainRulesCore.NoTangent()
  end
  return y, mul_pullback
end
function ChainRulesCore.rrule(
  ::typeof(*),
  x::LinearOperators.Adjoint{S, V},
  op::AbstractLinearOperator{T},
) where {T, S, V <: AbstractVector{S}}
  y = x * op
  project_x = ChainRulesCore.ProjectTo(x)
  function mul_pullback(ȳ)
    # needed to make sure that ȳ is recognized as Adjoint
    # ȳ_ = adjoint(collect(vec(ChainRulesCore.unthunk(ȳ))))
    ȳ_ = adjoint(conj.(vec(ChainRulesCore.unthunk(ȳ))))
    x̄ = project_x(ȳ_ * adjoint(op))
    return ChainRulesCore.NoTangent(), x̄, ChainRulesCore.NoTangent()
  end
  return y, mul_pullback
end

end # module

export LSR1Operator, diag

"A data type to hold information relative to LSR1 operators."
mutable struct LSR1Data{T, I <: Integer}
  mem::I
  const scaling::Bool
  scaling_factor::T
  opnorm_upper_bound::T # Upper bound for the operator norm ‖Bₖ‖₂ ≤ ‖B₀‖₂ + ∑ᵢ |σᵢ|‖aᵢ‖₂².
  const s::Vector{Vector{T}}
  const y::Vector{Vector{T}}
  const ys::Vector{T}
  const a::Vector{Vector{T}}
  const as::Vector{T}
  insert::I
  const Ax::Vector{T}
  const tmp::Vector{T}
end

function LSR1Data(T::Type, n::I; mem::I = 5, scaling::Bool = true) where {I <: Integer}
  LSR1Data{T, I}(
    max(mem, 1),
    scaling,
    convert(T, 1),
    convert(T, 1),
    [zeros(T, n) for _ = 1:mem],
    [zeros(T, n) for _ = 1:mem],
    zeros(T, mem),
    [zeros(T, n) for _ = 1:mem],
    zeros(T, mem),
    1,
    Vector{T}(undef, n),
    Vector{T}(undef, n),
  )
end

LSR1Data(n::I; kwargs...) where {I <: Integer} = LSR1Data(Float64, n; kwargs...)

"A type for limited-memory SR1 approximations."
mutable struct LSR1Operator{T, I <: Integer, F, Ft, Fct} <: AbstractQuasiNewtonOperator{T}
  const nrow::I
  const ncol::I
  const symmetric::Bool
  const hermitian::Bool
  const prod!::F     # apply the operator to a vector
  const tprod!::Ft    # apply the transpose operator to a vector
  const ctprod!::Fct   # apply the transpose conjugate operator to a vector
  const data::LSR1Data{T, I}
  nprod::I
  ntprod::I
  nctprod::I
end

LSR1Operator{T}(
  nrow::I,
  ncol::I,
  symmetric::Bool,
  hermitian::Bool,
  prod!::F,
  tprod!::Ft,
  ctprod!::Fct,
  data::LSR1Data{T, I},
) where {T, I <: Integer, F, Ft, Fct} = LSR1Operator{T, I, F, Ft, Fct}(
  nrow,
  ncol,
  symmetric,
  hermitian,
  prod!,
  tprod!,
  ctprod!,
  data,
  0,
  0,
  0,
)

has_args5(op::LSR1Operator) = true
isallocated5(op::LSR1Operator) = true
storage_type(op::LSR1Operator{T}) where {T} = Vector{T}

"""
    LSR1Operator(T, n; [mem=5, scaling=false)
    LSR1Operator(n; [mem=5, scaling=false)
Construct a limited-memory SR1 approximation in forward form. If the type `T` is
omitted, then `Float64` is used.
"""
function LSR1Operator(T::Type, n::I; kwargs...) where {I <: Integer}
  lsr1_data = LSR1Data(T, n; kwargs...)

  function lsr1_multiply(q::AbstractVector, data::LSR1Data, x::AbstractArray, α, β::T2) where {T2}
    # Multiply operator with a vector.

    if β == zero(T2)
      q .= α .* x ./ data.scaling_factor
    else
      q .= α .* x ./ data.scaling_factor .+ β .* q
    end

    for i = 1:(data.mem)
      k = mod(data.insert + i - 2, data.mem) + 1
      if data.ys[k] != 0
        ax = α * dot(data.a[k], x) / data.as[k]
        for j ∈ eachindex(q)
          q[j] += ax * data.a[k][j]
        end
      end
    end
  end

  prod! = @closure (res, x, α, β) -> lsr1_multiply(res, lsr1_data, x, α, β)
  return LSR1Operator{T}(n, n, true, true, prod!, nothing, nothing, lsr1_data)
end

LSR1Operator(n::I; kwargs...) where {I <: Integer} = LSR1Operator(Float64, n; kwargs...)

"""
    push!(op, s, y)
Push a new {s,y} pair into a L-SR1 operator.
"""
function push!(op::LSR1Operator, s::AbstractVector, y::AbstractVector)

  # op.counters.updates += 1
  data = op.data
  ymBs = data.tmp
  ymBs .= y
  mul!(ymBs, op, s, -1, 1)  # ymBs = y - B * s
  ys = dot(y, s)
  sNorm = norm(s)
  yy = dot(y, y)

  ϵ = eps(eltype(op))
  well_defined = abs(dot(ymBs, s)) ≥ ϵ + ϵ * norm(ymBs) * sNorm

  sufficient_curvature = true
  scaling_condition = true
  if data.scaling
    yNorm = √yy
    sufficient_curvature = abs(ys) ≥ ϵ * yNorm * sNorm
    if sufficient_curvature
      scaling_factor = ys / yy
      data.tmp .= y .- s ./ scaling_factor
      scaling_condition = norm(data.tmp) >= ϵ * yNorm * sNorm
    end
  end

  if !(well_defined && sufficient_curvature && scaling_condition)
    @debug "LSR1 update rejected" well_defined sufficient_curvature scaling_condition
    # op.counters.rejects += 1
    return op
  end

  data.s[data.insert] .= s
  data.y[data.insert] .= y
  data.ys[data.insert] = ys

  # update scaling factor
  data.opnorm_upper_bound = convert(typeof(data.opnorm_upper_bound), 1)
  if data.scaling
    (data.scaling_factor = ys / yy)
    !iszero(data.scaling_factor) && (data.opnorm_upper_bound = 1 / abs(op.data.scaling_factor))
  end

  # update next insertion position
  data.insert = mod(data.insert, data.mem) + 1

  # update rank-1 terms
  for i = 1:(data.mem)
    k = mod(data.insert + i - 2, data.mem) + 1
    if data.ys[k] != 0
      data.a[k] .= data.y[k] .- data.s[k] ./ data.scaling_factor  # = y - B₀ * s
      for j = 1:(i - 1)
        l = mod(data.insert + j - 2, data.mem) + 1
        if data.ys[l] != 0
          as = dot(data.a[l], data.s[k]) / data.as[l]
          data.a[k] .-= as .* data.a[l]
        end
      end
      data.as[k] = dot(data.a[k], data.s[k])

      !iszero(data.as[k]) && (data.opnorm_upper_bound += norm(data.a[k])^2/abs(data.as[k]))
    end
  end

  return op
end

"""
    diag(op)
    diag!(op, d)
Extract the diagonal of a L-SR1 operator in forward mode.
"""
function diag(op::LSR1Operator{T}) where {T}
  d = Vector{T}(undef, op.nrow)
  diag!(op, d)
end

function diag!(op::LSR1Operator{T}, d) where {T}
  data = op.data

  fill!(d, 1)
  data.scaling && (d ./= data.scaling_factor)

  for i = 1:(data.mem)
    k = mod(data.insert + i - 2, data.mem) + 1
    if data.ys[k] != 0.0
      for j = 1:(op.nrow)
        d[j] += data.a[k][j]^2 / data.as[k]
      end
    end
  end
  return d
end

"""
    reset!(data)
Reset the given LSR1 data.
"""
function reset!(data::LSR1Data{T, I}) where {T, I <: Integer}
  for i = 1:(data.mem)
    fill!(data.s[i], 0)
    fill!(data.y[i], 0)
    fill!(data.a[i], 0)
  end
  fill!(data.ys, 0)
  fill!(data.as, 0)
  data.scaling_factor = T(1)
  data.insert = 1
  return data
end

"""
    reset!(op)
Resets the LSR1 data of the given operator.
"""
function reset!(op::LSR1Operator)
  reset!(op.data)
  op.nprod = 0
  op.ntprod = 0
  op.nctprod = 0
  return op
end

import Base.kron

# (A ⊗ B)×vec(X) = vec(BXAᵀ)
"""`kron(A, B)`

Kronecker tensor product of A and B in linear operator form, if either
or both are linear operators. If both A and B are matrices, then
`Base.kron` is used.
"""
function kron(A::AbstractLinearOperator, B::AbstractLinearOperator)
  m, n = size(A)
  p, q = size(B)
  T = promote_type(eltype(A), eltype(B))
  function prod!(res, x, α, β::T2) where {T2}
    S = promote_type(T, eltype(x))
    X = reshape(convert(Vector{S}, x), q, n)
    if β == zero(T2)
      res .= α .* Matrix(B * X * transpose(A))[:]
    else
      res .= α .* Matrix(B * X * transpose(A))[:] .+ β .* res
    end
  end
  function tprod!(res, x, α, β::T2) where {T2}
    S = promote_type(T, eltype(x))
    X = reshape(convert(Vector{S}, x), p, m)
    if β == zero(T2)
      res .= α .* Matrix(transpose(B) * X * A)[:]
    else
      res .= α .* Matrix(transpose(B) * X * A)[:] .+ β .* res
    end
  end
  function ctprod!(res, x, α, β::T2) where {T2}
    S = promote_type(T, eltype(x))
    X = reshape(convert(Vector{S}, x), p, m)
    if β == zero(T2)
      res .= α .* Matrix(B' * X * conj(A))[:]
    else
      res .= α .* Matrix(B' * X * conj(A))[:] .+ β .* res
    end
  end
  symm = issymmetric(A) && issymmetric(B)
  herm = ishermitian(A) && ishermitian(B)
  nrow, ncol = m * p, n * q
  return LinearOperator{T, Vector{T}}(nrow, ncol, symm, herm, prod!, tprod!, ctprod!)
end

kron(A::AbstractMatrix, B::AbstractLinearOperator) = kron(LinearOperator(A), B)

kron(A::AbstractLinearOperator, B::AbstractMatrix) = kron(A, LinearOperator(B))

using TSVD, GenericLinearAlgebra
@testset "ShiftedOperator Tests" begin
  @testset "Real Symmetric (Float64)" begin
    n = 5
    H_dense = rand(n, n)
    H_dense = H_dense + H_dense'

    H_op = LinearOperator(H_dense; symmetric = true, hermitian = true)

    σ = 2.0
    op = ShiftedOperator(H_op, σ)

    A_ref = H_dense + σ * I

    x = rand(n)
    y = zeros(n)

    @test size(op) == (n, n)
    @test issymmetric(op) == true
    @test ishermitian(op) == true
    @test op.data.σ == σ

    mul!(y, op, x)
    @test y ≈ A_ref * x

    y_orig = rand(n)
    y = copy(y_orig)
    α, β = 0.5, -1.0
    mul!(y, op, x, α, β)
    @test y ≈ α * (A_ref * x) + β * y_orig

    op_t = transpose(op)

    y_t = zeros(n)
    mul!(y_t, op_t, x)
    @test y_t ≈ transpose(A_ref) * x
  end

  @testset "Complex Non-Hermitian" begin
    n = 5
    H_dense = rand(ComplexF64, n, n)
    H_op = LinearOperator(H_dense)

    σ = 1.0 + 2.0im
    op = ShiftedOperator(H_op, σ)

    @test !issymmetric(op)
    @test !ishermitian(op)

    A_ref = H_dense + σ * I
    x = rand(ComplexF64, n)

    op_c = adjoint(op)

    y_c = zeros(ComplexF64, n)
    mul!(y_c, op_c, x)
    @test y_c ≈ adjoint(A_ref) * x
  end

  @testset "Mutation (Updating Sigma)" begin
    n = 3
    H_dense = rand(n, n)
    op = ShiftedOperator(LinearOperator(H_dense), 1.0)

    x = ones(n)
    y1 = op * x

    op.data.σ = 10.0

    y2 = op * x

    @test !(y1 ≈ y2)
    @test y2 ≈ (H_dense + 10.0*I) * x
  end

  @testset "Mutation (Dynamic Hermitian Check)" begin
    n = 3
    H_dense = rand(ComplexF64, n, n)
    H_dense = H_dense + H_dense'
    H_op = LinearOperator(H_dense; symmetric = false, hermitian = true)

    σ = 2.0
    op = ShiftedOperator(H_op, σ)
    @test ishermitian(op)

    op.data.σ = 2.0 + 1.0im
    @test !ishermitian(op)

    op.data.σ = 3.0
    @test ishermitian(op)
  end

  @testset "Strict Type Constraint" begin
    H = LinearOperator(rand(Float32, 5, 5))
    σ = 1.0
    op = ShiftedOperator(H, σ)

    @test eltype(op) == Float32
    @test op.data.σ isa Float32

    x = rand(Float32, 5)
    y = op * x
    @test eltype(y) == Float32
  end

  @testset "Coverage & Utilities" begin
    n = 5
    H = LinearOperator(rand(n, n))
    x = rand(n)
    y = zeros(n)
    op = ShiftedOperator(H, 2.0)

    mul!(y, transpose(op), x, 0.5, 1.0)

    mul!(y, transpose(op), x, 0.0, 1.0)

    op_zero = ShiftedOperator(H, 0.0)
    mul!(y, transpose(op_zero), x)

    @test LinearOperators.isallocated5(op) == true

    @test LinearOperators.storage_type(op) == LinearOperators.storage_type(H)

    op.nprod = 10
    reset!(op)
    @test op.nprod == 0
  end

  @testset "OpNorm Fallback & Error Handling Coverage" begin
    """
            make_mock_throwing_op(m, n, is_sym, is_herm, err_msg)

        Creates a "mock" LinearOperator designed specifically to fail when applied to a vector.
        
        Why is this needed?
        To get CodeCov on our `catch` blocks and Krylov dimension (NCV) retry loops, we need 
        ARPACK to fail with specific Fortran errors (like "AUPD"). Triggering these errors 
        naturally using real math requires highly pathological matrices, which causes "flaky" 
        tests that might pass on one machine and fail on another (e.g., in CI pipelines).

        By using a mock operator that instantly throws an error containing our target string, 
        we guarantee 100% stable test coverage of our exception handling and retry logic.
        """
    function make_mock_throwing_op(m, n, is_sym, is_herm, err_msg)
      return LinearOperator(
        Float64,
        m,
        n,
        is_sym,
        is_herm,
        (args...) -> throw(ErrorException(err_msg)),
        (args...) -> throw(ErrorException(err_msg)),
        (args...) -> throw(ErrorException(err_msg)),
      )
    end

    @testset "Dense Branch Success" begin
      # Size <= 5 so it tries dense and succeeds. (Covers the successful try block)
      op_sym_small = LinearOperator(Symmetric(rand(4, 4)))
      val_sym, succ_sym = estimate_opnorm(op_sym_small; tiny_dense_threshold = 5)
      @test succ_sym

      op_nonsym_small = LinearOperator(rand(4, 4))
      val_nonsym, succ_nonsym = estimate_opnorm(op_nonsym_small; tiny_dense_threshold = 5)
      @test succ_nonsym
    end

    @testset "Dense Fallback & Generic Error Rethrow" begin
      # Size <= 5 so it tries dense. Dense calls Matrix(), which applies the operator and throws.
      # Caught by dense catch -> falls back to iterative -> applies operator and throws again.
      # Since the error isn't an ARPACK/AUPD error, it hits `else rethrow(e)`.
      op_err_sym = make_mock_throwing_op(4, 4, true, true, "Generic Error")
      @test_throws ErrorException estimate_opnorm(op_err_sym; tiny_dense_threshold = 5)

      op_err_nonsym = make_mock_throwing_op(4, 4, false, false, "Generic Error")
      @test_throws ErrorException estimate_opnorm(op_err_nonsym; tiny_dense_threshold = 5)
    end

    @testset "opnorm_eig: ARPACK/AUPD Logic" begin
      # Simulate AUPD failure: NCV increases, max_attempts exhausts -> return NaN, false
      # Starts ncv=20. We use n=100.
      op_aupd_sym_large = make_mock_throwing_op(100, 100, true, true, "Mock AUPD Error")
      @test_logs (:warn, r"opnorm_eig: increasing NCV from 20 to 40") match_mode=:any begin
        val, succ = estimate_opnorm(op_aupd_sym_large; tiny_dense_threshold = 5, max_attempts = 2)
        @test isnan(val)
        @test !succ
      end

      # Simulate AUPD failure: NCV hits maximum limit (n) -> logs and rethrows
      # Starts ncv=20. We use n=25.
      # Attempt 1: throws, ncv becomes 25. 
      # Attempt 2: throws, ncv >= n (25 >= 25) -> logs warning and rethrows!
      op_aupd_sym_small = make_mock_throwing_op(25, 25, true, true, "Mock AUPD Error")
      @test_logs (:warn, r"opnorm_eig: increasing NCV from 20 to 25") (
        :warn,
        r"ARPACK failed and NCV cannot be increased further.",
      ) match_mode=:any begin
        @test_throws ErrorException estimate_opnorm(
          op_aupd_sym_small;
          tiny_dense_threshold = 5,
          max_attempts = 3,
        )
      end
    end

    @testset "TSVD Fallback for BigFloat" begin
      op_bigfloat = LinearOperator(rand(BigFloat, 4, 4))
      val, succ = estimate_opnorm(op_bigfloat; tiny_dense_threshold = 5)
      @test succ  # TSVD-based fallback should succeed.
    end

    @testset "opnorm_svd: ARPACK/AUPD Logic" begin
      # Same logic for opnorm_svd (non-Hermitian).
      # Starts ncv=10. We use n=50. Max attempts=2.
      op_aupd_nonsym_large = make_mock_throwing_op(50, 50, false, false, "Mock AUPD Error")
      @test_logs (:warn, r"opnorm_svd: increasing NCV from 10 to 20") match_mode=:any begin
        val, succ =
          estimate_opnorm(op_aupd_nonsym_large; tiny_dense_threshold = 5, max_attempts = 2)
        @test isnan(val)
        @test !succ
      end

      # Starts ncv=10. n=15. Hits NCV limit and rethrows.
      op_aupd_nonsym_small = make_mock_throwing_op(15, 15, false, false, "Mock AUPD Error")
      @test_logs (:warn, r"opnorm_svd: increasing NCV from 10 to 15") (
        :warn,
        r"ARPACK failed and NCV cannot be increased further.",
      ) match_mode=:any begin
        @test_throws ErrorException estimate_opnorm(
          op_aupd_nonsym_small;
          tiny_dense_threshold = 5,
          max_attempts = 3,
        )
      end
    end
  end
end

module LinearOperatorsJLArraysExt

using LinearOperators
isdefined(Base, :get_extension) ? (using JLArrays) : (using ..JLArrays)

LinearOperators.storage_type(::JLArray{T, 2}) where {T} = JLArray{T, 1}

end # module

function test_lbfgs()
  ϵ = eps(Float64)
  rtol = sqrt(ϵ)

  # test limited-memory BFGS
  @testset ExtendedTestSet "LBFGS" begin
    n = 10
    mem = 5
    B = LBFGSOperator(n, mem = mem, scaling = false)
    H = InverseLBFGSOperator(n, mem = mem, scaling = false)
    @test isallocated5(B) == isallocated5(H) == true

    for t = 1:2 # Run again after reset!
      @test norm(diag(B) - diag(Matrix(B))) <= rtol

      @test B.data.insert == 1
      @test H.data.insert == 1
      @test norm(Matrix(B) - Matrix(1.0I, n, n)) <= ϵ
      @test norm(Matrix(H) - Matrix(1.0I, n, n)) <= ϵ

      # Test that nonpositive curvature can't be added.
      s = simple_vector(Float64, n)
      z = zeros(n)
      push!(B, s, -s)
      @test B.data.insert == 1
      push!(B, s, z)
      @test B.data.insert == 1
      push!(H, s, -s)
      @test H.data.insert == 1
      push!(H, s, z)
      @test H.data.insert == 1

      # Insert a few {s,y} pairs.
      insert = 0
      for i = 1:(mem + 2)
        s = ones(n) * i
        y = [i; ones(n - 1)]
        if dot(s, y) > 1.0e-20
          insert += 1
          push!(B, s, y)
          push!(H, s, y)
        end
      end

      @test B.data.insert == mod(insert, B.data.mem) + 1
      @test H.data.insert == mod(insert, H.data.mem) + 1

      @test check_positive_definite(B)
      @test check_positive_definite(H)

      @test check_hermitian(B)
      @test check_hermitian(H)

      @test norm(diag(B) - diag(Matrix(B))) <= rtol

      @test norm(Matrix(H * B) - Matrix(1.0I, n, n)) <= rtol

      # Testing reset! function
      v = simple_vector(Float64, n)
      @test norm(B * v - v) > rtol
      @test norm(H * v - v) > rtol
      reset!(B)
      reset!(H)
      @test B.data.scaling_factor == 1.0
      @test H.data.scaling_factor == 1.0
      @test norm(B * v - v) < rtol
      @test norm(H * v - v) < rtol

      # test upper bound
      @test opnorm(Matrix(B)) ≤ B.data.opnorm_upper_bound
    end

    # test against full BFGS without scaling
    mem = n
    LB = LBFGSOperator(n, mem = mem, scaling = false)
    B = Matrix(1.0I, n, n)

    function bfgs!(B, s, y, damped = false)
      # dense BFGS update
      ys = dot(y, s)
      Bs = B * s
      tol = damped ? (0.2 * dot(s, Bs)) : 1.0e-20
      if ys > tol
        B = B - Bs * Bs' / dot(s, Bs) + y * y' / ys
      end
      return B
    end

    @test norm(Matrix(LB) - B) < rtol * norm(B)
    @test norm(diag(LB) - diag(B)) < rtol * norm(diag(B))

    for k = 1:mem
      s = simple_vector(Float64, n)
      y = simple_vector(Float64, n)
      B = bfgs!(B, s, y)
      LB = push!(LB, s, y)
      @test norm(Matrix(LB) - B) < rtol * norm(B)
      @test norm(diag(LB) - diag(B)) < rtol * norm(diag(B))
    end

    # Test upper bound
    @test opnorm(B) ≤ LB.data.opnorm_upper_bound

    # test damped L-BFGS
    B = LBFGSOperator(n, mem = mem, damped = true, scaling = false, σ₂ = 0.8, σ₃ = Inf)
    H = InverseLBFGSOperator(n, mem = mem, damped = true, scaling = false, σ₂ = 0.8, σ₃ = Inf)

    insert_B = insert_H = 0
    for i = 1:(mem + 2)
      s = simple_vector(Float64, n)
      y = simple_vector(Float64, n)
      ys = dot(y, s)
      g = simple_vector(Float64, n)
      d = -(H * g) # added brackets here
      α = i / mem
      s = α * d
      if ys > 0.2 * dot(s, B * s)
        insert_B += 1
        insert_H += 1
        push!(B, s, y)
        push!(H, s, y, α, g)
      end
    end

    @test B.data.insert == mod(insert_B, B.data.mem) + 1
    @test H.data.insert == mod(insert_H, H.data.mem) + 1

    @test check_positive_definite(B)
    @test check_positive_definite(H)

    @test check_hermitian(B)
    @test check_hermitian(H)

    @test norm(diag(B) - diag(Matrix(B))) <= rtol

    @test norm(Matrix(H * B) - Matrix(1.0I, n, n)) <= rtol

    # Test upper bound
    @test opnorm(Matrix(B)) ≤ B.data.opnorm_upper_bound

    # test against full BFGS without scaling
    mem = n
    LB = LBFGSOperator(n, mem = mem, damped = true, scaling = false)
    B = Matrix(1.0I, n, n)

    @test norm(Matrix(LB) - B) < rtol * norm(B)
    @test norm(diag(LB) - diag(B)) < rtol * norm(diag(B))

    for k = 1:mem
      s = simple_vector(Float64, n)
      y = simple_vector(Float64, n)
      B = bfgs!(B, s, y, true)
      LB = push!(LB, s, y)
      @test norm(Matrix(LB) - B) < rtol * norm(B)
      @test norm(diag(LB) - diag(B)) < rtol * norm(diag(B))
    end

    # Test upper bound
    @test opnorm(Matrix(B)) ≤ LB.data.opnorm_upper_bound
  end

  @testset ExtendedTestSet "Different precision" begin
    n = 10
    mem = 5
    for T in (Float16, Float32, Float64, BigFloat)
      B = LBFGSOperator(T, n, mem = mem)
      H = InverseLBFGSOperator(T, n, mem = mem)
      s = ones(T, n)
      y = ones(T, n)
      push!(B, s, y)
      push!(H, s, y)
      @test eltype(B) == T
      @test eltype(H) == T
      v = [-(-one(T))^i for i = 1:n]
      @test eltype(B * v) == T
      @test eltype(H * v) == T
    end
  end

  @testset "LBFGS allocations" begin
    n = 100
    mem = 20
    B = LBFGSOperator(n, mem = mem)
    H = InverseLBFGSOperator(n, mem = mem)
    BD = LBFGSOperator(n, mem = mem, damped = true)
    HD = InverseLBFGSOperator(n, mem = mem, damped = true)
    for _ = 1:2:n
      s = rand(n)
      y = rand(n)
      push!(B, s, y)
      push!(H, s, y)
      g = rand(n)
      push!(BD, s, y)
      push!(HD, s, y, 1.0, g)
    end
    x = rand(n)
    y = rand(n)
    res = similar(x)
    mul!(res, B, x)  # warmup
    nallocs = @allocated mul!(res, B, x)
    @test nallocs == 0
    mul!(res, H, x)  # warmup
    nallocs = @allocated mul!(res, H, x)
    @test nallocs == 0
    nallocs = @allocated diag!(B, x)
    @test nallocs == 0

    nallocs = @allocated push!(B, x, y)
    @test nallocs == 0
    nallocs = @allocated push!(H, x, y)
    @test nallocs == 0

    tmp = zeros(n)
    nallocs = @allocated push!(BD, x, y, tmp)
    @test nallocs == 0
    nallocs = @allocated push!(HD, x, y, 1.0, x, tmp)
    @test nallocs == 0
  end

  @testset "push! errors" begin
    n = 100
    mem = 20
    B = LBFGSOperator(n, mem = mem)
    H = InverseLBFGSOperator(n, mem = mem)
    BD = LBFGSOperator(n, mem = mem, damped = true)
    HD = InverseLBFGSOperator(n, mem = mem, damped = true)
    s = ones(n)
    y = ones(n)
    g = ones(n)
    Bs = zeros(n)
    @test_throws ErrorException push!(B, s, y, Bs)
    @test_throws ErrorException push!(H, s, y, Bs)
    @test_throws ErrorException push!(HD, s, y, Bs)
    @test_throws ErrorException push!(B, s, y, 1.0, g)
    @test_throws ErrorException push!(BD, s, y, 1.0, g)
    @test_throws ErrorException push!(H, s, y, 1.0, g)
    @test_throws ErrorException push!(B, s, y, 1.0, g, Bs)
    @test_throws ErrorException push!(BD, s, y, 1.0, g, Bs)
    @test_throws ErrorException push!(H, s, y, 1.0, g, Bs)
  end

  @testset "LBFGS eigenvalues" begin
    n = 100
    mem = 20
    B = LBFGSOperator(n, mem = mem)
    H = InverseLBFGSOperator(n, mem = mem)
    for _ = 1:2:n
      s = rand(n)
      y = rand(n)
      push!(B, s, y)
      push!(H, s, y)
    end
    λ = eigs(B, nev = n)[1]  # call Arpack
    @test minimum(λ) > 0
    λ = eigs(H)[1]
    @test minimum(λ) > 0
  end
end

test_lbfgs()

export AbstractLinearOperator,
  AbstractQuasiNewtonOperator,
  AbstractDiagonalQuasiNewtonOperator,
  LinearOperator,
  LinearOperatorException,
  hermitian,
  ishermitian,
  symmetric,
  issymmetric,
  has_args5,     # TODO: deprecate
  isallocated5,
  nprod,
  ntprod,
  nctprod,
  reset!

struct LinearOperatorException <: Exception
  msg::AbstractString
end

# when indexing, Colon() is treated separately
const LinearOperatorIndexType{I} =
  Union{UnitRange{I}, StepRange{I, I}, AbstractVector{I}} where {I <: Integer}

# import methods we overload
import Base.eltype, Base.isreal, Base.size, Base.show
import LinearAlgebra.Symmetric,
  LinearAlgebra.issymmetric, LinearAlgebra.Hermitian, LinearAlgebra.ishermitian

abstract type AbstractLinearOperator{T} end
abstract type AbstractQuasiNewtonOperator{T} <: AbstractLinearOperator{T} end
abstract type AbstractDiagonalQuasiNewtonOperator{T} <: AbstractQuasiNewtonOperator{T} end
OperatorOrMatrix = Union{AbstractLinearOperator, AbstractMatrix}

eltype(A::AbstractLinearOperator{T}) where {T} = T
isreal(A::AbstractLinearOperator{T}) where {T} = T <: Real
get_nargs(f) = first(methods(f)).nargs - 1

"""
Base type to represent a linear operator.
The usual arithmetic operations may be applied to operators
to combine or otherwise alter them. They can be combined with
other operators, with matrices and with scalars. Operators may
be transposed and conjugate-transposed using the usual Julia syntax.
"""
mutable struct LinearOperator{T, S, I <: Integer, F, Ft, Fct} <: AbstractLinearOperator{T}
  const nrow::I
  const ncol::I
  const symmetric::Bool
  const hermitian::Bool
  const prod!::F
  const tprod!::Ft
  const ctprod!::Fct
  nprod::I
  ntprod::I
  nctprod::I
  Mv::S
  Mtu::S
end

function LinearOperator{T, S}(
  nrow::I,
  ncol::I,
  symmetric::Bool,
  hermitian::Bool,
  prod!::F,
  tprod!::Ft,
  ctprod!::Fct,
  nprod::I,
  ntprod::I,
  nctprod::I,
) where {T, S, I <: Integer, F, Ft, Fct}
  return LinearOperator{T, S, I, F, Ft, Fct}(
    nrow,
    ncol,
    symmetric,
    hermitian,
    prod!,
    tprod!,
    ctprod!,
    nprod,
    ntprod,
    nctprod,
    S(undef, 0),
    S(undef, 0),
  )
end

# backward compatibility (not inferrable; use LinearOperator{T, S} if you want something inferrable)
LinearOperator{T}(
  nrow,
  ncol,
  symmetric,
  hermitian,
  prod!,
  tprod!,
  ctprod!,
  nprod,
  ntprod,
  nctprod;
  S::Type = Vector{T},
) where {T} = LinearOperator{T, S}(
  nrow,
  ncol,
  symmetric,
  hermitian,
  prod!,
  tprod!,
  ctprod!,
  nprod,
  ntprod,
  nctprod,
)

"""
    LinearOperator{T, S}(nrow, ncol, symmetric, hermitian, prod!, tprod!, ctprod! = nothing) where {T, S}

Construct a linear operator with a specific temporary array storage type `S`, which should typically have element type `T`.

This is an inferrable variant of constructors that supply `S` as a keyword argument, and is recommended for performance-sensitive applications.
"""
LinearOperator{T, S}(
  nrow::I,
  ncol::I,
  symmetric::Bool,
  hermitian::Bool,
  prod!,
  tprod! = nothing,
  ctprod! = nothing,
) where {T, S, I <: Integer} =
  LinearOperator{T, S}(nrow, ncol, symmetric, hermitian, prod!, tprod!, ctprod!, 0, 0, 0)

# backward compatibility (not inferrable)
LinearOperator{T}(
  nrow,
  ncol,
  symmetric,
  hermitian,
  prod!,
  tprod!,
  ctprod!;
  S::Type = Vector{T},
) where {T} = LinearOperator{T, S}(nrow, ncol, symmetric, hermitian, prod!, tprod!, ctprod!)

const CompositeLinearOperator = LinearOperator   # backwards compatibility

nprod(op::AbstractLinearOperator) = op.nprod
ntprod(op::AbstractLinearOperator) = op.ntprod
nctprod(op::AbstractLinearOperator) = op.nctprod

increase_nprod!(op::AbstractLinearOperator) = (op.nprod += 1)
increase_ntprod!(op::AbstractLinearOperator) = (op.ntprod += 1)
increase_nctprod!(op::AbstractLinearOperator) = (op.nctprod += 1)

"""
    has_args5(op)

Determine whether the operator can work with the 5-args `mul!`.
If `false`, storage vectors will be generated at the first call of
the 5-args `mul!`.
No additional vectors are generated when using the 3-args `mul!`.

!!! warning
    `has_args5` can be very slow. A better option is to use Julia's `hasmethod`
    at points in the code where the concrete types of objects used in `mul!` are known.

    `has_args5` may be removed in a future release.
"""
has_args5(op::AbstractLinearOperator) = get_nargs(op.prod!) == 4

isallocated5(op::LinearOperator) = !(isempty(op.Mv) || isempty(op.Mtu))

has_args5(op::AbstractMatrix) = true  # Needed for BlockDiagonalOperator

# Alert user of the need for storage_type method definition for arbitrary, user defined operators
storage_type(op::AbstractLinearOperator) = error("please implement storage_type for $(typeof(op))")

storage_type(::LinearOperator{T, S}) where {T, S} = S
storage_type(::AbstractMatrix{T}) where {T} = Vector{T}

# Lazy wrappers
storage_type(op::Adjoint) = storage_type(parent(op))
storage_type(op::Transpose) = storage_type(parent(op))
storage_type(op::Diagonal) = typeof(parent(op))

"""
  reset!(op)

Reset the product counters of a linear operator.
"""
function reset!(op::AbstractLinearOperator)
  op.nprod = 0
  op.ntprod = 0
  op.nctprod = 0
  return op
end

"""
    m, n = size(op)

Return the size of a linear operator as a tuple.
"""
size(op::AbstractLinearOperator) = (op.nrow, op.ncol)

"""
    m = size(op, d)

Return the size of a linear operator along dimension `d`.
"""
function size(op::AbstractLinearOperator, d::Integer)
  nrow, ncol = size(op)
  if d == 1
    return nrow
  end
  if d == 2
    return ncol
  end
  throw(LinearOperatorException("Linear operators only have 2 dimensions for now"))
end

"""
    ishermitian(op)

Determine whether the operator is Hermitian.
"""
ishermitian(op::AbstractLinearOperator) = op.hermitian

"""
    Hermitian(op, uplo=:U)
"""
function Hermitian(op::AbstractLinearOperator, uplo::Symbol = :U)
  isequal(size(op)...) || throw(LinearOperatorException("Operator is not square"))
  ishermitian(op) && return op
  return (op + adjoint(op)) / 2
end

hermitian(A::AbstractLinearOperator, uplo::Symbol) = Hermitian(A, uplo)

"""
    issymmetric(op)

Determine whether the operator is symmetric.
"""
issymmetric(op::AbstractLinearOperator) = op.symmetric

"""
    Symmetric(op, uplo=:U)
"""
function Symmetric(op::AbstractLinearOperator, uplo::Symbol = :U)
  isequal(size(op)...) || throw(LinearOperatorException("Operator is not square"))
  issymmetric(op) && return op
  return (op + transpose(op)) / 2
end

symmetric(A::AbstractLinearOperator, uplo::Symbol) = Symmetric(A, uplo)

"""
    show(io, op)

Display basic information about a linear operator.
"""
function show(io::IO, op::AbstractLinearOperator)
  s = "Linear operator\n"
  nrow, ncol = size(op)
  s *= @sprintf("  nrow: %s\n", nrow)
  s *= @sprintf("  ncol: %d\n", ncol)
  s *= @sprintf("  eltype: %s\n", eltype(op))
  s *= @sprintf("  symmetric: %s\n", issymmetric(op))
  s *= @sprintf("  hermitian: %s\n", ishermitian(op))
  s *= @sprintf("  nprod:   %d\n", nprod(op))
  s *= @sprintf("  ntprod:  %d\n", ntprod(op))
  s *= @sprintf("  nctprod: %d\n", nctprod(op))
  s *= "\n"
  print(io, s)
end

"""
    A = Matrix(op)

Materialize an operator as a dense array using `op.ncol` products.
"""
function Base.Matrix(op::AbstractLinearOperator{T}) where {T}
  (m, n) = size(op)
  A = Array{T}(undef, m, n)
  ei = zeros(T, n)
  for i = 1:n
    ei[i] = one(T)
    A[:, i] = op * ei
    ei[i] = zero(T)
  end
  return A
end

import Base.hcat, Base.vcat, Base.hvcat

hcat(A::AbstractLinearOperator, B::AbstractMatrix) = hcat(A, LinearOperator(B))

hcat(A::AbstractMatrix, B::AbstractLinearOperator) = hcat(LinearOperator(A), B)

function hcat_prod!(
  res::AbstractVector,
  A::AbstractLinearOperator{T},
  B::AbstractLinearOperator{T},
  Ancol::I,
  nV::I,
  v::AbstractVector,
  α,
  β,
) where {T, I <: Integer}
  mul!(res, A, view(v, 1:Ancol), α, β)
  mul!(res, B, view(v, (Ancol + 1):nV), α, one(T))
end

function hcat_ctprod!(
  res::AbstractVector,
  A::AbstractLinearOperator{T},
  B::AbstractLinearOperator{T},
  Ancol::I,
  nV::I,
  u::AbstractVector,
  α,
  β,
) where {T, I <: Integer}
  mul!(view(res, 1:Ancol), A, u, α, β)
  mul!(view(res, (Ancol + 1):nV), B, u, α, β)
end

function hcat(A::AbstractLinearOperator, B::AbstractLinearOperator)
  size(A, 1) == size(B, 1) || throw(LinearOperatorException("hcat: inconsistent row sizes"))

  nrow = size(A, 1)
  Ancol, Bncol = size(A, 2), size(B, 2)
  ncol = Ancol + Bncol
  T = promote_type(eltype(A), eltype(B))
  prod! = @closure (res, v, α, β) -> hcat_prod!(res, A, B, Ancol, Ancol + Bncol, v, α, β)
  tprod! = @closure (res, u, α, β) ->
    hcat_ctprod!(res, transpose(A), transpose(B), Ancol, Ancol + Bncol, u, α, β)
  ctprod! = @closure (res, w, α, β) ->
    hcat_ctprod!(res, adjoint(A), adjoint(B), Ancol, Ancol + Bncol, w, α, β)
  S = promote_type(storage_type(A), storage_type(B))
  isconcretetype(S) ||
    throw(LinearOperatorException("storage types cannot be promoted to a concrete type"))
  LinearOperator{T, S}(nrow, ncol, false, false, prod!, tprod!, ctprod!)
end

function hcat(ops::AbstractLinearOperator...)
  op = ops[1]
  for i = 2:length(ops)
    op = [op ops[i]]
  end
  return op
end

vcat(A::AbstractLinearOperator, B::AbstractMatrix) = vcat(A, LinearOperator(B))

vcat(A::AbstractMatrix, B::AbstractLinearOperator) = vcat(LinearOperator(A), B)

function vcat_prod!(
  res::AbstractVector,
  A::AbstractLinearOperator{T},
  B::AbstractLinearOperator{T},
  Anrow::I,
  nV::I,
  u::AbstractVector,
  α,
  β,
) where {T, I <: Integer}
  mul!(view(res, 1:Anrow), A, u, α, β)
  mul!(view(res, (Anrow + 1):nV), B, u, α, β)
end

function vcat_ctprod!(
  res::AbstractVector,
  A::AbstractLinearOperator{T},
  B::AbstractLinearOperator{T},
  Anrow::I,
  nV::I,
  v::AbstractVector,
  α,
  β,
) where {T, I <: Integer}
  mul!(res, A, view(v, 1:Anrow), α, β)
  mul!(res, B, view(v, (Anrow + 1):nV), α, one(T))
end

function vcat(A::AbstractLinearOperator, B::AbstractLinearOperator)
  size(A, 2) == size(B, 2) || throw(LinearOperatorException("vcat: inconsistent column sizes"))

  Anrow, Bnrow = size(A, 1), size(B, 1)
  nrow = Anrow + Bnrow
  ncol = size(A, 2)
  T = promote_type(eltype(A), eltype(B))
  prod! = @closure (res, v, α, β) -> vcat_prod!(res, A, B, Anrow, Anrow + Bnrow, v, α, β)
  tprod! = @closure (res, u, α, β) ->
    vcat_ctprod!(res, transpose(A), transpose(B), Anrow, Anrow + Bnrow, u, α, β)
  ctprod! = @closure (res, w, α, β) ->
    vcat_ctprod!(res, adjoint(A), adjoint(B), Anrow, Anrow + Bnrow, w, α, β)
  S = promote_type(storage_type(A), storage_type(B))
  isconcretetype(S) ||
    throw(LinearOperatorException("storage types cannot be promoted to a concrete type"))
  LinearOperator{T, S}(nrow, ncol, false, false, prod!, tprod!, ctprod!)
end

function vcat(ops::AbstractLinearOperator...)
  op = ops[1]
  for i = 2:length(ops)
    op = [op; ops[i]]
  end
  return op
end

# Removed by https://github.com/JuliaLang/julia/pull/24017
function hvcat(rows::Tuple{Vararg{Int}}, ops::AbstractLinearOperator...)
  nbr = length(rows)
  rs = Array{AbstractLinearOperator, 1}(undef, nbr)
  a = 1
  for i = 1:nbr
    rs[i] = hcat(ops[a:(a - 1 + rows[i])]...)
    a += rows[i]
  end
  vcat(rs...)
end

using Test, LinearAlgebra, SparseArrays
using LinearOperators, CUDA, CUDA.CUSPARSE, CUDA.CUSOLVER

@testset "Nvidia -- CUDA.jl" begin
  @test CUDA.functional()
  CUDA.allowscalar(false)

  A = CUDA.rand(5, 5)
  B = CUDA.rand(10, 10)
  C = CUDA.rand(20, 20)
  M = BlockDiagonalOperator(A, B, C)

  v = CUDA.rand(35)
  y = M * v
  @test y isa CuVector{Float32}

  @test LinearOperators.storage_type(A) == LinearOperators.storage_type(adjoint(A))
  @test LinearOperators.storage_type(A) == LinearOperators.storage_type(transpose(A))
  @test LinearOperators.storage_type(A) == LinearOperators.storage_type(adjoint(A))
  @test LinearOperators.storage_type(Diagonal(v)) == typeof(v)

  @testset "Nvidia S kwarg" test_S_kwarg(arrayType = CuArray)
end

using Test, LinearOperators, LinearAlgebra

function test_S_kwarg(; arrayType, notMetal = true)
  mat = arrayType(rand(Float32, 32, 32))
  vec = arrayType(rand(Float32, 32))
  vecT = typeof(vec)

  if notMetal
    # To test operators which can derive a default storage_type from their arguments
    vecTother = typeof(arrayType(rand(Float32, 32)))
  end

  @testset "S Kwarg with arrayType $(arrayType)" begin
    @test vecT == LinearOperators.storage_type(mat)

    # constructors.jl
    @test LinearOperators.storage_type(LinearOperator(mat)) == LinearOperators.storage_type(mat) # default
    notMetal && @test LinearOperators.storage_type(LinearOperator(mat; S = vecTother)) == vecTother
    @test LinearOperators.storage_type(LinearOperator(Symmetric(mat); S = vecT)) == vecT
    #notMetal && @test LinearOperators.storage_type(LinearOperator(SymTridiagonal(Symmetric(mat)); S = vecT)) == vecT
    @test LinearOperators.storage_type(LinearOperator(Hermitian(mat); S = vecT)) == vecT
    @test LinearOperators.storage_type(
      LinearOperator(Float32, 32, 32, true, true, () -> 0; S = vecT),
    ) == vecT

    # special-operators.jl
    @test LinearOperators.storage_type(opEye(Float32, 32; S = vecT)) == vecT
    @test LinearOperators.storage_type(opEye(Float32, 16, 32; S = vecT)) == vecT
    @test LinearOperators.storage_type(opEye(Float32, 32, 32; S = vecT)) == vecT

    @test LinearOperators.storage_type(opOnes(Float32, 32, 32; S = vecT)) == vecT
    @test LinearOperators.storage_type(opZeros(Float32, 32, 32; S = vecT)) == vecT

    @test LinearOperators.storage_type(opDiagonal(vec)) == vecT
    @test LinearOperators.storage_type(opDiagonal(32, 32, vec)) == vecT

    @test LinearOperators.storage_type(opRestriction([1, 2, 3], 32; S = vecT)) == vecT
    @test LinearOperators.storage_type(opExtension([1, 2, 3], 32; S = vecT)) == vecT

    @test LinearOperators.storage_type(BlockDiagonalOperator(mat, mat)) == vecT # default
    notMetal &&
      @test LinearOperators.storage_type(BlockDiagonalOperator(mat, mat; S = vecTother)) ==
            vecTother
  end
end

module LinearOperators

using FastClosures, LinearAlgebra, Printf, SparseArrays

# Basic defitions
include("abstract.jl")
include("constructors.jl")

# Operations
include("operations.jl") # This first
include("adjtrans.jl")
include("cat.jl")
include("kron.jl")

# quasi-Newton operators
include("qn.jl")

# diagonal Hessian approximations
include("DiagonalHessianApproximation.jl")

# Special operators
include("linalg.jl")
include("special-operators.jl")
include("TimedOperators.jl")
include("shifted_operators.jl")

# Utilities
include("utilities.jl")
include("deprecated.jl")

end # module

import Base.eltypeof, Base.promote_eltypeof, LinearAlgebra.lmul!, LinearAlgebra.rmul!

export opEye, opOnes, opZeros, opDiagonal, opRestriction, opExtension, BlockDiagonalOperator

"""`opEye()`

Identity operator.
```
opI = opEye()
v = rand(5)
@assert opI * v === v
```
"""
struct opEye <: AbstractLinearOperator{Any} end

*(::opEye, x::AbstractArray{T, 1} where {T}) = x
*(x::AbstractArray{T, 1} where {T}, ::opEye) = x
*(::opEye, A::AbstractArray{T, 2} where {T}) = A
*(A::AbstractArray{T, 2} where {T}, ::opEye) = A
*(
  v::Union{LinearAlgebra.Adjoint{S, V}, LinearAlgebra.Transpose{S, V}},
  ::LinearOperators.opEye,
) where {S, V <: AbstractVector{S}} = v
*(::opEye, T::AbstractLinearOperator) = T
*(T::AbstractLinearOperator, ::opEye) = T
*(::opEye, T::opEye) = T

adjoint(A::opEye) = A
transpose(A::opEye) = A
conj(A::opEye) = A

function show(io::IO, op::opEye)
  println(io, "Identity operator")
end

function mulOpEye!(res, v, α, β::T, n_min) where {T}
  if β == zero(T)
    res[1:n_min] .= @views α .* v[1:n_min]
    res[(n_min + 1):end] .= 0
  else
    res[1:n_min] .= @views α .* v[1:n_min] .+ β .* res[1:n_min]
    res[(n_min + 1):end] .= β
  end
end

"""
    opEye(T, n; S = Vector{T})
    opEye(n)

Identity operator of order `n` and of data type `T` (defaults to `Float64`).
Change `S` to use LinearOperators on GPU.
"""
function opEye(T::Type, n::Int; S = Vector{T})
  prod! = @closure (res, v, α, β) -> mulOpEye!(res, v, α, β, n)
  LinearOperator{T, S}(n, n, true, true, prod!, prod!, prod!)
end

opEye(n::Int) = opEye(Float64, n)

# TODO: not type stable
"""
    opEye(T, nrow, ncol; S = Vector{T})
    opEye(nrow, ncol)

Rectangular identity operator of size `nrow`x`ncol` and of data type `T`
(defaults to `Float64`).
Change `S` to use LinearOperators on GPU.
"""
function opEye(T::Type, nrow::I, ncol::I; S = Vector{T}) where {I <: Integer}
  if nrow == ncol
    return opEye(T, nrow; S = S)
  end
  prod! = @closure (res, v, α, β) -> mulOpEye!(res, v, α, β, min(nrow, ncol))
  return LinearOperator{T, S}(nrow, ncol, false, false, prod!, prod!, prod!)
end

opEye(nrow::I, ncol::I) where {I <: Integer} = opEye(Float64, nrow, ncol)

function mulOpOnes!(res, v, α, β::T) where {T}
  if β == zero(T)
    res .= (α * sum(v))
  else
    res .= (α * sum(v)) .+ β .* res
  end
end

"""
    opOnes(T, nrow, ncol; S = Vector{T})
    opOnes(nrow, ncol)

Operator of all ones of size `nrow`-by-`ncol` of data type `T` (defaults to
`Float64`).
Change `S` to use LinearOperators on GPU.
"""
function opOnes(T::Type, nrow::I, ncol::I; S = Vector{T}) where {I <: Integer}
  prod! = @closure (res, v, α, β) -> mulOpOnes!(res, v, α, β)
  LinearOperator{T, S}(nrow, ncol, nrow == ncol, nrow == ncol, prod!, prod!, prod!)
end

opOnes(nrow::I, ncol::I) where {I <: Integer} = opOnes(Float64, nrow, ncol)

function mulOpZeros!(res, v, α, β::T) where {T}
  if β == zero(T)
    res .= 0
  else
    res .*= β
  end
end

"""
    opZeros(T, nrow, ncol; S = Vector{T})
    opZeros(nrow, ncol)

Zero operator of size `nrow`-by-`ncol`, of data type `T` (defaults to
`Float64`).
Change `S` to use LinearOperators on GPU.
"""
function opZeros(T::Type, nrow::I, ncol::I; S = Vector{T}) where {I <: Integer}
  prod! = @closure (res, v, α, β) -> mulOpZeros!(res, v, α, β)
  LinearOperator{T, S}(nrow, ncol, nrow == ncol, nrow == ncol, prod!, prod!, prod!)
end

opZeros(nrow::I, ncol::I) where {I <: Integer} = opZeros(Float64, nrow, ncol)

function mulSquareOpDiagonal!(res, d, v, α, β::T) where {T}
  if β == zero(T)
    res .= α .* d .* v
  else
    res .= α .* d .* v .+ β .* res
  end
end

"""
    opDiagonal(d)

Diagonal operator with the vector `d` on its main diagonal.
"""
function opDiagonal(d::AbstractVector{T}) where {T}
  prod! = @closure (res, v, α, β) -> mulSquareOpDiagonal!(res, d, v, α, β)
  ctprod! = @closure (res, w, α, β) -> mulSquareOpDiagonal!(res, conj.(d), w, α, β)
  LinearOperator{T, typeof(d)}(length(d), length(d), true, isreal(d), prod!, prod!, ctprod!)
end

function mulOpDiagonal!(res, d, v, α, β::T, n_min) where {T}
  if β == zero(T)
    res[1:n_min] .= @views α .* d[1:n_min] .* v[1:n_min]
  else
    res[1:n_min] .= @views α .* d[1:n_min] .* v[1:n_min] .+ β .* res[1:n_min]
  end
  res[(n_min + 1):end] .= 0
end
"""
    opDiagonal(nrow, ncol, d)

Rectangular diagonal operator of size `nrow`-by-`ncol` with the vector `d` on
its main diagonal.
"""
function opDiagonal(nrow::I, ncol::I, d::AbstractVector{T}) where {T, I <: Integer}
  nrow == ncol <= length(d) && (return opDiagonal(d[1:nrow]))
  n_min = min(nrow, ncol)
  prod! = @closure (res, v, α, β) -> mulOpDiagonal!(res, d, v, α, β, n_min)
  tprod! = @closure (res, u, α, β) -> mulOpDiagonal!(res, d, u, α, β, n_min)
  ctprod! = @closure (res, w, α, β) -> mulOpDiagonal!(res, conj.(d), w, α, β, n_min)
  LinearOperator{T, typeof(d)}(nrow, ncol, false, false, prod!, tprod!, ctprod!)
end

function mulRestrict!(res, I, v, α, β)
  res .= view(v, I)
end

function multRestrict!(res, I, u, α, β)
  res .= 0
  res[I] = u
end

"""
    Z = opRestriction(I, ncol)
    Z = opRestriction(:, ncol)

Creates a LinearOperator restricting a `ncol`-sized vector to indices `I`.
The operation `Z * v` is equivalent to `v[I]`. `I` can be `:`.

    Z = opRestriction(k, ncol)

Alias for `opRestriction([k], ncol)`.
"""
function opRestriction(Idx::LinearOperatorIndexType{I}, ncol::I; S = nothing) where {I <: Integer}
  all(1 .≤ Idx .≤ ncol) || throw(LinearOperatorException("indices should be between 1 and $ncol"))
  nrow = length(Idx)
  prod! = @closure (res, v, α, β) -> mulRestrict!(res, Idx, v, α, β)
  tprod! = @closure (res, u, α, β) -> multRestrict!(res, Idx, u, α, β)
  if isnothing(S)
    return LinearOperator{I, Vector{I}}(nrow, ncol, false, false, prod!, tprod!, tprod!)
  else
    return LinearOperator{I, S}(nrow, ncol, false, false, prod!, tprod!, tprod!)
  end
end

opRestriction(::Colon, ncol::I) where {I <: Integer} = opEye(I, ncol)

opRestriction(k::I, ncol::I) where {I <: Integer} = opRestriction([k], ncol)

"""
    Z = opExtension(I, ncol)
    Z = opExtension(:, ncol)

Creates a LinearOperator extending a vector of size `length(I)` to size `ncol`,
where the position of the elements on the new vector are given by the indices
`I`.
The operation `w = Z * v` is equivalent to `w = zeros(ncol); w[I] = v`.

    Z = opExtension(k, ncol)

Alias for `opExtension([k], ncol)`.
"""
opExtension(Idx::LinearOperatorIndexType{I}, ncol::I; S = nothing) where {I <: Integer} =
  opRestriction(Idx, ncol; S = S)'

opExtension(::Colon, ncol::I) where {I <: Integer} = opEye(I, ncol)

opExtension(k::I, ncol::I) where {I <: Integer} = opExtension([k], ncol)

# indexing for linear operators
import Base.getindex
function getindex(
  op::AbstractLinearOperator,
  rows::Union{LinearOperatorIndexType{<:Integer}, <:Integer, Colon},
  cols::Union{LinearOperatorIndexType{<:Integer}, <:Integer, Colon},
)
  R = opRestriction(rows, size(op, 1))
  E = opExtension(cols, size(op, 2))
  return R * op * E
end

eltypeof(op::AbstractLinearOperator) = eltype(op)  # need this for promote_eltypeof

"""
    BlockDiagonalOperator(M1, M2, ..., Mn; S = promote_type(storage_type.(M1, M2, ..., Mn)))

Creates a block-diagonal linear operator:

    [ M1           ]
    [    M2        ]
    [       ...    ]
    [           Mn ]

Change `S` to use LinearOperators on GPU.
"""
function BlockDiagonalOperator(ops...; S = promote_type(storage_type.(ops)...))
  nrow = ncol = 0
  for op ∈ ops
    m, n = size(op)
    nrow += m
    ncol += n
  end
  T = promote_eltypeof(ops...)

  function prod!(y, x, α, β)
    k = 0
    j = 0
    for op ∈ ops
      m, n = size(op)
      @views mul!(y[(k + 1):(k + m)], op, x[(j + 1):(j + n)], α, β)
      k += m
      j += n
    end
  end

  function tprod!(y, x, α, β)
    k = 0
    j = 0
    for op ∈ ops
      m, n = size(op)
      @views mul!(y[(k + 1):(k + n)], transpose(op), x[(j + 1):(j + m)], α, β)
      k += n
      j += m
    end
  end

  function ctprod!(y, x, α, β)
    k = 0
    j = 0
    for op ∈ ops
      m, n = size(op)
      @views mul!(y[(k + 1):(k + n)], adjoint(op), x[(j + 1):(j + m)], α, β)
      k += n
      j += m
    end
  end

  symm = all((issymmetric(op) for op ∈ ops))
  herm = all((ishermitian(op) for op ∈ ops))
  LinearOperator{T, S}(nrow, ncol, symm, herm, prod!, tprod!, ctprod!)
end

export ShiftedOperator

"A data type to hold information relative to shifted operators."
mutable struct ShiftedData{T, OpH}
  const H::OpH
  σ::T
  function ShiftedData{T, OpH}(H::OpH, σ::T) where {T, OpH}
    size(H, 1) == size(H, 2) || throw(DimensionMismatch("Operator H must be square."))
    new{T, OpH}(H, σ)
  end
end

ShiftedData(H::OpH, σ::T) where {T, OpH} = ShiftedData{T, OpH}(H, σ)

# Forward product: y = α(H + σI)x + βy
function shifted_prod!(y, data::ShiftedData, x, α, β)
  # y = α * H * x + β * y
  mul!(y, data.H, x, α, β)

  # y = y + (α * σ) * x
  if !(iszero(data.σ) || iszero(α))
    axpy!(α * data.σ, x, y)
  end
  return y
end

# Transpose product: y = α(Hᵀ + σI)x + βy
function shifted_tprod!(y, data::ShiftedData, x, α, β)
  # y = α * Hᵀ * x + β * y
  mul!(y, transpose(data.H), x, α, β)

  # y = y + (α * σ) * x
  if !(iszero(data.σ) || iszero(α))
    axpy!(α * data.σ, x, y)
  end
  return y
end

# Conjugate transpose (adjoint) product: y = α(Hᴴ + conj(σ)I)x + βy
function shifted_ctprod!(y, data::ShiftedData, x, α, β)
  # y = α * Hᴴ * x + β * y
  mul!(y, adjoint(data.H), x, α, β)

  # y = y + (α * conj(σ)) * x
  if !(iszero(data.σ) || iszero(α))
    axpy!(α * conj(data.σ), x, y)
  end
  return y
end

"""
    ShiftedOperator(H, σ=0)

Construct a linear operator representing `op = H + σI`.
"""
mutable struct ShiftedOperator{T, OpH, F, Ft, Fct} <: AbstractLinearOperator{T}
  const nrow::Int
  const ncol::Int
  const symmetric::Bool
  const hermitian::Bool
  const prod!::F      # Closure for op * x
  const tprod!::Ft    # Closure for transpose(op) * x
  const ctprod!::Fct  # Closure for adjoint(op) * x
  const data::ShiftedData{T, OpH}
  nprod::Int    # Internal counter for products
  ntprod::Int   # Internal counter for transpose products
  nctprod::Int  # Internal counter for adjoint products
end

function ShiftedOperator(H::OpH, σ_in::Number = zero(eltype(H))) where {OpH}
  T = eltype(H)
  σ = convert(T, σ_in)  # Enforces that σ matches the element type of H

  data = ShiftedData(H, σ)

  prod! = (y, x, α, β) -> shifted_prod!(y, data, x, α, β)
  tprod! = (y, x, α, β) -> shifted_tprod!(y, data, x, α, β)
  ctprod! = (y, x, α, β) -> shifted_ctprod!(y, data, x, α, β)

  n = size(H, 1)

  is_sym = issymmetric(H)
  is_herm = ishermitian(H) && isreal(σ)

  return ShiftedOperator(n, n, is_sym, is_herm, prod!, tprod!, ctprod!, data, 0, 0, 0)
end

size(op::ShiftedOperator) = (op.nrow, op.ncol)
issymmetric(op::ShiftedOperator) = op.symmetric
ishermitian(op::ShiftedOperator) = op.hermitian && isreal(op.data.σ)

has_args5(op::ShiftedOperator) = true

isallocated5(op::ShiftedOperator) = true

storage_type(op::ShiftedOperator{T}) where {T} = storage_type(op.data.H)

function reset!(op::ShiftedOperator)
  op.nprod = 0
  op.ntprod = 0
  op.nctprod = 0
  return op
end

function test_normest()
  @testset "normest" begin
    ϵ = 0.001
    simple_matrix_test(ϵ)
  end
end

function simple_matrix_test_helper(S, ϵ_norm, ϵ)
  val = opnorm(Matrix(S), 2)
  val_normest, _ = normest(S, ϵ_norm, 10000)
  if val == 0
    dev = 1
  else
    dev = abs(val)
  end
  @test abs(val_normest - val) / dev <= ϵ
end

function simple_matrix_test(ϵ)
  for (nrow, ncol) in [(10, 10), (5, 5), (3, 3), (3, 5), (5, 3), (5, 10), (10, 5)]
    ϵ_norm = eps(Float64)
    A1 = simple_matrix(ComplexF64, nrow, ncol)
    simple_matrix_test_helper(A1, ϵ_norm, ϵ)
    LA1 = LinearOperator(A1)
    simple_matrix_test_helper(LA1, ϵ_norm, ϵ)

    A2 = simple_matrix(Float64, nrow, ncol)
    simple_matrix_test_helper(A2, ϵ_norm, ϵ)
    LA2 = LinearOperator(A2)
    ϵ_norm = -1
    simple_matrix_test_helper(LA2, ϵ_norm, ϵ)

    A3 = zeros(Float64, nrow, ncol)
    simple_matrix_test_helper(A3, ϵ_norm, ϵ)
    LA3 = LinearOperator(A3)
    ϵ_norm = -1
    simple_matrix_test_helper(LA3, ϵ_norm, ϵ)
  end
end

test_normest()

module LinearOperatorsMetalExt

using LinearOperators
isdefined(Base, :get_extension) ? (using Metal) : (using ..Metal)

LinearOperators.storage_type(::MtlArray{T, 2, S}) where {T, S} = MtlArray{T, 1, S}

end # module

export opInverse, opCholesky, opHouseholder, opLDL, opHermitian

function mulFact!(res, F, v, α, β::T) where {T}
  if β == zero(T)
    res .= α .* (F \ v)
  else
    res .= α .* (F \ v) .+ β .* res
  end
end

function tmulFact!(res, F, u, α, β::T) where {T}
  if β == zero(T)
    res .= α .* conj!(F \ conj.(u))
  else
    res .= α .* conj!(F \ conj.(u)) .+ β .* res
  end
end

"""
    opInverse(M; symm=false, herm=false)

Inverse of a matrix as a linear operator using `\\`.
Useful for triangular matrices. Note that each application of this
operator applies `\\`.
This Operator is not in-place when using `mul!`.
"""
function opInverse(M::AbstractMatrix{T}; symm = false, herm = false) where {T}
  prod! = @closure (res, v, α, β) -> mulFact!(res, M, v, α, β)
  tprod! = @closure (res, u, α, β) -> mulFact!(res, transpose(M), u, α, β)
  ctprod! = @closure (res, w, α, β) -> mulFact!(res, adjoint(M), w, α, β)
  LinearOperator{T, Vector{T}}(size(M, 2), size(M, 1), symm, herm, prod!, tprod!, ctprod!)
end

"""
    opCholesky(M, [check=false])

Inverse of a Hermitian and positive definite matrix as a linear operator
using its Cholesky factorization.
The factorization is computed only once.
The optional `check` argument will perform cheap hermicity and definiteness
checks.
This Operator is not in-place when using `mul!`.
"""
function opCholesky(M::AbstractMatrix; check::Bool = false)
  (m, n) = size(M)
  m == n || throw(LinearOperatorException("shape mismatch"))
  if check
    check_hermitian(M) || throw(LinearOperatorException("matrix is not Hermitian"))
    check_positive_definite(M) || throw(LinearOperatorException("matrix is not positive definite"))
  end
  LL = cholesky(M)
  prod! = @closure (res, v, α, β) -> mulFact!(res, LL, v, α, β)
  tprod! = @closure (res, u, α, β) -> tmulFact!(res, LL, u, α, β)  # M.' = conj(M)
  ctprod! = @closure (res, w, α, β) -> mulFact!(res, LL, w, α, β)
  S = eltype(LL)
  LinearOperator{S, Vector{S}}(m, m, isreal(M), true, prod!, tprod!, ctprod!)
  #TODO: use iterative refinement.
end

"""
    opLDL(M, [check=false])

Inverse of a symmetric matrix as a linear operator using its LDLᵀ factorization
if it exists. The factorization is computed only once. The optional `check`
argument will perform a cheap hermicity check.

If M is sparse and real, then only the upper triangle should be stored in order to use
[`LDLFactorizations.jl`](https://github.com/JuliaSmoothOptimizers/LDLFactorizations.jl):

    using LDLFactorizations
    triu!(M)
    opLDL(Symmetric(M, :U))

"""
function opLDL end

function mulHouseholder!(res, h, v, α, β::T) where {T}
  if β == zero(T)
    res .= α .* (v .- 2 * dot(h, v) .* h)
  else
    res .= α .* (v .- 2 * dot(h, v) .* h) .+ β .* res
  end
end

"""
    opHouseholder(h)

Apply a Householder transformation defined by the vector `h`.
The result is `x -> (I - 2 h hᵀ) x`.
"""
function opHouseholder(h::AbstractVector{T}) where {T}
  n = length(h)
  prod! = @closure (res, v, α, β) -> mulHouseholder!(res, h, v, α, β)  # tprod will be inferred
  LinearOperator{T, Vector{T}}(n, n, isreal(h), true, prod!, nothing, prod!)
end

function mulHermitian!(res, d, L, v, α, β::T) where {T}
  if β == zero(T)
    res .= α .* (d .* v .+ L * v .+ (v' * L)')[:]
  else
    res .= α .* (d .* v .+ L * v .+ (v' * L)')[:] .+ β .* res
  end
end

"""
    opHermitian(d, A)

A symmetric/hermitian operator based on the diagonal `d` and lower triangle of `A`.
"""
function opHermitian(d::AbstractVector{S}, A::AbstractMatrix{T}) where {S, T}
  m, n = size(A)
  m == n == length(d) || throw(LinearOperatorException("shape mismatch"))
  L = tril(A, -1)
  U = promote_type(S, T)
  prod! = @closure (res, v, α, β) -> mulHermitian!(res, d, L, v, α, β)
  LinearOperator{U, Vector{U}}(m, m, isreal(A), true, prod!, nothing, nothing)
end

"""
    opHermitian(A)

A symmetric/hermitian operator based on a matrix.
"""
function opHermitian(T::AbstractMatrix)
  d = diag(T)
  opHermitian(d, T)
end

function test_kron()
  @testset ExtendedTestSet "Kron" begin
    for A in Any[simple_matrix(Float64, 2, 3), simple_sparse_matrix(Float64, 10, 10)]
      for B in Any[
        simple_matrix(Float64, 2, 3),
        simple_matrix(ComplexF64, 2, 3),
        simple_sparse_matrix(Float64, 10, 10),
      ]
        K = kron(A, B)
        normK = norm(K, 1)
        T1 = kron(LinearOperator(A), B)
        T2 = kron(A, LinearOperator(B))
        T3 = kron(LinearOperator(A), LinearOperator(B))
        for T in [T1, T2, T3]
          @test norm(K - Matrix(T), 1) < eps() * normK
          @test norm(K' - Matrix(T'), 1) < eps() * normK
          @test norm(transpose(K) - Matrix(transpose(T)), 1) < eps() * normK
          m, n = size(K)
          err = 0.0
          for t = 1:100
            x = simple_vector(Float64, n)
            Kx = K * x
            Tx = T * x
            err += norm(Kx - Tx, 1)

            x = simple_vector(Float64, m)
            Kx = K' * x
            Tx = T' * x
            err += norm(Kx - Tx, 1)

            Kx = transpose(K) * x
            Tx = transpose(T) * x
            err += norm(Kx - Tx, 1)
          end
          @test err < 1e-12 * normK
        end
      end
    end
  end

  @testset ExtendedTestSet "issue110" begin
    A = rand(2, 2)
    op = LinearOperator(A)
    K = kron(A, op)
    x = rand(Complex{Float64}, 4)
    y = K * x
    @test eltype(y) == Complex{Float64}
  end

  @testset ExtendedTestSet "kron scaling" begin
    A = 2kron(opEye(2), I(1))
    x = randn(2)
    y1 = A * x
    y2 = A' * x
    y3 = transpose(A) * x
    err = norm(y1 - 2x) + norm(y2 - 2x) + norm(y3 - 2x)
    @test err < 1e-12
  end
end

test_kron()

using TSVD
using Arpack
using GenericLinearAlgebra

@testset "estimate_opnorm type stability and dispatch" begin
  @testset "Type $T" for T in [Float32, Float64, ComplexF32, ComplexF64]
    # A) Rectangular Matrix (Forces SVD path)
    J_mat = zeros(T, 3, 2)
    J_mat[1, 1] = 3.0
    J_mat[2, 2] = 1.0
    J_op = LinearOperator(J_mat)

    σ, ok = estimate_opnorm(J_op)
    @test ok
    @test isapprox(σ, 3.0; rtol = 1e-5)

    # B) Hermitian Wrapper (Forces Eig path via dispatch)
    H_data = rand(T, 10, 10)
    H_data = H_data + H_data'
    H = Hermitian(H_data)

    H_op = LinearOperator(H)

    exact_norm = opnorm(H) # Uses standard LinearAlgebra
    est_norm, ok = estimate_opnorm(H_op) # Uses our extension

    @test ok
    @test isapprox(est_norm, exact_norm; rtol = 1e-5)

    # C) Symmetric Wrapper (Dispatch varies by Real vs Complex)
    S_data = rand(T, 10, 10)
    S_data = S_data + transpose(S_data)
    S = Symmetric(S_data)

    S_op = LinearOperator(S)

    exact_norm_S = opnorm(Matrix(S))
    est_norm_S, ok_S = estimate_opnorm(S_op)

    @test ok_S
    @test isapprox(est_norm_S, exact_norm_S; rtol = 1e-5)

    # C.1) Specific check: Ensure Symmetric{Complex} works 
    # (This is NOT Hermitian, so it must successfully fall back to the SVD path)
    if T <: Complex
      # Ensure the operator didn't falsely flag itself as Hermitian
      @test !ishermitian(S_op)
    end
  end

  @testset "BigFloat (Generic)" begin
    # -------------------------
    B_mat = Matrix{BigFloat}([2.0 0.0; 0.0 -1.0])
    B_op = LinearOperator(B_mat)

    λ_bf, ok_bf = estimate_opnorm(B_op)

    @test ok_bf
    @test isapprox(λ_bf, BigFloat(2); rtol = 1e-12)
  end
end

using Arpack, Test, TestSetExtensions, LinearOperators
using LinearAlgebra, LDLFactorizations, SparseArrays, JLArrays
using Zygote
include("test_aux.jl")

include("test_linop.jl")
include("test_linop_allocs.jl")
include("test_adjtrans.jl")
include("test_cat.jl")
include("test_lbfgs.jl")
include("test_lsr1.jl")
include("test_kron.jl")
include("test_callable.jl")
include("test_deprecated.jl")
include("test_normest.jl")
include("test_estimate_opnorm.jl")
include("test_diag.jl")
include("test_chainrules.jl")
include("test_solve_shifted_system.jl")
include("test_shifted_operator.jl")
include("gpu/test_S_kwarg.jl")
include("gpu/jlarrays.jl")
if Sys.isapple() && occursin("arm64", Sys.MACHINE)
  include("gpu/metal.jl")
end

function test_deprecated()
  @testset ExtendedTestSet "Deprecated methods" begin
    n = 10
    mem = 3
    T = Float16
    @test_deprecated LBFGSOperator(n, mem, scaling = false)
    @test_deprecated InverseLBFGSOperator(n, mem, scaling = false)
    @test_deprecated LBFGSOperator(T, n, mem, scaling = false)
    @test_deprecated InverseLBFGSOperator(T, n, mem, scaling = false)
    @test_deprecated LSR1Operator(n, mem, scaling = false)
    @test_deprecated LSR1Operator(T, n, mem, scaling = false)
    opA = LinearOperator(rand(10, 10))
    for op in [opA, TimedLinearOperator(opA), adjoint(opA), transpose(opA), conj(opA)]
      @test_deprecated hermitian(op)
      @test_deprecated symmetric(op)
    end
  end
end

test_deprecated()

function test_adjtrans()
  @testset ExtendedTestSet "Adjoint/Transpose/Conjugate" begin
    A = rand(5, 3) + im * rand(5, 3)
    opA = LinearOperator(A)

    aopA = AdjointLinearOperator(opA)
    copA = ConjugateLinearOperator(opA)
    topA = TransposeLinearOperator(opA)

    for (foo, fop) in [(adjoint, aopA), (conj, copA), (transpose, topA)]
      @test foo(opA) === fop
      @test Matrix(fop) == foo(A)
      @test foo(fop) === opA

      @test Matrix(-fop) == foo(-A)
      @test Matrix((2 + 3im) * fop) ≈ (2 + 3im) * foo(A)
      @test Matrix(fop * (2 + 3im)) ≈ foo(A) * (2 + 3im)
    end

    @test adjoint(topA) === copA
    @test adjoint(copA) === topA
    @test conj(aopA) === topA
    @test conj(topA) === aopA
    @test transpose(copA) === aopA
    @test transpose(aopA) === copA

    v = rand(5) + im * rand(5)
    @test aopA * v == adjoint(A) * v
    @test topA * v == transpose(A) * v
    v = rand(5)
    @test aopA * v ≈ adjoint(A) * v
    @test topA * v ≈ transpose(A) * v

    v = rand(3) + im * rand(3)
    @test copA * v ≈ conj(A) * v
    v = rand(3)
    @test copA * v ≈ conj(A) * v
  end
end

test_adjtrans()

##
function test_derived_adjoint()
  @testset ExtendedTestSet "Derived Adjoint" begin
    A = rand(5, 3) + im * rand(5, 3)

    opA = LinearOperator{eltype(A)}(
      size(A, 1),
      size(A, 2),
      false,
      false,
      (y, x) -> mul!(y, A, x),
      (x, y) -> mul!(x, transpose(A), y),
      nothing,
    )

    aopA = AdjointLinearOperator(opA)
    copA = ConjugateLinearOperator(opA)
    topA = TransposeLinearOperator(opA)

    for (foo, fop) in [(adjoint, aopA), (conj, copA), (transpose, topA)]
      @test foo(opA) === fop
      @test Matrix(fop) == foo(A)
      @test foo(fop) === opA

      @test Matrix(-fop) == foo(-A)
      @test Matrix((2 + 3im) * fop) ≈ (2 + 3im) * foo(A)
      @test Matrix(fop * (2 + 3im)) ≈ foo(A) * (2 + 3im)
    end

    @test adjoint(topA) === copA
    @test adjoint(copA) === topA
    @test conj(aopA) === topA
    @test conj(topA) === aopA
    @test transpose(copA) === aopA
    @test transpose(aopA) === copA

    v = rand(5) + im * rand(5)
    @test aopA * v == adjoint(A) * v
    @test topA * v == transpose(A) * v
    v = rand(5)
    @test aopA * v ≈ adjoint(A) * v
    @test topA * v ≈ transpose(A) * v

    v = rand(3) + im * rand(3)
    @test copA * v ≈ conj(A) * v
    v = rand(3)
    @test copA * v ≈ conj(A) * v
  end
end

test_derived_adjoint()

##
function test_derived_transpose()
  @testset ExtendedTestSet "Derived Transpose" begin
    A = rand(5, 3) + im * rand(5, 3)

    opA = LinearOperator{eltype(A)}(
      size(A, 1),
      size(A, 2),
      false,
      false,
      (y, x) -> mul!(y, A, x),
      nothing,
      (x, y) -> mul!(x, adjoint(A), y),
    )

    aopA = AdjointLinearOperator(opA)
    copA = ConjugateLinearOperator(opA)
    topA = TransposeLinearOperator(opA)

    for (foo, fop) in [(adjoint, aopA), (conj, copA), (transpose, topA)]
      @test foo(opA) === fop
      @test Matrix(fop) == foo(A)
      @test foo(fop) === opA

      @test Matrix(-fop) == foo(-A)
      @test Matrix((2 + 3im) * fop) ≈ (2 + 3im) * foo(A)
      @test Matrix(fop * (2 + 3im)) ≈ foo(A) * (2 + 3im)
    end

    @test adjoint(topA) === copA
    @test adjoint(copA) === topA
    @test conj(aopA) === topA
    @test conj(topA) === aopA
    @test transpose(copA) === aopA
    @test transpose(aopA) === copA

    v = rand(5) + im * rand(5)
    @test aopA * v == adjoint(A) * v
    @test topA * v == transpose(A) * v
    v = rand(5)
    @test aopA * v ≈ adjoint(A) * v
    @test topA * v ≈ transpose(A) * v

    v = rand(3) + im * rand(3)
    @test copA * v ≈ conj(A) * v
    v = rand(3)
    @test copA * v ≈ conj(A) * v
  end
end

test_derived_transpose()

# Constructors.
"""
    LinearOperator(M::AbstractMatrix{T}; symmetric=defaultsymmetric(M), hermitian=defaulthermitian(M), S = Vector{T}) where {T}
Construct a linear operator from a dense or sparse matrix. Use the optional
keyword arguments to indicate whether the operator is symmetric and/or
hermitian. Change `S` to use LinearOperators on GPU.

!!! tip
    In performance-sensitive applications, it may be advisable to use

        LinearOperator{T, S}(M; kwargs...)

    instead.
"""
function LinearOperator(M::AbstractMatrix{T}; S = storage_type(M), kwargs...) where {T}
  return LinearOperator{T, S}(M; kwargs...)
end

function LinearOperator{T, S}(
  M::AbstractMatrix{T};
  symmetric = defaultsymmetric(M),
  hermitian = defaulthermitian(M),
) where {T, S}
  nrow, ncol = size(M)
  prod! = @closure (res, v, α, β) -> mul!(res, M, v, α, β)
  tprod! = @closure (res, u, α, β) -> mul!(res, transpose(M), u, α, β)
  ctprod! = @closure (res, w, α, β) -> mul!(res, adjoint(M), w, α, β)
  LinearOperator{T, S}(nrow, ncol, symmetric, hermitian, prod!, tprod!, ctprod!)
end

defaultsymmetric(M) = false
defaulthermitian(M) = false
defaultsymmetric(M::Symmetric) = true
defaulthermitian(M::Symmetric{<:Real}) = true
defaultsymmetric(M::Hermitian) = eltype(M) <: Real
defaulthermitian(M::Hermitian) = true
defaultsymmetric(M::SymTridiagonal) = true
defaulthermitian(M::SymTridiagonal{<:Real}) = true

"""
    LinearOperator(type::Type{T}, nrow, ncol, symmetric, hermitian, prod!,
                    [tprod!=nothing, ctprod!=nothing],
                    S = Vector{T}) where {T}

Construct a linear operator from functions where the type is specified as the first argument.
Change `S` to use LinearOperators on GPU.
Notice that the linear operator does not enforce the type, so using a wrong type can
result in errors. For instance,
```
A = [im 1.0; 0.0 1.0] # Complex matrix
function mulOp!(res, M, v, α, β)
  mul!(res, M, v, α, β)
end
op = LinearOperator(Float64, 2, 2, false, false,
                    (res, v, α, β) -> mulOp!(res, A, v, α, β),
                    (res, u, α, β) -> mulOp!(res, transpose(A), u, α, β),
                    (res, w, α, β) -> mulOp!(res, A', w, α, β))
Matrix(op) # InexactError
```
The error is caused because `Matrix(op)` tries to create a Float64 matrix with the
contents of the complex matrix `A`.

Using `*` may generate a vector that contains `NaN` values.
This can also happen if you use the 3-args `mul!` function with a preallocated vector such as
`Vector{Float64}(undef, n)`.
To fix this issue you will have to deal with the cases `β == 0` and `β != 0` separately:
```
d1 = [2.0; 3.0]
function mulSquareOpDiagonal!(res, d, v, α, β::T) where T
  if β == zero(T)
    res .= α .* d .* v
  else
    res .= α .* d .* v .+ β .* res
  end
end
op = LinearOperator(Float64, 2, 2, true, true,
                    (res, v, α, β) -> mulSquareOpDiagonal!(res, d, v, α, β))
```

It is possible to create an operator with the 3-args `mul!`.
In this case, using the 5-args `mul!` will generate storage vectors.

```
A = rand(2, 2)
op = LinearOperator(Float64, 2, 2, false, false,
                    (res, v) -> mul!(res, A, v),
                    (res, w) -> mul!(res, A', w))
```

The 3-args `mul!` also works when applying the operator on a matrix.

!!! tip
    In performance-sensitive applications, it may be advisable to use

        LinearOperator{T, S}(nrow, ncol, symmetric, hermitian, prod!, tprod! = nothing, ctprod! = nothing)

    instead.
"""
function LinearOperator(
  ::Type{T},
  nrow::I,
  ncol::I,
  symmetric::Bool,
  hermitian::Bool,
  prod!,
  tprod! = nothing,
  ctprod! = nothing;
  S::Type = Vector{T},
) where {T, I <: Integer}
  return LinearOperator{T, S}(nrow, ncol, symmetric, hermitian, prod!, tprod!, ctprod!)
end

# A Julia Linear Operator Package

Operators behave like matrices (with [exceptions](@ref differences)) but are defined
by their effect when applied to a vector.
They can be transposed, conjugated, or combined with other operators cheaply.
The costly operation is deferred until multiplied with a vector.

## Compatibility

Julia 1.6 and up.

## How to Install

```julia
pkg> add LinearOperators
pkg> test LinearOperators
```

## Operators Available

Operator                     | Description
-----------------------------|------------
`LinearOperator`             | Base class. Useful to define operators from functions
`TimedLinearOperator`        | Linear operator instrumented with timers from [`TimerOutputs`](https://github.com/KristofferC/TimerOutputs.jl)
`BlockDiagonalOperator`      | Block-diagonal linear operator
`opEye`                      | Identity operator
`opOnes`                     | All ones operator
`opZeros`                    | All zeros operator
`opDiagonal`                 | Square (equivalent to `diagm()`) or rectangular diagonal operator
`opInverse`                  | Equivalent to `\`
`opCholesky`                 | More efficient than `opInverse` for symmetric positive definite matrices
`opLDL`                      | Similar to `opCholesky`, for general sparse symmetric matrices
`opHouseholder`              | Apply a Householder transformation `I-2hh'`
`opHermitian`                | Represent a symmetric/hermitian operator based on the diagonal and strict lower triangle
`opRestriction`              | Represent a selection of "rows" when composed on the left with an existing operator
`opExtension`                | Represent a selection of "columns" when composed on the right with an existing operator
`LBFGSOperator`              | Limited-memory BFGS approximation in operator form (damped or not)
`InverseLBFGSOperator`       | Inverse of a limited-memory BFGS approximation in operator form (damped or not)
`LSR1Operator`               | Limited-memory SR1 approximation in operator form
`kron`                       | Kronecker tensor product in linear operator form

## Utility Functions

Function           | Description
-------------------|------------
`check_ctranspose` | Cheap check that `A'` is correctly implemented
`check_hermitian`  | Cheap check that `A = A'`
`check_positive_definite` | Cheap check that an operator is positive (semi-)definite
`diag`             | Extract the diagonal of an operator
`Matrix`           | Convert an abstract operator to a dense array
`hermitian`        | Determine whether the operator is Hermitian
`push!`            | For L-BFGS or L-SR1 operators, push a new pair {s,y}
`reset!`           | For L-BFGS or L-SR1 operators, reset the data
`show`             | Display basic information about an operator
`size`             | Return the size of a linear operator
`symmetric`        | Determine whether the operator is symmetric
`normest`          | Estimate the 2-norm


## Other Operations on Operators

Operators can be transposed (`A.'`), conjugated (`conj(A)`) and conjugate-transposed (`A'`).
Operators can be sliced (`A[:,3]`, `A[2:4,1:5]`, `A[1,1]`), but unlike matrices, slices always return
operators (see [differences](@ref differences)).

## [Differences](@id differences)

Unlike matrices, an operator never reduces to a vector or a number.

```@example exdiff
using LinearOperators
A = rand(5,5)
opA = LinearOperator(A)
A[:,1] * 3 isa Vector
```
```@example exdiff
opA[:,1] * 3 isa LinearOperator
```
```@example exdiff
opA[:,1] * [3] isa Vector
```
However, the following returns an error
```julia
A[:,1] * [3]
```
This is also true for `A[i,:]`, which would return a vector and for the scalar
`A[i,j]`.
Similarly, `opA[1,1]` is an operator of size (1,1):"
```@example exdiff
(opA[1,1] * [3])[1] - A[1,1] * 3
```

In the same spirit, the operator `Matrix` always returns a matrix.
```@example exdiff
Matrix(opA[:,1])
```

## Other Operators

* [LLDL](https://github.com/optimizers/lldl) features a limited-memory
  LDLᵀ factorization operator that may be used as preconditioner
  in iterative methods
* [MUMPS.jl](https://github.com/JuliaSmoothOptimizers/MUMPS.jl) features a full
  distributed-memory factorization operator that may be used to represent the
  preconditioner in, e.g., constraint-preconditioned Krylov methods.

## Testing

```julia
julia> Pkg.test("LinearOperators")
```

## Bug reports and discussions

If you think you found a bug, feel free to open an [issue](https://github.com/JuliaSmoothOptimizers/LinearOperators.jl/issues).
Focused suggestions and requests can also be opened as issues. Before opening a pull request, start an issue or a discussion on the topic, please.

If you want to ask a question not suited for a bug report, feel free to start a discussion [here](https://github.com/JuliaSmoothOptimizers/Organization/discussions). This forum is for general discussion about this repository and the [JuliaSmoothOptimizers](https://github.com/JuliaSmoothOptimizers) organization, so questions about any of our packages are welcome.
